<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display a news
	' IN  : iID (int) : news' id (table news, field nID)
	' OUT : -
	Sub DisplayAdminNews(iID)
		Dim oCn, oRs, oRs2, rSQL, sURL, tURL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT nID, nTitle, nAuthor, nDate, nHeader, nText, nImage, nURL, nRead, cTitle, vCode FROM news, categories, versions WHERE nCategory=cID AND nVersion=vID AND nID=" & iID

		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then
			Response.Write "	  <a name=""news_" & oRs("nID") & """></a>" & vbCRLF
			CreateTopTable "news_" & oRs("nID"), CodeMessage(oRs("nTitle"), False)
			Response.Write "<span class=""small"">" & Replace(Replace(GetTranslation("LANG_POST_DATE_BY"), "%1%", GetDateLitteralDDMMYYYYHHMMSS(StringToDate(oRs("nDate")))), "%2%", "<a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_PROFILE_PAGE & "?id=" & Server.URLEncode(oRs("nAuthor")) & """>" & Server.HTMLEncode(oRs("nAuthor")) & "</a>")
			Response.Write " " & Server.HTMLEncode(oRs("vCode")) & " - " & Server.HTMLEncode(oRs("cTitle"))
			If oRs("nURL") <> "" Then
				sURL = Replace(LCase(oRs("nURL")), "http://", "")
				rSQL = "SELECT uTitle FROM urls WHERE uURL LIKE '%" & SQLEncrypt(sURL) & "%'"
				Set oRs2 = DBRecordSet(oCn, rSQL)
				Response.Write "<br>" & GetTranslation("LANG_SOURCE") & " : <a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_GOTOURL_PAGE & "?url=http://" & Server.URLEncode(sURL) & """ target=_blank>"
				If Not oRs2.EOF Then
					Response.Write Server.HTMLEncode(oRs2("uTitle"))
				Else
					tURL = Split(sURL, "/")
					Response.Write Server.HTMLEncode(tURL(0))
				End If
				Response.Write "</a>" & vbCRLF
			End If
			Response.Write "</span><br><br>" & vbCRLF

			If oRs("nImage") <> "" Then 
				Response.Write "<img src="""
				If Left(LCase(oRs("nImage")), 7) <> "http://" Then Response.Write GLOBAL_SITE_IMAGES_NEWS_PATH 
				Response.Write oRs("nImage") & """ align=""left"" border=""0"">" & vbCRLF
			End If

			Response.Write CodeMessage(oRs("nHeader"), False) & vbCRLF
			Response.Write "<br><br>" & vbCRLF
			Response.Write CodeMessage(oRs("nText"), False) & vbCRLF
			rSQL = "SELECT Count(cID) FROM Comments WHERE cItem=" & iID & " AND cType=" & CATEGORY_TYPE_NEWS & " AND cValid=True"
			Set oRs2 = DBRecordSet(oCn, rSQL)
			CreateBottomTable GetTranslation("LANG_COMMENTS") & " : " & oRs2(0) & " | " & GetTranslation("LANG_READ") & " : " & oRs("nRead") & vbCRLF
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing		
	End Sub

	' Display the navigation bar for news (previous and next day)
	' IN  : dDate (datetime) : actual date
	' OUT : -
	Sub DisplayNewsNavigation(dDate)
		Dim oCn, oRs, rSQL, jPrec, jSuiv, X

		Set oCn = DBConnexion(DB_MAIN)
		
		rSQL = "SELECT TOP 1 nDate FROM news WHERE (nDate < '" & DateToString(dDate) & "') AND (nValid=True) ORDER BY nDate DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then jPrec = Left(oRs(0), 8)

		rSQL = "SELECT TOP 1 nDate FROM news WHERE nDate > '" & DateToString(DateAdd("d", 1, dDate)) & "' AND nValid=True ORDER BY nDate"
		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then jSuiv = Left(oRs(0), 8)
		
		If jPrec <> "" or jSuiv <> "" Then
			CreateTopTable "NewsNavigate", GetTranslation("LANG_OLD_NEWS")
			Response.Write "<table width=""100%"" cellspacing=""0"" cellpadding=""5"" border=""0"" align=""center"">" & vbCRLF
			Response.Write "  <tr>" & vbCRLF
			Response.Write "    <td width=""35%"" class=""small"">" & vbCRLF
			If jPrec <> "" Then Response.Write "      &lt;&lt; <a href=""" & GLOBAL_SITE_NEWS_PAGE & "?date=" & jPrec & """>" & GetTranslation("LANG_LAST_DAY") & "</a><br>" & GetDateLitteralDDMMYYYY(StringToDate(jPrec)) & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "    <td width=""30%"" class=""small"" align=""center"" valign=""bottom"">" & GetDateLitteralDDMMYYYY(dDate) & "</td>" & vbCRLF
			Response.Write "    <td width=""35%"" class=""small"" align=""right"">" & vbCRLF
			If jSuiv <> "" Then Response.Write "      <a href=""" & GLOBAL_SITE_NEWS_PAGE & "?date=" & jSuiv & """>" & GetTranslation("LANG_NEXT_DAY") & "</a> &gt;&gt;<br>" & GetDateLitteralDDMMYYYY(StringToDate(jSuiv)) & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Generate news backend - create a file display_news.js into the scripts directory with javascript inside
	' IN  : iTop (int) : number of results wanted
	' OUT : -
	Sub GenerateBackEndNews(iTop)
		Dim oCn, oRs, rSQL, oFs, oJsFile, oFile

		Set oCn = DBConnexion(DB_MAIN)
			
		rSQL = "SELECT TOP " & iTop & " nID, nTitle, nDate FROM news WHERE (nDate < '" & DateTimeToString(Now) & "') AND (nValid = True) ORDER BY nDate DESC"
			
		Set oRs = DBRecordSet(oCn, rSQL)
		
		On Error Resume Next
		Set oFs = Server.CreateObject("Scripting.FileSystemObject")
		If Err.number <> 0 Then
			Err.Clear
		Else
			Set oFile = oFs.OpenTextFile(Server.MapPath(GLOBAL_SITE_BACKEND), 2, true)
			If Not oRs.EOF Then
				While Not oRs.EOF
					oFile.WriteLine "document.write('<a href=""" & GLOBAL_SITE_URL & "/news.asp?id=" & oRs("nID") & """ target=""_blank"">" & JsEncrypt(CodeMessage(oRs("nTitle"), False)) & "</a>&nbsp;<font size=""1"">" & GetDateLitteralDDMMYYYY(StringToDate(oRs("nDate"))) & "</font><br>');" & vbCRLF
					oRs.MoveNext
				WEnd
			End If
			oFile.Close
			Set oFs = Nothing
		End If
		On Error Goto 0

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display the top last news
	' IN  : iTop (int) : number of results wanted
	'     : sSortedField (string) : field sorted
	'     : bAscSort (boolean) : if true = ASC sort, else DESC
	' OUT : -
	Sub DisplayTopNewsAdmin(iTop, sSortedField, bAscSort)
		Dim oCn, oRs, rSQL, iLine
		Dim titreNews, texteNews, dateNews, sSortDesc

		Select Case LCase(sSortedField)
			Case "ntitle" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_TITLE")
			Case "nauthor" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_AUTHOR")
			Case "ndate" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_DATE")
			Case Else :
				' default value
				sSortedField = "nDate"
				bAscSort = False
				sSortDesc = GetTranslation("LANG_DATE")
		End Select

		rSQL = "SELECT TOP " & iTop & " nID, nTitle, nDate, nAuthor FROM news ORDER BY " & sSortedField

		If Not bAscSort Then 
			rSQL = rSQL & " DESC"
			sSortDesc = sSortDesc & " (DESC)"
		Else
			sSortDesc = sSortDesc & " (ASC)"
		End If

		Set oCn = DBConnexion(DB_MAIN)

		Set oRs = DBRecordSet(oCn, rSQL)

		CreateTopTable "AdminNews", GetTranslation("LANG_TOP") & " " & iTop & " - " & GetTranslation("LANG_NEWS") & "&nbsp;|&nbsp;<span class=""small"">" & Replace(GetTranslation("LANG_SORT_BY"), "%1%", sSortDesc)  & "</span>"
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>"
		SortMenu GetTranslation("LANG_TITLE"), "nTitle", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""120"" align=""center"">"
		SortMenu GetTranslation("LANG_DATE"), "nDate", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">"
		SortMenu GetTranslation("LANG_AUTHOR"), "nAuthor", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
			
		iLine = 1
		While Not oRs.EOF
			Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
			Response.Write "    <td>" & CodeMessage(oRs("nTitle"), False) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & StringToDate(oRs("nDate")) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("nAuthor")) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & vbCRLF
			MenuAdmin(oRs("nID"))
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
				
			iLine = 1 + ((iLine-1) XOR 1)
			oRs.MoveNext
		WEnd
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""4""><a href=""" & sURLPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_NEWS") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display the preview page
	' IN  : sTitle (string) : news' title
	'     : dDate (datetime) : news' post date
	'     : sAuthor (string) : news' author
	'     : sHeader (string) : news' header
	'     : sText (string) : news' content
	'     : sImage (string) : news' picture (displayed if not null)
	'     : sURL (string) : news' source (display if not null)
	' OUT : -
	Sub DisplayPreviewNews(sTitle, dDate, sAuthor, sHeader, sText, sImage, sURL)
		Dim tURL

		CreateTopTable "PreviewNews", CodeMessage(sTitle, False)
		Response.Write "<span class=""small"">" & Replace(Replace(GetTranslation("LANG_POST_DATE_BY"), "%1%", GetDateLitteralDDMMYYYYHHMMSS(StringToDate(dDate))), "%2%", "<a href=""mailto:" & sAuthor & """>" & Server.HTMLEncode(sAuthor) & "</a>")
		If sURL <> "" Then
			sURL = Replace(LCase(sURL), "http://", "")
			tURL = Split(sURL, "/")
			Response.Write "<br>" & GetTranslation("LANG_SOURCE") & " : <a href=""" & GLOBAL_SITE_GOTOURL_PAGE & "?url=http://" & Server.URLEncode(sURL) & """ target=_blank>" & Server.HTMLEncode(tURL(0)) & "</a>" & vbCRLF
		End If
		Response.Write "</span><br><br>" & vbCRLF

		If sImage <> "" Then Response.Write "<img src=""" & Server.HTMLEncode(sImage) & """ align=""left"" border=""0"">" & vbCRLF
		Response.Write CodeMessage(sHeader, False) & vbCRLF
		If sHeader <> "" Then Response.Write "<br><br>" & vbCRLF
		Response.Write CodeMessage(sText, False) & vbCRLF
		CreateBottomTable "<input type=""button"" class=""button"" onClick=""javascript:history.back()"" value=""" & GetTranslation("LANG_BACK") & """>"
	End Sub
	
	' Display old news by date
	' IN  : dDate (datetime) : news' posting date
	' OUT : -
	Sub DisplayAdminOldNews(dDate)
		Dim oCn, oRs, rSQL, iLine

		Set oCn = Server.CreateObject("ADODB.Connection")
		Set oRs = Server.CreateObject("ADODB.RecordSet")
		
		Set oCn = DBConnexion(DB_MAIN)
			
		rSQL = "SELECT * FROM news WHERE Left(nDate,8) = " & Left(DateToString(dDate), 8) & " ORDER BY nDate DESC"
		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Then
			CreateTopTable "News", GetTranslation("LANG_NEWS") & " - " & dDate
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td width=""120"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
			Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			
			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & CodeMessage(oRs("nTitle"), False) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & StringToDate(oRs("nDate")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("nAuthor")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">"
				MenuAdmin(oRs("nID"))
				Response.Write "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = 1 + ((iLine-1) XOR 1)
				oRs.MoveNext
			WEnd
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Edit news for add or update
	' IN  : iID (int) : news' id (table news, field nID) if 0 or null then added
	' OUT : -
	Sub EditNews(iID)
		Dim oCn, oRs, rSQL, X
		Dim sDo, sEditTitle, sTitle, sAuthor, dDate, sHeader, sText, sImage, sURL, iCategory, iVersion, bValid

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sDo = "updt"
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_NEWS")
			rSQL = "SELECT nTitle, nAuthor, nDate, nHeader, nText, nImage, nURL, nValid, nCategory, nVersion FROM news WHERE nID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sTitle = oRs("nTitle")
				sAuthor = oRs("nAuthor")
				dDate = StringToDate(oRs("nDate"))
				sHeader = oRs("nHeader")
				sText = oRs("nText")
				sImage = oRs("nImage")
				sURL = oRs("nURL")
				iCategory = oRs("nCategory")
				iVersion = oRs("nVersion")
				bValid = oRs.Fields("nValid").Value
			End If
		Else
			sDo = "add"
			sEditTitle = GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_NEWS")
			dDate = Now()
			sAuthor = sPseudo
		End If

		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "    var ok;" & vbCRLF
		Response.Write "    ok = true;" & vbCRLF
		Response.Write "    if (document.edition.nValid.checked)" & vbCRLF
		Response.Write "    {" & vbCRLF
		Response.Write "      if (!confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "')) ok = false;" & vbCRLF
		Response.Write "    }" & vbCRLF
		Response.Write "    if ((document.edition.nTitle.value == '') || (document.edition.nText.value == ''))" & vbCRLF
		Response.Write "    {" & vbCRLF
		Response.Write "      ok = false;" & vbCRLF
		Response.Write "      alert('" & GetTranslation("LANG_MUST_FILL") & "');" & vbCRLF
		Response.Write "    }" & vbCRLF
		Response.Write "    if (ok)" & vbCRLF
		Response.Write "    {" & vbCRLF
		Response.Write "      document.edition.Do.value = '" & sDo & "';" & vbCRLF
		Response.Write "      document.edition.submit();" & vbCRLF
		Response.Write "    }" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "  function openPicture()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "	var sMyPicture = document.edition.nImage.value;" & vbCRLF
		Response.Write "    if (sMyPicture != '')"
		Response.Write "	{" & vbCRLF
		Response.Write "		window.open('" & GLOBAL_SITE_PATH & GLOBAL_SITE_VIEW_IMAGE_PAGE & "?img=' + sMyPicture, 'Picture', 'width=500,height=100,menubar=no,resizable=yes');" & vbCRLF
		Response.Write "	}" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "  function preview()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "    document.edition.Do.value = 'preview';" & vbCRLF
		Response.Write "    document.edition.submit();" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		CreateTopTable "EditionNews", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""nID"" value=""" & iID & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td width=""150"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""nTitle"" value=""" & Server.HTMLEncode(sTitle) & """ maxlength=""100"" size=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
		Response.Write "    <td><input type=""hidden"" name=""nAuthor"" value=""" & Server.HTMLEncode(sAuthor) & """>" & Server.HTMLEncode(sAuthor) & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
		Response.Write "    <td>Le " & vbCRLF
		Response.Write "      <select name=""nJour"" class=""cell"">" & vbCRLF
		For X = 1 to 31
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Day(dDate) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      <select name=""nMois"" class=""cell"">" & vbCRLF
		For X = 1 to 12
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Month(dDate) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      <select name=""nAnnee"" class=""cell"">" & vbCRLF
		For X = Year(DateAdd("yyyy", -2, dDate)) to Year(DateAdd("yyyy", 2, Date))
			Response.Write "      <option value=""" & X & """"
			If X = Year(dDate) Then Response.Write " selected"
			Response.Write ">" & CStr(X) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "       " & vbCRLF
		Response.Write "      <select name=""nHeure"" class=""cell"">" & vbCRLF
		For X = 0 to 23
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Hour(dDate) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      h " & vbCRLF
		Response.Write "      <select name=""nMinute"" class=""cell"">" & vbCRLF
		For X = 0 to 59
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Minute(dDate) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      mn" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_EDIT_MENU") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		DisplayEditBar "document.edition.nHeader", 0
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td valign=""top"">" & GetTranslation("LANG_HEADER") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""nHeader"" cols=""50"" rows=""8"" class=""cell"">" & Server.HTMLEncode(HTML2Text(sHeader)) & "</textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_EDIT_MENU") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		DisplayEditBar "document.edition.nText", 1
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td valign=""top"">" & GetTranslation("LANG_CONTENT") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""nText"" cols=""50"" rows=""10"" class=""cell"">" & Server.HTMLEncode(HTML2Text(sText)) & "</textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_URL") & " - " & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <input name=""nImage"" class=""cell"" maxlength=""200"" size=""50"" value=""" & Server.HTMLEncode(sImage) & """>" & vbCRLF
		Response.Write "      <a href=""javascript:openPicture()""><img src=""" & GLOBAL_SITE_IMAGES_PATH & "view.gif"" border=""0""></a>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_URL") & " - " & GetTranslation("LANG_SOURCE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""nURL"" value=""" & Server.HTMLEncode(sURL) & """ maxlength=""250"" size=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		
		rSQL = "SELECT cID, cTitle FROM categories WHERE cType=" & CATEGORY_TYPE_NEWS & " ORDER BY cTitle"
		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Then
			Response.Write "      <select name=""nCategory"" class=""cell"">" & vbCRLF
			While Not oRs.EOF
				Response.Write "        <option value=""" & oRs("cID") & """"
				If oRs("cID") = iCategory Then Response.Write " selected"
				Response.Write ">" & Server.HTMLEncode(oRs("cTitle")) & "</option>" & vbCRLF
				oRs.MoveNext
			WEnd
			Response.Write "      </select>" & vbCRLF
			Response.Write "      " & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_CATEGORY") & " : <input name=""nCategory2"" class=""cell"" size=""20"" maxlength=""50"" value="""">" & vbCRLF
		Else
			Response.Write "      <input name=""nCategory2"" class=""cell"" size=""20"" maxlength=""50"" value=""" & Server.HTMLEncode(GLOBAL_SITE_NAME) & """>" & vbCRLF
		End If

		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""nVersion"" class=""cell"">" & vbCRLF
		
		rSQL = "SELECT vID, vCode FROM versions"
		Set oRs = DBRecordSet(oCn, rSQL)

		While Not oRs.EOF
			Response.Write "        <option value=""" & oRs("vID") & """"
			If oRs("vID") = iVersion Then Response.Write " selected"
			Response.Write ">" & Server.HTMLEncode(oRs("vCode")) & "</option>" & vbCRLF
			oRs.MoveNext
		WEnd


		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
		Response.Write "    <td><input type=""checkbox"" name=""nValid"""
		If bValid Then Response.Write " checked"
		Response.Write "></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>&nbsp;</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <input type=""button"" value="" " & GetTranslation("LANG_PREVIEW") & " "" class=""button"" onClick=""preview();"">" & vbCRLF
		Response.Write "      <input type=""button"" value="" " & GetTranslation("LANG_SUBMIT") & " "" class=""button"" onClick=""confirmDo();"">" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display deleting page
	' IN  : iID (int) : news' id (table news, field nID)
	' OUT : -
	Sub ConfirmDeleteNews(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT * FROM news WHERE nID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delNews()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "ConfirmDel", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""nID"" value=""" & oRs("nID") & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td><td>" & Server.HTMLEncode(oRs("nTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td><td>" & StringToDate(oRs("nDate")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_AUTHOR") & "</td><td>" & Server.HTMLEncode(oRs("nAuthor")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				rSQL = "SELECT Count(*) FROM Comments WHERE cItem=" & iID & " AND cType=" & CATEGORY_TYPE_NEWS
				Set oRs = DBRecordSet(oCn, rSQL)

				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_COMMENTS") & "</td><td>" & oRs(0) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=""button"" onClick=""javascript:delNews();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=""button"" onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add a news' category (insert query)
	' IN  : sTitle (string) : category's title (table categories, field cTitle)
	' OUT : (int) : Category's id (table categories, fields cID)
	Function AddCategoryNews(sTitle)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT TOP 1 cID FROM categories WHERE cParent=0 AND cTitle='" & SQLEncrypt(sTitle) & "' AND cDescription='" & SQLEncrypt(sTitle) & "' AND cType=" & CATEGORY_TYPE_NEWS & " ORDER BY cID DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		If oRs.EOF Then
			rSQL = "INSERT INTO categories (cParent, cTitle, cDescription, cImage, cType) VALUES (0, '" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sTitle) &"', '', " & CATEGORY_TYPE_NEWS & ")"
			DBExecute oCn, rSQL
			rSQL = "SELECT TOP 1 cID FROM categories WHERE cParent=0 AND cTitle='" & SQLEncrypt(sTitle) & "' AND cDescription='" & SQLEncrypt(sTitle) & "' AND cType=" & CATEGORY_TYPE_NEWS & " ORDER BY cID DESC"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				AddCategoryNews = oRs(0)
			Else
				AddCategoryNews = -1
			End If
		Else
			AddCategoryNews = oRs(0)
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function

	' Add a news (insert query)
	' IN  : sTitle (string) : news' title (table news, field nTitle)
	'     : dDate (datetime) : news' posting date (table news, field nDate)
	'     : sAuthor (string) : news' author (table news, field nAuthor)
	'     : sHeader (string) : news' header (table news, field nHeader)
	'     : sText (string) : news' content (table news, field nText)
	'     : sImage (string) : news' image path (table news, field nImage)
	'     : sURL (string) : news' source (table news, field nURL)
	'     : iCategory (int) : news' category (table news, field nCategory)
	'     : iVersion (int) : news' version (table news, field nVersion)
	'     : bValid (boolean) : news' validation (table news, field nValid)
	' OUT : (boolean) : True if added
	Function AddNews(sTitle, dDate, sAuthor, sHeader, sText, sImage, sURL, iCategory, iVersion, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "INSERT INTO news (nTitle, nDate, nAuthor, nHeader, nText, nImage, nURL, nCategory, nVersion, nValid) VALUES ('" & SQLEncrypt(sTitle) & "', '" & dDate &"', '" & SQLEncrypt(sAuthor) & "', '" & SQLEncrypt(sHeader) & "', '" & SQLEncrypt(sText) & "', '" & SQLEncrypt(sImage) & "', '" & SQLEncrypt(sURL) & "', " & iCategory & ", " & iVersion & ", " & bValid & ")"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		AddNews = True
	End Function

	' Modify news (update query)
	' IN  : iID (int) : news' id (table news, field nID)
	'     : sTitle (string) : news' title (table news, field nTitle)
	'     : dDate (datetime) : news' posting date (table news, field nDate)
	'     : sAuthor (string) : news' author (table news, field nAuthor)
	'     : sHeader (string) : news' header (table news, field nHeader)
	'     : sText (string) : news' content (table news, field nText)
	'     : sImage (string) : news' image path (table news, field nImage)
	'     : sURL (string) : news' source (table news, field nURL)
	'     : iCategory (int) : news' category (table news, field nCategory)
	'     : iVersion (int) : news' version (table news, field nVersion)
	'     : bValid (boolean) : news' validation (table news, field nValid)
	' OUT : (boolean) : True if modified
	Function ModifyNews(iID, sTitle, dDate, sAuthor, sHeader, sText, sImage, sURL, iCategory, iVersion, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE news SET nTitle='" & SQLEncrypt(sTitle) & "', nDate='" & dDate & "', nAuthor='" & SQLEncrypt(sAuthor) & "', nHeader='" & SQLEncrypt(sHeader) & "', nText='" & SQLEncrypt(sText) & "', nImage='" & SQLEncrypt(sImage) & "', nURL='" & SQLEncrypt(sURL) & "', nCategory=" & iCategory & ", nVersion=" & iVersion & ", nValid=" & bValid & " WHERE nID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		ModifyNews = True
	End Function

	' Delete news (delete query) and delete comments associated !!!
	' IN  : iID (int) : news' id (table news, field nID)
	' OUT : (boolean) : True if deleted
	Function DeleteNews(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		
		rSQL = "DELETE FROM comments WHERE cItem=" & iID & " AND cType=" & CATEGORY_TYPE_NEWS
		DBExecute oCn, rSQL
		rSQL = "DELETE FROM news WHERE nID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		DeleteNews = True
	End Function

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminNews()
		Dim nDate, nValid, iCategory

		Select Case Request("do") 
			Case "add"  : 
				nDate = Request.Form("nAnnee") & Request.Form("nMois") & Request.Form("nJour") & " " & Request.Form("nHeure") & ":" & Request.Form("nMinute") & ":00"
				If Request.Form("nCategory2") <> "" Then 
					iCategory = AddCategoryNews(Request.Form("nCategory2"))
				Else
					iCategory = Request.Form("nCategory")
				End If
				If Request.Form("nValid") = "on" Then
					nValid = "1"
				Else
					nValid = "0"
				End If
				If AddNews(Request.Form("nTitle"), nDate, Request.Form("nAuthor"), Request.Form("nHeader"), Request.Form("nText"), Request.Form("nImage"), Request.Form("nURL"), iCategory, Request.Form("nVersion"), nValid) Then 
					If bAutoBackEnd Then GenerateBackEndNews(GLOBAL_NEWS_LINKS_TOP) ' Generate a new backend
					sInfoPage = GetTranslation("LANG_NEWS") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_NEWS") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			Case "updt" : 
				nDate = Request.Form("nAnnee") & Request.Form("nMois") & Request.Form("nJour") & " " & Request.Form("nHeure") & ":" & Request.Form("nMinute") & ":00"
				If Request.Form("nCategory2") <> "" Then 
					iCategory = AddCategoryNews(Request.Form("nCategory2"))
				Else
					iCategory = Request.Form("nCategory")
				End If
				If Request.Form("nValid") = "on" Then
					nValid = "1"
				Else
					nValid = "0"
				End If
				If ModifyNews(Request.Form("nID"), Request.Form("nTitle"), nDate, Request.Form("nAuthor"), Request.Form("nHeader"), Request.Form("nText"), Request.Form("nImage"), Request.Form("nURL"), iCategory, Request.Form("nVersion"), nValid) Then 
					If bAutoBackEnd Then GenerateBackEndNews(GLOBAL_NEWS_LINKS_TOP) ' Generate a new backend
					sInfoPage = GetTranslation("LANG_NEWS") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_NEWS") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del"  :
				If DeleteNews(Request.Form("nID")) Then 
					If bAutoBackEnd Then GenerateBackEndNews(GLOBAL_NEWS_LINKS_TOP) ' Generate a new backend
					sInfoPage = GetTranslation("LANG_NEWS") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_NEWS") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub

	' Display page
	' IN  : -
	' OUT : -
	Sub DisplayAdminNewsPage()
		Dim sDate, dDatePage, bAscSorted, sSortedField
		
		bAscSorted = True
		sSortedField = ""
		
		sSortedField = Request.QueryString("sort")
		If sSortedField <> "" Then sSortedField = LCase(sSortedField)
		If Request.QueryString("sortype") = "desc" Then	bAscSorted = False

		dDatePage = Request("date")
		If dDatePage = "" Then 
			dDatePage = Date
		Else
			dDatePage = StringToDate(dDatePage)
		End If

		Select Case Request("do")
			Case "view" : 
				DisplayAdminNews Request("id")
			Case "preview" : 
				sDate = Request.Form("nAnnee") & Request.Form("nMois") & Request.Form("nJour") & " " & Request.Form("nHeure") & ":" & Request.Form("nMinute") & ":00"
				DisplayPreviewNews Request.Form("nTitle"), sDate, Request.Form("nAuthor"), Request.Form("nHeader"), Request.Form("nText"), Request.Form("nImage"), Request.Form("nURL")
			Case "new"  : 
				EditNews 0
			Case "edit" : 
				EditNews Request("id")
			Case "cdel" : 
				ConfirmDeleteNews Request("id")
		End Select

		If Request("do") <> "preview" Then
			DisplayTopNewsAdmin 10, sSortedField, bAscSorted
			DisplayAdminOldNews dDatePage
			DisplayNewsNavigation dDatePage
		End If
	End Sub
%>