<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002 by Gaetan Bouveret                                *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<!-- #include file='../includes/admin/includes-inc.asp' -->
<% 
	Dim iCountColumns, iMyLine, sEmptyBloc, iTemp, tLeftColumnTemp, tRightColumnTemp

	sTitlePage = GetTranslation("LANG_TITLE_BLOCKS_DESIGNER")
	
	Function DisplayLine(sName, sContent, iNum, sBgColor)
		Dim sID
		If sBgColor = "" Then sBgColor = "#C0C0C0"
		sID = sName & "_" & Right("00" & iNum, 2)

		Response.Write "        <tr>" & vbCRLF
		Response.Write "          <td height=""40"" bgcolor=""" & sBgColor & """ id=""" & sID & """ onClick=""javascript:changeBloc(document.getElementById('" & sID & "'))"" align=""center"">" & sContent & "</td>" & vbCRLF
		Response.Write "        </tr>" & vbCRLF
	End Function

	If Request.Form("dummy") <> "" Then
		If Request.Form("myLeftColumn") <> "" or Request.Form("myRightColumn") <> "" Then
			If Request.Form("myLeftColumn") <> "" Then
				tLeftColumnTemp = Split(Request.Form("myLeftColumn"), "")
			Else
				tLeftColumnTemp = ""
			End If
			If Request.Form("myRightColumn") <> "" Then 
				tRightColumnTemp = Split(Request.Form("myRightColumn"), "")
			Else
				tRightColumnTemp = ""
			End If
		Else
			tLeftColumnTemp = GetTableAvailableColumns()
			tRightColumnTemp = ""
		End If

		Application.Lock
		Application("myLeftColumn") = tLeftColumnTemp
		Application("myRightColumn") = tRightColumnTemp
		Application.UnLock
		
		ManageLeftAndRightColumn()
	End If
	
	sEmptyBloc = JSEncrypt(GetTranslation("LANG_EMPTY_BLOCK"))

	tLeftColumnTemp = tLeftColumn
	tRightColumnTemp = tRightColumn	
%>
<!-- #include file='../includes/toppage-inc.asp' -->
<%
	tLeftColumn = Application("myLeftColumn")
	tRightColumn = Application("myRightColumn")

	If IsAuthorized(ROLE_ADMIN) Then %>
	<script language="javascript" type="text/javascript">
		var myID = null;
		var emptyColor = '#C0C0C0'
		var tempColor = '';
		var tempText = '';

		function changeBloc(idCell)
		{
			if (myID != null)
			{
				if (myID != idCell)
				{
					tempColor = idCell.bgColor;
					tempText = idCell.innerText;
					idCell.bgColor = myID.bgColor;
					idCell.innerText = myID.innerText;
					myID.bgColor = tempColor;
					myID.innerText = tempText;
					document.getElementById('selectedBloc').bgColor = emptyColor;
					document.getElementById('selectedBloc').innerHTML = '-';
					myID = null;
				}
				else
				{
					myID = null;
				}
			}
			else
			{
				myID = idCell;
				document.getElementById('selectedBloc').bgColor = idCell.bgColor;
				document.getElementById('selectedBloc').innerHTML = idCell.innerHTML;
			}
		}

		function addToPlacement(myPlacement, addTo)
		{
			if (myPlacement != '')
			{
				if (addTo != '') 
					return(myPlacement + '' + addTo);
				else
					return(myPlacement);
			}
			else return addTo;
		}
	
		function getIDFrom(myTextPlacement)
		{
			switch (myTextPlacement)
			{
				case '<%=JSEncrypt(GetTranslation("LANG_MENU"))%>' : 
					return '0';
					break;
				case '<%=JSEncrypt(GetTranslation("LANG_VISITORS"))%>' : 
					return '1';
					break;
				case '<%=JSEncrypt(GetTranslation("LANG_ACCOUNTS"))%>' : 
					return '2';
					break;
				case '<%=JSEncrypt(GetTranslation("LANG_SEARCH"))%>' : 
					return '3';
					break;
				case '<%=JSEncrypt(GetTranslation("LANG_MY_FAVORITES"))%>' : 
					return '4';
					break;
				case '<%=JSEncrypt(GetTranslation("LANG_TOP") & " " & GetTranslation("LANG_SITES"))%>' :
					return '5';
					break;
				case '<%=JSEncrypt(GetTranslation("LANG_VERSIONS"))%>' :
					return '6';
					break;
				case '<%=JSEncrypt(GetTranslation("LANG_WEBCOUNTERS"))%>' :
					return '7';
					break;
				case '<%=JSEncrypt(GetTranslation("LANG_POLLS"))%>' :
					return '8';
					break;
<%
	For iTemp = 1 To GLOBAL_CUSTOM_BLOCKS
		Response.Write "				case '" & JSEncrypt(GetTranslation("LANG_BLOCK_" & iTemp)) & "' :" & vbCRLF
		Response.Write "					return '" & iTemp + 8 & "';" & vbCRLF
		Response.Write "					break;" & vbCRLF
	Next
%>
				default : 
					return '';
					break;
			}
		}

		function savePlacement()
		{
			var strPlacement = '';

			if (document.getElementById('left_01').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('left_01').innerHTML))
			if (document.getElementById('left_02').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('left_02').innerHTML))
			if (document.getElementById('left_03').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('left_03').innerHTML))
			if (document.getElementById('left_04').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('left_04').innerHTML))
			if (document.getElementById('left_05').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('left_05').innerHTML))
			if (document.getElementById('left_06').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('left_06').innerHTML))
			if (document.getElementById('left_07').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('left_07').innerHTML))
			if (document.getElementById('left_08').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('left_08').innerHTML))
			if (document.getElementById('left_09').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('left_09').innerHTML))
<%
	For iTemp = 1 To GLOBAL_CUSTOM_BLOCKS
		Response.Write "			if (document.getElementById('left_" & Right("00" & (9 + iTemp), 2) & "').innerHTML != '" & sEmptyBloc & "') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('left_" & Right("00" & (9 + iTemp), 2) & "').innerHTML));" & vbCRLF
	Next
%>
			//alert("Left : " + strPlacement);
			document.placement.myLeftColumn.value = strPlacement;

			strPlacement = '';
			if (document.getElementById('right_01').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('right_01').innerHTML))
			if (document.getElementById('right_02').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('right_02').innerHTML))
			if (document.getElementById('right_03').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('right_03').innerHTML))
			if (document.getElementById('right_04').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('right_04').innerHTML))
			if (document.getElementById('right_05').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('right_05').innerHTML))
			if (document.getElementById('right_06').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('right_06').innerHTML))
			if (document.getElementById('right_07').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('right_07').innerHTML))
			if (document.getElementById('right_08').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('right_08').innerHTML))
			if (document.getElementById('right_09').innerHTML != '<%=sEmptyBloc%>') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('right_09').innerHTML))
<%
	For iTemp = 1 To GLOBAL_CUSTOM_BLOCKS
		Response.Write "			if (document.getElementById('right_" & Right("00" & (9 + iTemp), 2) & "').innerHTML != '" & sEmptyBloc & "') strPlacement = addToPlacement(strPlacement, getIDFrom(document.getElementById('right_" & Right("00" & (9 + iTemp), 2) & "').innerHTML));" & vbCRLF
	Next
%>
			//alert("Right : " + strPlacement);
			document.placement.myRightColumn.value = strPlacement;
			document.placement.submit();
		}	

		function clearPlacement()
		{
			document.placement.myLeftColumn.value = '';
			document.placement.myRightColumn.value = '';
			document.placement.submit();
		}
	</script>
<table width="100%" border="0">
  <tr>
    <td width="150" valign="top">
      <table width="100%" border="0" cellspacing="0" cellpadding="5">
      <%
		imyLine = 0
		If IsArray(tLeftColumn) Then
			For iCountColumns = 0 To UBound(tLeftColumn)
				Select Case CInt(tLeftColumn(iCountColumns))
					Case 0 : DisplayLine "left", GetTranslation("LANG_MENU"), iCountColumns+1, "#CC0000"
					Case 1 : DisplayLine "left", GetTranslation("LANG_VISITORS"), iCountColumns+1, "#00CC00"
					Case 2 : DisplayLine "left", GetTranslation("LANG_ACCOUNTS"), iCountColumns+1, "#0066ff"
					Case 3 : DisplayLine "left", GetTranslation("LANG_SEARCH"), iCountColumns+1, "#6699CC"
					Case 4 : DisplayLine "left", GetTranslation("LANG_MY_FAVORITES"), iCountColumns+1, "#CC9933"
					Case 5 : DisplayLine "left", GetTranslation("LANG_TOP") & " " & GetTranslation("LANG_SITES"), iCountColumns+1, "#00FF00"
					Case 6 : DisplayLine "left", GetTranslation("LANG_VERSIONS"), iCountColumns+1, "#FFCC00"
					Case 7 : DisplayLine "left", GetTranslation("LANG_WEBCOUNTERS"), iCountColumns+1, "#996699"
					Case 8 : DisplayLine "left", GetTranslation("LANG_POLLS"), iCountColumns+1, "#FF6633"
					Case Else :
						iTemp = CInt(tLeftColumn(iCountColumns)) - 8
						If iTemp > 0 Then
							DisplayLine "left", GetTranslation("LANG_BLOCK_" & iTemp), iCountColumns+1, "#6699ff"
						End If
				End Select
				iMyLine = iMyLine + 1
			Next
		End If
		For iCountColumns = iMyLine To 8 + GLOBAL_CUSTOM_BLOCKS
			DisplayLine "left", sEmptyBloc, iCountColumns+1, ""
		Next
      %>
      </table>
    </td>
    <td valign="top">
      <table width="100%" border="0">
        <tr>
          <td>
          <%
          CreateTopTable "BlocksDesigner", GetTranslation("LANG_TITLE_BLOCKS_DESIGNER")
          Response.Write GetTranslation("LANG_BLOCKS_DESIGNER_DESCRIPTION")
		  CreateBottomTable ""
		  %>
          </td>
        </tr>
      </table>
    </td>
    <td width="150" valign="top">
      <table width="100%" border="0" cellspacing="0" cellpadding="5">
      <%
		iMyLine = 0
		If IsArray(tRightColumn) Then
			For iCountColumns = 0 To UBound(tRightColumn)
				Select Case CInt(tRightColumn(iCountColumns))
					Case 0 : DisplayLine "right", GetTranslation("LANG_MENU"), iCountColumns+1, "#CC0000"
					Case 1 : DisplayLine "right", GetTranslation("LANG_VISITORS"), iCountColumns+1, "#00CC00"
					Case 2 : DisplayLine "right", GetTranslation("LANG_ACCOUNTS"), iCountColumns+1, "#0066ff"
					Case 3 : DisplayLine "right", GetTranslation("LANG_SEARCH"), iCountColumns+1, "#6699CC"
					Case 4 : DisplayLine "right", GetTranslation("LANG_MY_FAVORITES"), iCountColumns+1, "#CC9933"
					Case 5 : DisplayLine "right", GetTranslation("LANG_TOP") & " " & GetTranslation("LANG_SITES"), iCountColumns+1, "#00FF00"
					Case 6 : DisplayLine "right", GetTranslation("LANG_VERSIONS"), iCountColumns+1, "#FFCC00"
					Case 7 : DisplayLine "right", GetTranslation("LANG_WEBCOUNTERS"), iCountColumns+1, "#996699"
					Case 8 : DisplayLine "right", GetTranslation("LANG_POLLS"), iCountColumns+1, "#FF6633"
					Case Else :
						iTemp = CInt(tRightColumn(iCountColumns)) - 8
						If iTemp > 0 Then
							DisplayLine "right", GetTranslation("LANG_BLOCK_" & iTemp), iCountColumns+1, "#6699ff"
						End If
				End Select
				iMyLine = iMyLine+1
			Next
		End If
		For iCountColumns = iMyLine To 8 + GLOBAL_CUSTOM_BLOCKS
			DisplayLine "right", sEmptyBloc, iCountColumns+1, ""
		Next
      %>      </table>
    </td>
  </tr>
</table>
<br><br>
<table width="100%" height="20" border="0">
  <form method="post" action="<%=sURLPage%>" name="placement">
  <input type="hidden" name="dummy" value="submit">
  <input type="hidden" name="myLeftColumn" value="<%=Server.HTMLEncode(Request.Form("myLeftColum"))%>">
  <input type="hidden" name="myRightColumn" value="<%=Server.HTMLEncode(Request.Form("myLeftColum"))%>">
  <tr>
    <td width="150"><%=GetTranslation("LANG_SELECTED_BLOCK")%> :</td>
    <td id="selectedBloc" bgcolor="#C0C0C0" width="150" align="center">-</td>
    <td align="right"><input type="button" name="btnSave" value="<%=GetTranslation("LANG_SUBMIT")%>" class="button" onClick="javascript:savePlacement()"></td>
  </tr>
  <tr>   
    <td align="right" colspan="3"><input type="button" name="btnClear" value="<%=GetTranslation("LANG_DELETE")%>" class="button" onClick="javascript:clearPlacement()"></td>
  </tr>
  </form>
</table>
<%	Else
		CreateTable "Role", "", GetTranslation("LANG_MUST_HAVE_ROLE"), ""
	End If 
	
	tLeftColumn = tLeftColumnTemp
	tRightColumn = tRightColumnTemp

%>
<!-- #include file='../includes/bottompage-inc.asp' -->
<!-- #include file='../includes/clearitall-inc.asp' -->