<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	Select Case Request.Form("myAction")
		Case "addforum":
			If Request.Form("ForumName") <> "" and Request.Form("ForumDescription") <> "" Then
				AddForum Request.Form("ForumName"), Request.Form("ForumDescription")
				sInfoPage = GetTranslation("LANG_FORUM") & " - " & GetTranslation("LANG_ADD_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_FORUM") & " - " & GetTranslation("LANG_ADD_ERROR")
			End If
		Case "delforum":
			If Request.Form("ForumID") <> "" Then
				DeleteForum Request.Form("ForumID")
				sInfoPage = GetTranslation("LANG_FORUM") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_FORUM") & " - " & GetTranslation("LANG_DELETE_ERROR")
			End If
		Case "addsection":
			If Request.Form("nomSection") <> "" and Request.Form("descriptionSection") <> "" Then
				AddSection Request.Form("nomSection"), Request.Form("descriptionSection"), Request.Form("forumSection")
				sInfoPage = GetTranslation("LANG_SECTION") & " - " & GetTranslation("LANG_ADD_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_SECTION") & " - " & GetTranslation("LANG_ADD_ERROR")
			End If
		Case "delsection":
			If Request.Form("SectionID") <> "" Then
				DeleteSection Request.Form("SectionID")
				sInfoPage = GetTranslation("LANG_SECTION") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_SECTION") & " - " & GetTranslation("LANG_DELETE_ERROR")
			End If
		Case "delpost":
			If Request.Form("PostID") <> "" Then
				DeletePost Request.Form("PostID")
				sInfoPage = GetTranslation("LANG_POST") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_POST") & " - " & GetTranslation("LANG_DELETE_ERROR")
			End If
		Case "validatepost":
			If Request.Form("PostID") <> "" Then
				ValidatePost Request.Form("PostID"), 1
				sInfoPage = GetTranslation("LANG_POST") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_POST") & " - " & GetTranslation("LANG_MODIFY_ERROR")
			End If
		Case "unvalidatepost":
			If Request.Form("PostID") <> "" Then
				ValidatePost Request.Form("PostID"), 0
				sInfoPage = GetTranslation("LANG_POST") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_POST") & " - " & GetTranslation("LANG_MODIFY_ERROR")
			End If
		Case "addmoderator":
			If mySection <> 0 and mySection <> "" Then
				If AddModerator(Request.Form("sModerator"), mySection) Then 
					sInfoPage = GetTranslation("LANG_MODERATOR") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_MODERATOR") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			End If
		Case "delmoderator":
			If mySection <> 0 and mySection <> "" Then
				If DeleteModerator(Request.Form("sModerator"), mySection) Then 
					sInfoPage = GetTranslation("LANG_MODERATOR") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_MODERATOR") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			End If
		Case "addadministrator":
			If myForum <> 0 and myForum <> "" Then
				If AddAdministrator(Request.Form("sAdministrator"), myForum) Then 
					sInfoPage = GetTranslation("LANG_ADMINISTRATOR") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_ADMINISTRATOR") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			End If
		Case "deladministrator":
			If myForum <> 0 and myForum <> "" Then
				If DeleteAdministrator(Request.Form("sAdministrator"), myForum) Then 
					sInfoPage = GetTranslation("LANG_ADMINISTRATOR") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_ADMINISTRATOR") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			End If
	End Select

	Sub DisplayForum(myForum, mySection, myPost, myPage)
		If myForum = "" or myForum = 0 Then 
			Select Case FORUM_TYPE
				Case 1 : Displayforums myPage
				Case 2 : Displayforums2 myPage
				Case Else : Displayforums myPage
			End Select
		ElseIf mySection = "" or mySection = 0 Then 
			DisplaySections myForum, myPage
		ElseIf myPost = "" or myPost = 0 Then 
			DisplayPosts myForum, mySection, myPage
		Else 
			DisplayThreads myForum, mySection, myPost, myPage
		End If
	End Sub

	Sub DisplayForums(myPage)
		Dim oCn, Rs, RsTemp, rSQL, rSQLTemp, iLine
		Dim iForumID, sForumName, sForumDescription
		Dim sVisit, iNbPosts, iNbSubjects, sAdministrators
		
		Set oCn = DBConnexion(DB_FORUM)

		rSQL = "SELECT ForumID, ForumName, ForumDescription FROM Forums"
		Set Rs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "ForumsTitle", GetTranslation("LANG_FORUMS")
		If Not Rs.EOF Then
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			
			If isOwner <> "" and operatorMode <> "" Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delForum(forumID)" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
				Response.Write "    {" & vbCRLF
				Response.Write "      document.suppressionforum.ForumID.value = forumID;" & vbCRLF
				Response.Write "      document.suppressionforum.submit();" & vbCRLF
				Response.Write "    }" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				Response.Write "<form name=""suppressionforum"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
				Response.Write "<input name=""myAction"" type=""hidden"" value=""delforum"">" & vbCRLF
				Response.Write "<input name=""ForumID"" type=""hidden"" value="""">" & vbCRLF
				Response.Write "</form>" & vbCRLF
			End If

			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""30"">&nbsp;</td>" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_FORUM") & "</td>" & vbCRLF
			Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_SUBJECTS") & "</td>" & vbCRLF
			Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_MESSAGES") & "</td>" & vbCRLF
			Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_ADMINISTRATORS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not Rs.EOF
				iForumID = Rs(0)
				sForumName = Rs(1)
				sForumDescription = Rs(2)

				sVisit = ""

				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				rSQLTemp = "SELECT TOP 1 PostDate FROM Posts, Sections WHERE PostSection=SectionID AND SectionForum=" & iForumID
				If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQLTemp = rSQLTemp & " AND PostValid=1"
				rSQLTemp = rSQLTemp & " ORDER BY PostDate DESC"
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)
				If Not RsTemp.EOF Then
					If RsTemp(0) < sLastVisit Then
						sVisit = "old"
					Else
						sVisit = "new"
					End If
				Else
					sVisit = "new"
				End If

				rSQLTemp = "SELECT Count(*) FROM Posts, Sections WHERE PostParent=PostID AND PostSection=SectionID AND SectionForum=" & iForumID
				If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQLTemp = rSQLTemp & " AND PostValid=1"
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)		
				iNbSubjects = RsTemp(0)

				rSQLTemp = "SELECT Count(*) FROM Posts, Sections WHERE PostParent<>PostID AND PostSection=SectionID AND SectionForum=" & iForumID
				If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQLTemp = rSQLTemp & " AND PostValid=1"
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)
				iNbPosts = RsTemp(0)

				sAdministrators = "-"
				rSQLTemp = "SELECT DISTINCT AdministratorID FROM Administrators WHERE AdministratorForum=" & iForumID
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)
				If Not RsTemp.EOF then
					sAdministrators = ""
					While Not RsTemp.EOF
						sAdministrators = sAdministrators & ", " & RsTemp(0)
						RsTemp.MoveNext
					WEnd
					sAdministrators = Mid(sAdministrators, 3)
				End If
				Set RsTemp = Nothing
								
				Response.Write "    <td align=""center""><img src=""" & ImagesPath & sVisit & ".gif"" border=""0""></td>" & vbCRLF
				Response.Write "    <td>&nbsp;<a href=""" & sURLPage & "?forum=" & iForumID & """>" & CodeMessage(sForumName, True) & "</a>"
				If sForumDescription <> "" Then Response.Write "<br>&nbsp;<span class=""small"">" & CodeMessage(sForumDescription, True) & "</span>"

				' Console d'admin
				If isOwner <> "" and operatorMode <> "" Then
					Response.Write "  <div align=""right"" class=""small"">" & vbCRLF
					Response.Write "    <a href=""EditForum.asp?forum=" & iForumID & """>" & GetTranslation("LANG_EDIT") & "</a>&nbsp;" & vbCRLF
					Response.Write "    <a href=""javascript:delForum(" & iForumID & ")"">" & GetTranslation("LANG_DELETE") & "</a>&nbsp;" & vbCRLF
					Response.Write "</div>" & vbCRLF
				End If
				
				Response.Write "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & iNbSubjects & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & iNbPosts & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & Server.HTMLEncode(sAdministrators) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				Rs.MoveNext

				iLine = ((iLine - 1) XOr 1) + 1
			WEnd

			Response.Write "</table>" & vbCRLF
		End If
		CreateBottomTable ""

		If isOwner <> "" and operatorMode <> "" Then
			CreateTopTable "NouveauForum", GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_FORUM")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "<form name=""addnewforum"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
			Response.Write "<input name=""myAction"" type=""hidden"" value=""addforum"">" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_NAME") & "</td>" & vbCRLF
			Response.Write "    <td><input name=""ForumName"" type=""text"" class=""cell"" maxlength=""50"" value=""""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
			Response.Write "    <td><input name=""ForumDescription"" type=""text"" class=""cell"" size=""50"" maxlength=""200"" value=""""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2""><input name=""creer"" type=""button"" class=""button"" value=""" & GetTranslation("LANG_ADD") & """ OnClick=""javascript:document.addnewforum.submit();""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		Response.Write "<div class=""small""><img src=""" & ImagesPath & "new.gif"" border=""0""> " & GetTranslation("LANG_NEW_POSTS") & vbCRLF
		Response.Write "<br><img src=""" & ImagesPath & "old.gif"" border=""0""> " & GetTranslation("LANG_OLD_POSTS") & "</div>" & vbCRLF

		oCn.Close
		Set Rs   = Nothing
		Set oCn = Nothing
	End Sub

	Sub DisplayForums2(myPage)
		Dim oCn, Rs, Rs2, RsTemp, rSQL, rSQLTemp, iLine
		Dim iForumID, sForumName, sForumDescription, iSectionID, sSectionName, sSectionDescription
		Dim sVisit, sLastPostUser, sLastPostDate, iNbPosts, iNbSubjects
		
		Set oCn = DBConnexion(DB_FORUM)

		rSQL = "SELECT ForumID, ForumName, ForumDescription FROM Forums"
		Set Rs = DBRecordSet(oCn, rSQL)
		
		If Not Rs.EOF Then		
			If isOwner <> "" and operatorMode <> "" Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delForum(forumID)" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
				Response.Write "    {" & vbCRLF
				Response.Write "      document.suppressionforum.ForumID.value = forumID;" & vbCRLF
				Response.Write "      document.suppressionforum.submit();" & vbCRLF
				Response.Write "    }" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				Response.Write "<form name=""suppressionforum"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
				Response.Write "<input name=""myAction"" type=""hidden"" value=""delforum"">" & vbCRLF
				Response.Write "<input name=""ForumID"" type=""hidden"" value="""">" & vbCRLF
				Response.Write "</form>" & vbCRLF
			End If

			While Not Rs.EOF
				iForumID = Rs(0)
				sForumName = Rs(1)
				sForumDescription = Rs(2)

				' Console d'admin
				If isOwner <> "" and operatorMode <> "" Then
					CreateTopTable "ForumTitle", "<a href=""" & sURLPage & "?forum=" & iForumID & """>" & CodeMessage(sForumName, True) & "</a> | <a href=""EditForum.asp?forum=" & iForumID & """>" & GetTranslation("LANG_EDIT") & "</a>&nbsp;<a href=""javascript:delForum(" & iForumID & ")"">" & GetTranslation("LANG_DELETE") & "</a>" 
				Else
					CreateTopTable "ForumTitle", "<a href=""" & sURLPage & "?forum=" & iForumID & """>" & CodeMessage(sForumName, True) & "</a>" 
				End If
				If sForumDescription <> "" Then Response.Write "<span class=""small"">" & CodeMessage(sForumDescription, True) & "<br><br></span>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td width=""30"">&nbsp;</td>" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td width=""70"" align=""center"">" & GetTranslation("LANG_SUBJECTS") & "</td>" & vbCRLF
				Response.Write "    <td width=""70"" align=""center"">" & GetTranslation("LANG_MESSAGES") & "</td>" & vbCRLF
				Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_LAST_MESSAGE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
						
				rSQL = "SELECT SectionID, SectionName, SectionDescription FROM Sections WHERE SectionForum=" & iForumID
				Set Rs2 = DBRecordSet(oCn, rSQL)

				iLine = 1
				While Not Rs2.EOF
					iSectionID = Rs2("SectionID")
					sSectionName = Rs2("SectionName")
					sSectionDescription = Rs2("SectionDescription")

					rSQLTemp = "SELECT TOP 1 PostDate, PostUser FROM Posts WHERE PostSection=" & iSectionID 
					If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQLTemp = rSQLTemp & " AND PostValid=1"
					rSQLTemp = rSQLTemp & " ORDER BY PostDate DESC"

					Set RsTemp = DBRecordSet(oCn, rSQLTemp)
					If Not RsTemp.EOF Then
						sLastPostUser = Server.HTMLEncode(RsTemp("PostUser"))
						sLastPostDate = RsTemp("PostDate")
						If sLastPostDate < sLastVisit Then
							sVisit = "old"
						Else
							sVisit = "new"
						End If
					Else
						sVisit = "new"
					End If

					rSQLTemp = "SELECT Count(*) FROM Posts WHERE PostParent=PostID AND PostSection=" & iSectionID
					If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQLTemp = rSQLTemp & " AND PostValid=1"
					Set RsTemp = DBRecordSet(oCn, rSQLTemp)		
					iNbSubjects = RsTemp(0)

					rSQLTemp = "SELECT Count(*) FROM Posts WHERE PostParent<>PostID AND PostSection=" & iSectionID
					If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQLTemp = rSQLTemp & " AND PostValid=1"
					Set RsTemp = DBRecordSet(oCn, rSQLTemp)
					iNbPosts = RsTemp(0)

					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td align=""center""><img src=""" & ImagesPath & sVisit & ".gif"" border=""0""></td>" & vbCRLF
					Response.Write "    <td>&nbsp;<a href=""" & sURLPage & "?forum=" & iForumID & "&section=" & iSectionID & """>" & CodeMessage(sSectionName, True) & "</a>"
					If sSectionDescription <> "" Then Response.Write "<br>&nbsp;<span class=""small"">" & CodeMessage(sSectionDescription, True) & "</span>"
					Response.Write "</td>" & vbCRLF
					Response.Write "    <td align=""center"">" & iNbSubjects & "</td>" & vbCRLF
					Response.Write "    <td align=""center"">" & iNbPosts & "</td>" & vbCRLF
					Response.Write "    <td align=""center"">" 
					If sLastPostUser <> "" Then
						Response.Write "<a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_PROFILE_PAGE & "?id=" & sLastPostUser & """>" & Server.HTMLEncode(sLastPostUser) & "</a><br><span class=""small"">" & GetDateDDMMYYHHMMSS(StringToDate(sLastPostDate)) & "</span></td>" & vbCRLF
					Else
						Response.Write "-"
					End If
					Response.Write "</td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
						
					iLine = ((iLine - 1) XOr 1) + 1
					Rs2.MoveNext
				WEnd
				
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""

				Rs.MoveNext
			WEnd
		End If

		If isOwner <> "" and operatorMode <> "" Then
			CreateTopTable "NouveauForum", GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_FORUM")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "<form name=""addnewforum"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
			Response.Write "<input name=""myAction"" type=""hidden"" value=""addforum"">" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_NAME") & "</td>" & vbCRLF
			Response.Write "    <td><input name=""ForumName"" type=""text"" class=""cell"" maxlength=""50"" value=""""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
			Response.Write "    <td><input name=""ForumDescription"" type=""text"" class=""cell"" size=""50"" maxlength=""200"" value=""""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2""><input name=""creer"" type=""button"" class=""button"" value=""" & GetTranslation("LANG_ADD") & """ OnClick=""javascript:document.addnewforum.submit();""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		Response.Write "<div class=""small""><img src=""" & ImagesPath & "new.gif"" border=""0""> " & GetTranslation("LANG_NEW_POSTS") & vbCRLF
		Response.Write "<br><img src=""" & ImagesPath & "old.gif"" border=""0""> " & GetTranslation("LANG_OLD_POSTS") & "</div>" & vbCRLF

		oCn.Close
		Set Rs = Nothing
		Set Rs2 = Nothing
		Set RsTemp = Nothing
		Set oCn = Nothing
	End Sub

	Sub DisplaySections(myForum, myPage)
		Dim oCn, Rs, RsTemp, rSQL, rSQLTemp, iLine
		Dim iSectionID, sSectionName, sSectionDescription, bSectionModerated, sLevelName, sForumName
		Dim sModerator, sVisit, iNbPosts, iNbSubjects, sModerators, sLastPostUser, sLastPostDate
		
		Set oCn = DBConnexion(DB_FORUM)

		' Recuperation de la date du dernier post de cette section
		rSQL = "SELECT SectionID, SectionName, SectionDescription, SectionModerated, LevelName, ForumName FROM Sections, Levels, Forums WHERE SectionLevel=LevelID AND SectionForum=ForumID AND SectionForum=" & myForum
		Set Rs = DBRecordSet(oCn, rSQL)
	
		If Not Rs.EOF Then		
			CreateTopTable "SectionsTitle", GetTranslation("LANG_SECTIONS")

			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF

			If (isOwner <> "" or isAdministrator <> "") and operatorMode <> "" Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delSection(sectionID)" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
				Response.Write "    {" & vbCRLF
				Response.Write "      document.suppressionsection.sectionID.value = sectionID;" & vbCRLF
				Response.Write "      document.suppressionsection.submit();" & vbCRLF
				Response.Write "    }" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				Response.Write "<form name=""suppressionsection"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
				Response.Write "<input name=""myAction"" type=""hidden"" value=""delsection"">" & vbCRLF
				Response.Write "<input name=""sectionID"" type=""hidden"" value="""">" & vbCRLF
				Response.Write "</form>" & vbCRLF
			End If

			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""30"">&nbsp;</td>" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td width=""70"" align=""center"">" & GetTranslation("LANG_SUBJECTS") & "</td>" & vbCRLF
			Response.Write "    <td width=""70"" align=""center"">" & GetTranslation("LANG_MESSAGES") & "</td>" & vbCRLF
			Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_MODERATORS") & "</td>" & vbCRLF
			Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_LAST_MESSAGE") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not Rs.EOF
				iSectionID = Rs(0)
				sSectionName = Rs(1)
				sSectionDescription = Rs(2)
				bSectionModerated = Rs.Fields(3).Value
				sLevelName = Rs(4)
				sForumName = Rs(5)
				sLastPostUser = ""
				sLastPostDate = ""
				sVisit = ""

				rSQLTemp = "SELECT TOP 1 PostDate, PostUser FROM Posts WHERE PostSection=" & iSectionID 
				If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQLTemp = rSQLTemp & " AND PostValid=1"
				rSQLTemp = rSQLTemp & " ORDER BY PostDate DESC"
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)
				If Not RsTemp.EOF Then
					sLastPostUser = Server.HTMLEncode(RsTemp("PostUser"))
					sLastPostDate = RsTemp("PostDate")
					If sLastPostDate < sLastVisit Then
						sVisit = "old"
					Else
						sVisit = "new"
					End If
				Else
					sVisit = "new"
				End If

				rSQLTemp = "SELECT Count(*) FROM Posts WHERE PostParent=PostID AND PostSection=" & iSectionID
				If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQLTemp = rSQLTemp & " AND PostValid=1"
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)		
				iNbSubjects = RsTemp(0)
				
				rSQLTemp = "SELECT Count(*) FROM Posts WHERE PostParent<>PostID AND PostSection=" & iSectionID
				If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQLTemp = rSQLTemp & " AND PostValid=1"
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)
				iNbPosts = RsTemp(0)

				sModerators = "-"
				rSQLTemp = "SELECT ModeratorID FROM Moderators WHERE ModeratorSection=" & iSectionID
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)
				If Not RsTemp.EOF Then
					sModerators = ""
					While Not RsTemp.EOF
						sModerators = sModerators & ", " & RsTemp(0)
						RsTemp.MoveNext
					WEnd
					sModerators = Mid(sModerators, 3)
				End If

				If bSectionModerated Or sLevelName <> "User" Then
					sSectionDescription = sSectionDescription & "<br>" & GetTranslation("LANG_SECTION") & " : "
					If bSectionModerated Then sSectionDescription = sSectionDescription & "- Moderated&nbsp;"
					If sLevelName <> "User" Then sSectionDescription = sSectionDescription & "- Only Level " & sLevelName
				End If

				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td align=""center""><img src=""" & ImagesPath & sVisit & ".gif"" border=""0""></td>" & vbCRLF
				Response.Write "    <td>&nbsp;<a href=""" & sURLPage & "?" & myForumPath & "&section=" & iSectionID & """>" & CodeMessage(sSectionName, True) & "</a>"
				If sSectionDescription <> "" Then Response.Write "<br>&nbsp;<span class=""small"">" & CodeMessage(sSectionDescription, True) & "</span>"

				If (isOwner <> "" or isAdministrator <> "") and operatorMode <> "" Then
					Response.Write "  <div class=""small"" align=""right"">" & vbCRLF
					Response.Write "<a href=""EditSection.asp?" & myForumPath & "&section=" & iSectionID & """>" & GetTranslation("LANG_EDIT") & "</a>&nbsp;"
					Response.Write "<a href=""javascript:delSection(" & iSectionID & ")"">" & GetTranslation("LANG_DELETE") & "</a>&nbsp;"
					Response.Write "</div>" & vbCRLF
				End If

				Response.Write "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & iNbSubjects & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & iNbPosts & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & Server.HTMLEncode(sModerators) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" 
				If sLastPostUser <> "" Then
					Response.Write "<a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_PROFILE_PAGE & "?id=" & sLastPostUser & """>" & Server.HTMLEncode(sLastPostUser) & "</a><br><span class=""small"">" & GetDateDDMMYYHHMMSS(StringToDate(sLastPostDate)) & "</span></td>" & vbCRLF
				Else
					Response.Write "-"
				End If
				Response.Write "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Rs.MoveNext

				iLine = ((iLine - 1) XOr 1) + 1
			WEnd

			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
		
		If operatorMode <> "" and (isOwner <> "" or isAdministrator <> "") Then
			CreateTopTable "Administration", GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_SECTION")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "<form name=""newsection"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
			Response.Write "<input name=""myAction"" type=""hidden"" value=""addsection"">" & vbCRLF
			Response.Write "<input name=""forumSection"" type=""hidden"" value=""" & myForum & """>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_NAME") & "</td>" & vbCRLF
			Response.Write "    <td><input name=""nomSection"" type=""text"" class=""cell"" maxlength=""50"" value=""""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
			Response.Write "    <td><input name=""descriptionSection"" type=""text"" class=""cell"" size=""50"" maxlength=""200"" value=""""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2""><input name=""creer"" type=""button"" class=""button"" value=""" & GetTranslation("LANG_ADD") & """ OnClick=""javascript:document.newsection.submit();""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""

			CreateTopTable "AddAdministrator", GetTranslation("LANG_ADMINISTRATION") & " - " & GetTranslation("LANG_ADMINISTRATORS")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "<form name=""NewAdministrator"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLf
			Response.Write "<input type=""hidden"" name=""myAction"" value=""addadministrator"">" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & vbCRLF
			Response.Write "      <input name=""sAdministrator"" size=""20"" maxlength=""50"" class=""cell"">" & vbCRLF
			Response.Write "      <input type=""submit"" name=""submit"" value=""" & GetTranslation("LANG_ADD") & """ class=""button"">" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF

			rSQL = "SELECT AdministratorID FROM Administrators WHERE AdministratorForum=" & myForum
			Set Rs = DBRecordSet(oCn, rSQL)
			If Not Rs.EOF Then
				Response.Write "<form name=""DelAdministrator"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLf
				Response.Write "<input type=""hidden"" name=""myAction"" value=""deladministrator"">" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & vbCRLF
				Response.Write "      <select name=""sAdministrator"" class=""cell"">" & vbCRLF
				While Not Rs.EOF
					Response.Write "      <option value=""" & Rs(0) & """>" & Rs(0) & "</option>" & vbCRLF
					Rs.MoveNext
				WEnd
				Response.Write "        </select>" & vbCRLF
				Response.Write "      <input type=""submit"" name=""submit"" value=""" & GetTranslation("LANG_DELETE") & """ class=""button"">" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
			End If

			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		Response.Write "<div class=""small""><img src=""" & ImagesPath & "new.gif"" border=""0""> " & GetTranslation("LANG_NEW_POSTS") & vbCRLF
		Response.Write "<br><img src=""" & ImagesPath & "old.gif"" border=""0""> " & GetTranslation("LANG_OLD_POSTS") & "</div>" & vbCRLF

		oCn.Close
		Set Rs   = Nothing
		Set oCn = Nothing
	End Sub
	
	Sub DisplayPosts(myForum, mySection, myPage)
		Dim oCn, Rs, RsTemp, rSQL, rSQLTemp, iLine
		Dim iPostID, sPostTitle, sPostDate, iPostHits, sPostUser, iPostParent, bPostValid, bPostSticked, sFeelingPath, sLastPostDate, sLastPostUser
		Dim sModerators, iNbPosts, sVisit, sHot, iNbTotalPosts, iNbPages, X
		
		Set oCn = DBConnexion(DB_FORUM)
		Set Rs = Server.CreateObject("ADODB.RecordSet")

		If myPage = "" or myPage = 0 Then 
			myPage = 1
		Else
			myPage = CInt(myPage)
		End If

		rSQL = "SELECT Count(*) FROM Posts WHERE PostID=PostParent AND PostSection=" & mySection
		If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQL = rSQL & " AND PostValid=1"
		Set Rs = DBRecordSet(oCn, rSQL)
		iNbTotalPosts = Rs(0)

		rSQL = "SELECT TOP " & (myPage*FORUM_MAX_POSTS) & " PostID FROM Posts WHERE PostID=PostParent AND PostSection=" & mySection
		If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQL = rSQL & " AND PostValid=1"
		rSQL = rSQL & " ORDER BY PostSticked, PostLastDate DESC"
		Rs.PageSize = FORUM_MAX_POSTS
		Set Rs = DBRecordSet(oCn, rSQL)
		If Rs.RecordCount <> - 1 Then
			Rs.AbsolutePage = myPage
		Else
			For X = 1 To (myPage-1)*FORUM_MAX_POSTS
				Rs.MoveNext
			Next
		End If

		CreateTopTable "PostsTitle", GetTranslation("LANG_SUBJECTS")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		If (isOwner <> "" or isAdministrator <> "" or isModerator <> "") and operatorMode <> "" Then
			Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
			Response.Write "  function delPost(postID)" & vbCRLF
			Response.Write "  {" & vbCRLF
			Response.Write "    if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
			Response.Write "    {" & vbCRLF
			Response.Write "      document.suppressionpost.myAction.value = 'delpost';" & vbCRLF
			Response.Write "      document.suppressionpost.PostID.value = postID;" & vbCRLF
			Response.Write "      document.suppressionpost.submit();" & vbCRLF
			Response.Write "    }" & vbCRLF
			Response.Write "  }" & vbCRLF
			Response.Write "  function validatePost(postID)" & vbCRLF
			Response.Write "  {" & vbCRLF
			Response.Write "    if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
			Response.Write "    {" & vbCRLF
			Response.Write "      document.suppressionpost.myAction.value = 'validatepost';" & vbCRLF
			Response.Write "      document.suppressionpost.PostID.value = postID;" & vbCRLF
			Response.Write "      document.suppressionpost.submit();" & vbCRLF
			Response.Write "    }" & vbCRLF
			Response.Write "  }" & vbCRLF
			Response.Write "  function unvalidatePost(postID)" & vbCRLF
			Response.Write "  {" & vbCRLF
			Response.Write "    if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
			Response.Write "    {" & vbCRLF
			Response.Write "      document.suppressionpost.myAction.value = 'unvalidatepost';" & vbCRLF
			Response.Write "      document.suppressionpost.PostID.value = postID;" & vbCRLF
			Response.Write "      document.suppressionpost.submit();" & vbCRLF
			Response.Write "    }" & vbCRLF
			Response.Write "  }" & vbCRLF
			Response.Write "</script>" & vbCRLF
			Response.Write "<form name=""suppressionpost"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
			Response.Write "<input name=""myAction"" type=""hidden"" value="""">" & vbCRLF
			Response.Write "<input name=""PostID"" type=""hidden"" value="""">" & vbCRLF
			Response.Write "</form>" & vbCRLF
		End If			

		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td width=""30"">&nbsp;</td>" & vbCRLF
		Response.Write "    <td width=""30"">&nbsp;</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_SUBJECT") & "</td>" & vbCRLF
		Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
		Response.Write "    <td width=""70"" align=""center"">" & GetTranslation("LANG_MESSAGES") & "</td>" & vbCRLF
		Response.Write "    <td width=""30"" align=""center"">" & GetTranslation("LANG_READ") & "</td>" & vbCRLF
		Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_LAST_MESSAGE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF

		If Not Rs.EOF Then
			iLine = 1
			While Not Rs.EOF
				iPostID = Rs(0)

				rSQLTemp = "SELECT PostTitle, PostHits, PostUser, PostDate, PostValid, PostSticked, FeelingPath FROM Posts, Feelings WHERE PostID=PostParent AND PostID=" & iPostID & " AND PostFeeling=FeelingID"
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)

				sPostTitle = RsTemp("PostTitle")
				iPostHits = RsTemp("PostHits")
				sPostUser = RsTemp("PostUser")
				sPostDate = RsTemp("PostDate")
				bPostValid = RsTemp("PostValid").Value
				bPostSticked = RsTemp("PostSticked").Value
				sFeelingPath = RsTemp("FeelingPath")

				rSQLTemp = "SELECT TOP 1 PostUser, PostDate FROM Posts WHERE PostParent=" & iPostID & " ORDER BY PostDate DESC"
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)

				sLastPostUser = RsTemp("PostUser")
				sLastPostDate = RsTemp("PostDate")

				sVisit = ""
				sHot = ""
				
				rSQLTemp = "SELECT Count(*) FROM Posts WHERE PostParent=" & iPostID
				Set RsTemp = DBRecordSet(oCn, rSQLTemp)
				iNbPosts = RsTemp(0)
				If iNbPosts > FORUM_IS_HOT Then sHot = "hot"

				If sLastPostDate < sLastVisit Then
					sVisit = "old"
				Else
					sVisit = "new"
				End If

				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td align=""center""><img src=""" & ImagesPath & sVisit & sHot & ".gif"" border=""0""></td>" & vbCRLF
				Response.Write "    <td align=""center""><img src=""" & FeelingsPath & sFeelingPath & """ border=""0""></td>" & vbCRLF
				Response.Write "    <td>&nbsp;"
				If bPostSticked Then Response.Write "<b>" & GetTranslation("LANG_POST_STICKED") & "</b> :&nbsp;"
				Response.Write "<a href=""" & sURLPage & "?" & myForumPath & "&post=" & iPostID & """>" & CodeMessage(sPostTitle, True) & "</a>"
				If iNbPosts > FORUM_MAX_THREADS Then
					Response.Write " <img src=""" & ImagesPath & "page.gif"" hspace=""2"" border=""0"">"
					iNbPages = iNbPosts\FORUM_MAX_THREADS
					If iNbPosts mod FORUM_MAX_THREADS <> 0 Then iNbPages = iNbPages + 1
					For X = 1 To iNbPages
						Response.Write " <a href=""" & sURLPage & "?" & myForumPath & "&post=" & iPostID & "&page=" & X & """>" & X & "</a>"
					Next
				End If

				If Not bPostValid Then Response.Write "      <div class=""small"" align=""right"">-+-</div>" & vbCRLF

				If (isOwner <> "" or isAdministrator <> "" or isModerator <> "") and operatorMode <> "" Then
					Response.Write "      <div class=""small"" align=""right"">"
					If bPostValid Then
						Response.Write "<a href=""javascript:unvalidatePost(" & iPostID & ")"">" & GetTranslation("LANG_UNVALIDATE") & "</a>&nbsp;"
					Else
						Response.Write "<a href=""javascript:validatePost(" & iPostID & ")"">" & GetTranslation("LANG_VALIDATE") & "</a>&nbsp;"
					End If
					If isOwner <> "" or isAdministrator <> "" Then
						Response.Write "<a href=""javascript:delPost(" & iPostID & ")"">" & GetTranslation("LANG_DELETE") & "</a>&nbsp;"
					End If
				End If
				
				Response.Write "</td>" & vbCRLF
				Response.Write "    <td align=""center""><a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_PROFILE_PAGE & "?id=" & sPostUser & """>" & Server.HTMLEncode(sPostUser) & "</a><br><span class=""small"">" & GetDateDDMMYYHHMMSS(StringToDate(sPostDate)) & "</span></td>" & vbCRLF
				Response.Write "    <td align=""center"">" & (iNbPosts-1) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & iPostHits & "</td>" & vbCRLF
				Response.Write "    <td align=""center""><a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_PROFILE_PAGE & "?id=" & sLastPostUser & """>" & Server.HTMLEncode(sLastPostUser) & "</a><br><span class=""small"">" & GetDateDDMMYYHHMMSS(StringToDate(sLastPostDate)) & "</span></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				Rs.MoveNext
				iLine = ((iLine - 1) XOr 1) + 1
			WEnd
	
			iNbPages = iNbTotalPosts\FORUM_MAX_POSTS
			If iNbTotalPosts mod FORUM_MAX_POSTS Then iNbPages = iNbPages + 1
			If iNbPages > 1 Then
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td align=""center"" colspan=""7"">" & vbCRLF
				If myPage <> 1 Then Response.Write "      &nbsp;<a href=""" & sURLPage & "?forum=" & myForum & "&section=" & mySection & "&page=" & myPage-1 & """>&lt;&lt;</a>" & vbCRLF
				For X = 1 To iNbPages
					If X <> CInt(myPage) Then 
						Response.Write "      &nbsp;<a href=""" & sURLPage & "?forum=" & myForum & "&section=" & mySection & "&page=" & X & """>" & X & "</a>" & vbCRLF
					Else
						Response.Write "&nbsp;<b>" & X & "</b>" & vbCRLF
					End If
				Next
				If myPage <> iNbPages Then Response.Write "      &nbsp;<a href=""" & sURLPage & "?forum=" & myForum & "&section=" & mySection & "&page=" & myPage+1 & """>&gt;&gt;</a>" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
			End If
		End If

		If sPseudo <> "" and bIsValid Then
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""7"">" & vbCRLF
			Response.Write "      <input name=""nouveausujet"" type=""button"" class=""button"" value=""" & GetTranslation("LANG_NEW_SUBJECT") & """ OnClick=""javascript:document.location='Post.asp?forum=" & myForum & "&section=" & mySection & "';"">" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
		End If

		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		If (isAdministrator <> "" or isOwner <> "") and operatorMode <> "" Then
			CreateTopTable "AddModerator", GetTranslation("LANG_ADMINISTRATION") & " - " & GetTranslation("LANG_MODERATORS")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "<form name=""NewModerator"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLf
			Response.Write "<input type=""hidden"" name=""myAction"" value=""addmoderator"">" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & vbCRLF
			Response.Write "      <input name=""sModerator"" size=""20"" maxlength=""50"" class=""cell"">" & vbCRLF
			Response.Write "      <input type=""submit"" name=""submit"" value=""" & GetTranslation("LANG_ADD") & """ class=""button"">" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF

			rSQL = "SELECT ModeratorID FROM Moderators WHERE ModeratorSection=" & mySection
			Set Rs = DBRecordSet(oCn, rSQL)
			If Not Rs.EOF Then
				Response.Write "<form name=""DelModerator"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLf
				Response.Write "<input type=""hidden"" name=""myAction"" value=""delmoderator"">" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & vbCRLF
				Response.Write "      <select name=""sModerator"" class=""cell"">" & vbCRLf
				While Not Rs.EOF
					Response.Write "      <option value=""" & Rs(0) & """>" & Rs(0) & "</option>" & vbCRLF
					Rs.MoveNext
				WEnd
				Response.Write "        </select>" & vbCRLF
				Response.Write "      <input type=""submit"" name=""submit"" value=""" & GetTranslation("LANG_DELETE") & """ class=""button"">" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
			End If

			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
		
		Response.Write "<div class=""small""><img src=""" & ImagesPath & "new.gif"" border=""0""> " & GetTranslation("LANG_NEW_POSTS") & ", <img src=""" & ImagesPath & "newhot.gif"" border=""0""> > " & FORUM_IS_HOT & vbCRLF
		Response.Write "<br><img src=""" & ImagesPath & "old.gif"" border=""0""> " & GetTranslation("LANG_OLD_POSTS") & ", <img src=""" & ImagesPath & "oldhot.gif"" border=""0""> > " & FORUM_IS_HOT & "</div>" & vbCRLF

		oCn.Close
		Set Rs   = Nothing
		Set oCn = Nothing
	End Sub

	Sub DisplayThreads(myForum, mySection, myPost, myPage)
		Dim oCn, Rs, oCn2, oRs, RsTemp, rSQL, rSQLTemp, iLine, iNbTotalThreads, iNbPages, X
		Dim iPostID, sPostUser, sPostTitle, sPostDate, sPostMessage, bPostValid, bPostSmileys, bPostSignature
		Dim sFeelingPath, iUserPosts, iUserAvatar, sUserIP, sSignature, sEditDate
		
		Set oCn = DBConnexion(DB_FORUM)
		Set oCn2 = DBConnexion(DB_MAIN)

		rSQL = "UPDATE Posts SET PostHits=PostHits+1 WHERE PostParent=PostID AND PostID=" & myPost
		DBExecute oCn, rSQL

		If myPage = "" or myPage = 0 Then 
			myPage = 1
		Else
			myPage = CInt(myPage)
		End If

		rSQL = "SELECT Count(*) FROM Posts WHERE PostParent=" & myPost
		If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQL = rSQL & " AND PostValid=1"
		Set Rs = DBRecordSet(oCn, rSQL)
		iNbTotalThreads = Rs(0)

		If iNbTotalThreads > 0 Then
			rSQL = "SELECT TOP " & myPage*FORUM_MAX_THREADS & " p1.PostID, p1.PostUser, p1.PostTitle, p1.PostDate, p1.PostMessage, p1.PostValid, p1.PostUserIP, p1.PostEditDate, p1.PostSmileys, p1.PostSignature, FeelingPath, UserPosts, UserAvatar FROM Posts p1, Users, Feelings WHERE p1.PostUser=UserLogin AND FeelingID=PostFeeling AND p1.PostParent=" & myPost
			If isModerator = "" and isAdministrator = "" and isOwner = "" Then rSQL = rSQL & " AND p1.PostValid=1"
			rSQL = rSQL & " ORDER BY p1.PostDate, p1.PostID"
			Rs.PageSize = FORUM_MAX_POSTS
			Set Rs = DBRecordSet(oCn, rSQL)

			If Rs.RecordCount <> - 1 Then
				Rs.AbsolutePage = myPage
			Else
				For X = 1 To (myPage-1)*FORUM_MAX_THREADS
					Rs.MoveNext
				Next
			End If

			CreateTopTable "ThreadsTitle", CodeMessage(Rs("PostTitle"), True)
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF

			If (isOwner <> "" or isAdministrator <> "" or isModerator <> "") and operatorMode = "oui" Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delPost(postID)" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
				Response.Write "    {" & vbCRLF
				Response.Write "      document.actionpost.myAction.value = 'delpost';" & vbCRLF
				Response.Write "      document.actionpost.PostID.value = postID;" & vbCRLF
				Response.Write "      document.actionpost.submit();" & vbCRLF
				Response.Write "    }" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "  function validatePost(postID)" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
				Response.Write "    {" & vbCRLF
				Response.Write "      document.actionpost.myAction.value = 'validatepost';" & vbCRLF
				Response.Write "      document.actionpost.PostID.value = postID;" & vbCRLF
				Response.Write "      document.actionpost.submit();" & vbCRLF
				Response.Write "    }" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "  function unvalidatePost(postID)" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
				Response.Write "    {" & vbCRLF
				Response.Write "      document.actionpost.myAction.value = 'unvalidatepost';" & vbCRLF
				Response.Write "      document.actionpost.PostID.value = postID;" & vbCRLF
				Response.Write "      document.actionpost.submit();" & vbCRLF
				Response.Write "    }" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				Response.Write "<form name=""actionpost"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
				Response.Write "<input name=""myAction"" type=""hidden"" value="""">" & vbCRLF
				Response.Write "<input name=""PostID"" type=""hidden"" value="""">" & vbCRLF
				Response.Write "</form>" & vbCRLF
			End If

			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""30"">&nbsp;</td>" & vbCRLF
			Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_MESSAGE") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			If Not Rs.EOF Then
				iLine = 1
				While Not Rs.EOF
					iPostID = Rs(0)
					sPostUser = Rs(1)
					sPostTitle = Rs(2)
					sPostDate = Rs(3)
					sPostMessage = Rs(4)
					bPostValid = Rs.Fields(5).Value
					sUserIP = Rs(6)
					sEditDate = Rs(7)
					bPostSmileys = Rs(8).Value
					bPostSignature = Rs(9).Value
					sFeelingPath = Rs(10)
					iUserPosts = Rs(11)
					iUserAvatar = Rs(12)
					sSignature = ""

					If bPostSignature Then
						rSQL = "SELECT uSignature FROM users WHERE uLogin='" & SQLEncrypt(sPostUser) & "'"
						Set oRs = DBRecordSet(oCn2, rSQL)
						If Not oRs.EOF Then sSignature = oRs(0)
					End If

					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td align=""center"" valign=""top""><br><a name=""" & iPostID & """></a><img src=""" & FeelingsPath & sFeelingPath & """ border=""0""></td>" & vbCRLF
					Response.Write "    <td align=""center"" valign=""top"">" & Server.HTMLEncode(sPostUser) & "<br>" & vbCRLF
					DisplayRank(sPostUser)
					Response.Write "<br>" & vbCRLF
					DisplayAvatar(iUserAvatar)
					Response.Write "    </td>" & vbCRLF

					Response.Write "    <td valign=""top""><span class=""small"">" & vbCRLF
					Response.Write "      " & Replace(GetTranslation("LANG_POST_DATE"), "%1%", GetDateLitteralDDMMYYYYHHMMSS(StringToDate(sPostDate)))
					Response.Write "      <a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_PROFILE_PAGE & "?id=" & Server.HTMLEncode(sPostUser) & """><img src=""" & ImagesPath & "profile.gif"" border=""0"" hspace=""2"" alt=""" & GetTranslation("LANG_PROFILE") & " - " & Server.HTMLEncode(sPostUSer) & """></a>"
					If isAdministrator <> "" Then Response.Write "&nbsp;" & GetTranslation("LANG_IP") & " : " & sUserIP
					If sEditDate <> "" Then Response.Write "<br>" & Replace(GetTranslation("LANG_POST_EDIT_DATE"), "%1%", GetDateLitteralDDMMYYYYHHMMSS(StringToDate(sEditDate)))
					Response.Write "</span>" & vbCRLF
					Response.Write "      <hr>" & CodeMessageEx(sPostMessage, 0, True, bPostSmileys) & vbCRLF

					If bPostSignature and sSignature <> "" Then
						Response.Write "<font size=""1"">" & FORUM_SIGNATURE_DELIMITER & CodeMessage(sSignature, True) & "</font>" & vbCRLF
					End If


					If (isOwner <> "" or isAdministrator <> "" or isModerator <> "") and operatorMode <> "" Then
						Response.Write "<div align=""right"" class=""small"">" & vbCRLF				
						Response.Write "<a href=""edit.asp?" & MyForumPath & "&post=" & myPost & "&editpost=" & iPostID & """>" & GetTranslation("LANG_EDIT") & "</a>&nbsp;"
						If bPostValid Then
							Response.Write "<a href=""javascript:unvalidatePost(" & iPostID & ")"">" & GetTranslation("LANG_UNVALIDATE") & "</a>&nbsp;"
						Else
							Response.Write "<a href=""javascript:validatePost(" & iPostID & ")"">" & GetTranslation("LANG_VALIDATE") & "</a>&nbsp;"
						End If
						If isOwner <> "" or isAdministrator <> "" Then
							Response.Write "<a href=""javascript:delPost(" & iPostID & ")"">" & GetTranslation("LANG_DELETE") & "</a>&nbsp;"
						End If

						Response.Write "</div>" & vbCRLF
					ElseIf sPostUser = sPseudo Then 
						Response.Write "      <div class=""small"" align=""right""><a href=""edit.asp?" & MyForumPath & "&post=" & myPost & "&editpost=" & iPostID & """>" & GetTranslation("LANG_EDIT") & "</a></div>" & vbCRLF
					End If
					Response.Write "    </td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
					Rs.MoveNext

					iLine = ((iLine - 1) XOr 1) + 1
				WEnd

				iNbPages = iNbTotalThreads\FORUM_MAX_THREADS
				If iNbTotalThreads mod FORUM_MAX_THREADS <> 0 Then iNbPages = iNbPages + 1
				If iNbPages > 1 Then
					Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
					Response.Write "    <td align=""center"" colspan=""3"">" & vbCRLF
					If myPage <> 1 Then Response.Write "      &nbsp;<a href=""" & sURLPage & "?forum=" & myForum & "&section=" & mySection & "&post=" & myPost & "&page=" & myPage-1 & """>&lt;&lt;</a>" & vbCRLF
					For X = 1 To iNbPages
						If X <> CInt(myPage) Then 
							Response.Write "      &nbsp;<a href=""" & sURLPage & "?forum=" & myForum & "&section=" & mySection & "&post=" & myPost & "&page=" & X & """>" & X & "</a>" & vbCRLF
						Else
							Response.Write "&nbsp;<b>" & X & "</b>" & vbCRLF
						End If
					Next
					If myPage <> iNbPages Then Response.Write "      &nbsp;<a href=""" & sURLPage & "?forum=" & myForum & "&section=" & mySection & "&post=" & myPost & "&page=" & myPage+1 & """>&gt;&gt;</a>" & vbCRLF
					Response.Write "    </td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
				End If

			End If

			If sPseudo <> "" and bIsValid Then
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""3"">" & vbCRLF
				Response.Write "      <input name=""nouveausujet"" type=""button"" class=""button"" value=""" & GetTranslation("LANG_NEW_SUBJECT") & """ OnClick=""javascript:document.location='Post.asp?forum=" & myForum & "&section=" & mySection & "';"">" & vbCRLF
				Response.Write "      <input name=""repondre"" type=""button"" class=""button"" value=""" & GetTranslation("LANG_ANSWER_POST") & """ OnClick=""javascript:document.location='Post.asp?forum=" & myForum & "&section=" & mySection & "&post=" & myPost & "';"">" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
			End If

			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		oCn.Close
		oCn2.Close
		Set Rs   = Nothing
		Set oCn = Nothing
		Set oCn2 = Nothing
	End Sub
	
	Sub DisplayRank(sUserLogin)
		Dim oCn, Rs, rSQL, iPosts

		Set oCn = DBConnexion(DB_FORUM)
		rSQL = "SELECT UserPosts FROM Users WHERE UserLogin='" & SQLEncrypt(sUserLogin) & "'"
		Set Rs = DBRecordSet(oCn, rSQL)

		If Not Rs.EOF Then 
			iPosts = Rs(0)
		Else
			iPosts = 0
		End If
		Set Rs = Nothing

		rSQL = "SELECT RankName, RankPicture FROM Ranks WHERE RankValue<=" & iPosts & " ORDER BY RankValue DESC"
		Set Rs = DBRecordSet(oCn, rSQL)
		Response.Write "<span class=""small""><br>" & vbCRLF
		If Not Rs.EOF Then
			If FORUM_RANK_NAME Then
				Response.Write "<img src=""" & ImagesPath & Rs("RankPicture") & """ border=""0"" alt=""" & Server.HTMLEncode(Rs("RankName")) & """><br>" & Server.HTMLEncode(Rs("RankName")) & "<br>" & vbCRLF
			Else
				Response.Write "<img src=""" & ImagesPath & Rs("RankPicture") & """ border=""0"" alt=""""><br>" & vbCRLF
			End If
			'Response.Write Rs(0) & vbCRLF
		End If
		If iPosts > 1 Then 
			Response.Write iPosts & " " & GetTranslation("LANG_POSTS")
		Else
			Response.Write iPosts & " " & GetTranslation("LANG_POST")
		End If
		Response.Write "</span>" & vbCRLF

		Set Rs = Nothing
		oCn.Close
		Set oCn = Nothing
	End Sub

	Sub DisplayAvatar(iAvatarID)
		Dim oCn, oRs, rSQL
		
		If iAvatarID <> 0 and iAvatarID <> "" Then
			Set oCn = DBConnexion(DB_FORUM)
			rSQL = "SELECT AvatarPath FROM Avatars WHERE AvatarID=" & iAvatarID & " AND AvatarValid=1"

			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				Response.Write "<img src="""
				If Left(LCase(oRs("AvatarPath")), 7) <> "http://" Then
					Response.Write GLOBAL_SITE_PATH & FORUM_AVATARS_PATH
				End If
				Response.Write Server.HTMLEncode(oRs("AvatarPath")) & """ border=""0"">" & vbCRLF
			End If

			oCn.Close
			Set oRs = Nothing
			Set oCn = Nothing
		End If
	End Sub
	
	Function AddForum(sTitle, sDescription)
		Dim oCn, rSQL

		AddForum = False

		If sTitle <> "" and sDescription <> "" Then
			Set oCn = DBConnexion(DB_FORUM)
			rSQL = "INSERT INTO Forums (ForumName, ForumDescription) VALUES ('" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sDescription) & "')"
			oCn.Execute rSQL
			AddForum = True
			oCn.Close
			Set oCn = Nothing
		End If
	End Function

	Function DeleteForum(forum)
		Dim oCn, Rs, rSQL

		DeleteForum = False

		If IsNumeric(forum) and forum <> 0 Then
			Set oCn = DBConnexion(DB_FORUM)
			rSQL = "SELECT SectionID From Sections WHERE SectionForum=" & forum
			Set Rs = DBRecordSet(oCn, rSQL)
			While Not Rs.EOF
				rSQL = "DELETE FROM Posts WHERE PostSection=" & Rs("SectionID")
				DBExecute oCn, rSQL
				rSQL = "DELETE FROM Sections WHERE SectionID=" & Rs("SectionID")
				DBExecute oCn, rSQL
				Rs.MoveNext
			WEnd
			oCn.Execute rSQL
			rSQL = "DELETE FROM Forums WHERE ForumID=" & forum
			oCn.Execute rSQL
			DeleteForum = True
			oCn.Close
			Set oCn = Nothing
		End If
	End Function

	Function AddSection(sTitle, sDescription, iForum)
		Dim oCn, rSQL

		AddSection = False

		If sTitle <> "" and sDescription <> "" and IsNumeric(iForum) and iForum <> 0 Then
			Set oCn = DBConnexion(DB_FORUM)
			rSQL = "INSERT INTO Sections (SectionName, SectionForum, SectionDescription) VALUES ('" & SQLEncrypt(sTitle) & "', " & iForum & ", '" & SQLEncrypt(sDescription) & "')"
			DBExecute oCn, rSQL
			AddSection = True
			oCn.Close
			Set oCn = Nothing
		End If
	End Function

	Function DeleteSection(iSection)
		Dim oCn, rSQL

		DeleteSection = False

		If IsNumeric(iSection) and iSection <> 0 Then
			Set oCn = DBConnexion(DB_FORUM)
			rSQL = "DELETE FROM Posts WHERE PostSection=" & iSection
			DBExecute oCn, rSQL
			rSQL = "DELETE FROM Sections WHERE SectionID=" & iSection
			DBExecute oCn, rSQL
			DeleteSection = True
			oCn.Close
			Set oCn = Nothing
		End If
	End Function

	Function DeletePost(iPost)
		Dim oCn, oRs, rSQL

		DeletePost = False

		If IsNumeric(iPost) and iPost <> 0 Then
			Set oCn = DBConnexion(DB_FORUM)
			rSQL = "SELECT PostParent FROM Posts WHERE PostID=" & iPost
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				If oRs("PostParent") = CInt(iPost) Then
					rSQL = "DELETE FROM Posts WHERE PostParent=" & iPost
				Else
					rSQL = "DELETE FROM Posts WHERE PostID=" & iPost
				End If
				DBExecute oCn, rSQL
				DeletePost = True
				oCn.Close
				Set oCn = Nothing
			End If
		End If
	End Function

	Function ValidatePost(iPost, bState)
		Dim oCn, rSQL

		ValidatePost = False

		If iPost <> "" and iPost <> 0 Then
			Set oCn = DBConnexion(DB_FORUM)
			rSQL = "UPDATE Posts SET PostValid=" & bState & " WHERE PostID=" & iPost
			DBExecute oCn, rSQL
			ValidatePost = True
			oCn.Close
			Set oCn = Nothing
		End If
	End Function

	Function AddModerator(sUser, iSection)
		Dim oCn, Rs, rSQL

		AddModerator = False
		Set oCn = DBConnexion(DB_FORUM)
		
		If iSection = "" Then iSection = 0
		rSQL = "SELECT SectionID FROM Sections WHERE SectionID=" & iSection
		Set Rs = DBRecordSet(oCn, rSQL)
		If Not Rs.EOF Then
			rSQL = "SELECT UserLogin FROM Users WHERE UserLogin='" & SQLEncrypt(sUser) & "'"
			Set Rs = DBRecordSet(oCn, rSQL)
			If Not Rs.EOF Then
				rSQL = "INSERT INTO Moderators (ModeratorID, ModeratorSection) VALUES ('" & SQLEncrypt(Rs("UserLogin")) & "', " & iSection & ")"
				DBExecute oCn, rSQL
				AddModerator = True
			End If
		End If

		oCn.Close
		Set Rs   = Nothing
		Set oCn = Nothing
	End Function

	Function DeleteModerator(sUser, iSection)
		Dim oCn, Rs, rSQL

		DeleteModerator = False
		Set oCn = DBConnexion(DB_FORUM)
		
		If IsNumeric(iSection) And iSection <> 0 Then
			rSQL = "DELETE FROM Moderators WHERE ModeratorID = '" & SQLEncrypt(sUser) & "' AND ModeratorSection=" & iSection
			DBExecute oCn, rSQL
			DeleteModerator = True
		End If

		oCn.Close
		Set Rs   = Nothing
		Set oCn = Nothing
	End Function

	Function AddAdministrator(sUser, iForum)
		Dim oCn, Rs, rSQL

		AddAdministrator = False
		Set oCn = DBConnexion(DB_FORUM)

		If IsNumeric(iForum) And iForum <> 0 Then
			rSQL = "SELECT UserLogin FROM Users WHERE UserLogin='" & SQLEncrypt(sUser) & "'"
			Set Rs = DBRecordSet(oCn, rSQL)
			If Not Rs.EOF Then
				rSQL = "INSERT INTO Administrators (AdministratorID, AdministratorForum) VALUES ('" & SQLEncrypt(Rs("UserLogin")) & "', " & iForum & ")"
				DBExecute oCn, rSQL
				AddAdministrator = True
			End If
		End If

		oCn.Close
		Set Rs   = Nothing
		Set oCn = Nothing
	End Function

	Function DeleteAdministrator(sUser, iForum)
		Dim oCn, Rs, rSQL

		DeleteAdministrator = False
		Set oCn = DBConnexion(DB_FORUM)

		If IsNumeric(iForum) And iForum <> 0 Then
			rSQL = "DELETE FROM Administrators WHERE AdministratorID = '" & SQLEncrypt(sUser) & "' AND AdministratorForum=" & iForum
			DBExecute oCn, rSQL
			DeleteAdministrator = True
		End If

		oCn.Close
		Set Rs   = Nothing
		Set oCn = Nothing
	End Function
%>