<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display advertising
	' IN  : iID (int) : advertising's id (table advertising, field aID)
	' OUT : -
	Sub DisplayAdvertising(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT aTitle, aURL, aHits FROM advertising WHERE aID=" & iID

		Set oRs = DBRecordSet(oCn, rSQL)

		CreateTopTable "Advertising", GetTranslation("LANG_ADVERTISING")

		If Not oRs.EOF Then
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("aTitle")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & oRs("aHits") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2"" align=""center"">" & oRs("aURL") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF

			rSQL = "UPDATE advertising SET aHits=" & oRs("aHits") + 1 & ", aDate='" & DateTimeToString(Now()) & "' WHERE aID=" & iID
			DBExecute oCn, rSQL
		End If

		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display the top advertising
	' IN  : iTop (int) : number of results wanted
	'     : sSortedField (string) : field sorted
	'     : bAscSort (boolean) : if true = ASC sort, else DESC
	' OUT : -
	Sub DisplayTopAdvertising(iTop, sSortedField, bAscSort)
		Dim oCn, oRs, rSQL, iLine, sSortDesc
		
		Select Case LCase(sSortedField)
			Case "atitle" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_TITLE")
			Case "ahits" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_HITS")
			Case "adate" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_DATE")
			Case Else :
				' default value
				sSortedField = "aDate"
				bAscSort = False
				sSortDesc = GetTranslation("LANG_DATE")
		End Select

		Set oCn = DBConnexion(DB_MAIN)

		If iTop <> 0 and iTop <> "" Then
			rSQL = "SELECT TOP " & iTop & " aID, aTitle, aHits, aDate, aValid FROM advertising ORDER BY " & sSortedField
		Else
			rSQL = "SELECT aID, aTitle, aHits, aDate, aValid FROM advertising ORDER BY " & sSortedField
		End If

		If Not bAscSort Then
			rSQL = rSQL & " DESC"
			sSortDesc = sSortDesc & " (DESC)"
		Else
			sSortDesc = sSortDesc & " (ASC)"
		End If

		Set oRs = DBRecordSet(oCn, rSQL)

		CreateTopTable "TopAdvertising", GetTranslation("LANG_TOP") & " " & iTop & " - " & GetTranslation("LANG_ADVERTISING") & "&nbsp;|&nbsp;<span class=""small"">" & Replace(GetTranslation("LANG_SORT_BY"), "%1%", sSortDesc)  & "</span>"
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "&nbsp;</td>" & vbCRLF
		Response.Write "    <td width=""60"" align=""center"">" & GetTranslation("LANG_HITS") & "&nbsp;</td>" & vbCRLF
		Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_DATE") & "&nbsp;</td>" & vbCRLF
		Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_VALID") & "&nbsp;</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "&nbsp;</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		If Not oRs.EOF Then
			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("aTitle")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & oRs("aHits") & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & GetDateDDMMYYHHMMSS(StringToDate(oRs("aDate"))) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & oRs("aValid") & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & vbCRLF
				MenuAdmin(oRs("aID"))
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				oRs.MoveNext
			WEnd
		End If
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""5""><a href=""" & sURLPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_ADVERTISING") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display search's resulton advertising
	' IN  : sQuery (string) : query data
	' OUT : -
	Sub DisplayAdvertisingSearch(sQuery)
		Dim oCn, oRs, rSQL, iLine, iNum

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT * FROM advertising WHERE aTitle LIKE '" & SQLEncrypt(sQuery) & "' ORDER BY aTitle"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "SearchAccounts", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_ADVERTISING") & " (" & Server.HTMLEncode(Replace(sQuery, "%", "")) & ")"
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "&nbsp;</td>" & vbCRLF
		Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_HITS") & "&nbsp;</td>" & vbCRLF
		Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_VALID") & "&nbsp;</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "&nbsp;</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF

		iNum = 0
		If Not oRs.EOF Then
			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("aTitle")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & oRs("aHits") & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & oRs("aValid") & "</td>" & vbCRLF
				Response.Write "    <td align=""center"" align=""center"">" & vbCRLF
				MenuAdmin(oRs("aID"))
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				iNum = iNum + 1
				oRs.MoveNext
			WEnd
		End If

		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""4"">" & GetTranslation("LANG_TOTAL_ADVERTISING") & " : " & iNum & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""4""><a href=""" & sURLPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_ADVERTISING") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display a navigation bar for advertising
	' IN  : -
	' OUT : -
	Sub DisplayAdvertisingNavigation()
		Dim X
		
		CreateTopTable "SearchAdvertising", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_ADVERTISING")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <form name=""Search"" method=""get"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "    <input type=""hidden"" name=""Do"" value=""search"">" & vbCRLF
		Response.Write "    <td>"
		Response.Write "&nbsp;<a href=""" & sURLPage & """>" & GetTranslation("LANG_TOP") & "</a>" & vbCRLF
		For X = 0 to 25
			Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=" & Chr(Asc("a")+X) & """>" & Chr(Asc("a")+X) & "</a>" & vbCRLF
		Next
		Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=0"">0-9</a>" & vbCRLF
		Response.Write "    &nbsp;<input name=""name"" size=""10"" maxlength=""20"" class=""cell"" onEnter=""javascript:document.search.submit()""></td>"
		Response.Write "    </form>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
	End Sub

	' Display edit advertising's form (add or update data)
	' IN  : iID (int) : advertising's id (table advertising, field aID), if null or = 0 then add advertising
	' OUT : -
	Sub EditAdvertising(iID)
		Dim oCn, oRs, rSQL
		Dim sTitle, sEditTitle, sURL, bRoleBased, iAdRole, bValid, sDo

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sDo = "updt"
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_ADVERTISING")
			rSQL = "SELECT * FROM advertising WHERE aID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sTitle = oRs("aTitle")
				sURL = oRs("aURL")
				bRoleBased = oRs("aRoleBased")
				iAdRole = oRs("aRole")
				bValid = oRs("aValid").Value
			End If
		Else
			sDo = "add"
			sEditTitle = GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_ADVERTISING")
			bRoleBased = False
			iAdRole = 0
			bValid = False
		End If
	
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "')) document.edition.submit();" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		CreateTopTable "Edit", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""aID"" value=""" & iID & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLf
		Response.Write "    <td width=""120"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""aTitle"" value=""" & Server.HTMLEncode(sTitle) & """ maxlength=""50"" size=""20"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_CONTENT") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""aURL"" cols=""50"" rows=""3"" class=""cell"">" & Server.HTMLEncode(sURL) & "</textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_ROLE") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <input type=""checkbox"" name=""aRoleBased"""
		If bRoleBased Then Response.Write " checked"
		Response.Write ">" & vbCRLF
		Response.Write "      <select name=""aRole"" class=""cell"">" & vbCRLF
		Response.Write "        <option value=""0"""
		If iRole = 0 Then Response.Write " selected"
		Response.Write ">" & GetTranslation("LANG_VISITORS") & "</option>" & vbCRLF
		
		rSQL = "SELECT rId, rTitle FROM Roles ORDER BY rID"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		While Not oRs.EOF
			Response.Write "        <option value=""" & oRs("rID") & """"
			If iAdRole = oRs("rID") Then Response.Write " selected"
			Response.Write ">" & Server.HTMLEncode(oRs("rTitle")) & "</option>" & vbCRLF
			
			oRs.MoveNext
		WEnd

		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
		Response.Write "    <td><input type=""checkbox"" name=""aValid"""
		If bValid Then Response.Write " checked"
		Response.Write "></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""confirmDo();""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add advertising (insert query)
	' IN  : sTitle (string) : advertising's title (table advertising, field aTitle)
	'     : sURL (string) : advertising's url (table advertising, field aURL)
	'     : dDate (datetime) : advertising's last display date (table advertising, field aDate)
	'     : bRoleBased (boolean) : if advertising role based (table advertising, field aRoleBased)
	'     : iAdRole (boolean) : advertising minimum role (table advertising, field aRole)
	'     : bValid (boolean) : advertising's validation (table advertising, field aValid)
	' OUT : (boolean) : True if added
	Function AddAdvertising(sTitle, sURL, dDate, bRoleBased, iAdRole, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "INSERT INTO advertising (aTitle, aURL, aDate, aHits, aRoleBased, aRole, aValid) VALUES ('" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sURL) & "', '" & DateTimeToString(dDate) & "', 0, " & bRoleBased & ", " & iAdRole & ", " & bValid & ")"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing
		AddAdvertising = True
	End Function

	' Modify advertising (update query)
	' IN  : iID (int) : advertising's id (table advertising, field aID)
	'     : sTitle (string) : advertising's title (table advertising, field aTitle)
	'     : sURL (string) : advertising's url (table advertising, field aURL)
	'     : bRoleBased (boolean) : if advertising role based (table advertising, field aRoleBased)
	'     : iAdRole (boolean) : advertising minimum role (table advertising, field aRole)
	'     : bValid (boolean) : advertising's validation (table advertising, field aValid)
	' OUT : (boolean) : True if modified
	Function ModifyAdvertising(iID, sTitle, sURL, bRoleBased, iAdRole, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "UPDATE advertising SET aTitle = '" & SQLEncrypt(sTitle) & "', aURL = '" & SQLEncrypt(sURL) & "', aRoleBased=" & bRoleBased & ", aRole=" & iAdRole & ", aValid = " & bValid & " WHERE aID=" & iID
		DBExecute oCn, rSQL
		
		oCn.Close
		Set oCn = Nothing
		ModifyAdvertising = True
	End Function

	' Delete advertising (delete query)
	' IN  : iID (int) : advertising's id (table advertising, field aID)
	' OUT : (boolean) : True if deleted
	Function DeleteAdvertising(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "DELETE FROM advertising WHERE aID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing
		DeleteAdvertising = True
	End Function
	
	' Display deleting's form (to confirm)
	' IN  : iID (int) : advertising's id (table advertising, field aID)
	' OUT : -
	Sub ConfirmDeleteAdvertising(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" Then
			rSQL = "SELECT * FROM advertising WHERE aID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delAccount()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "ConfirmDel", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""aID"" value=""" & iID & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td><td>" & Server.HTMLEncode(oRs("aTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONTENT") & "</td><td>" & oRs("aURL") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_HITS") & "</td><td>" & oRs("aHits") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=""button"" onClick=""javascript:delAccount();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=""button"" onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminAdvertising()
		Dim bValid, bRoleBased, iAdRole

		Select Case Request("do")
			Case "add" :
				If Request.Form("aValid") <> "" Then
					bValid = "1"
				Else
					bValid = "0"
				End If
				If Request.Form("aRoleBased") <> "" Then
					bRoleBased = "1"
					iAdRole = Request.Form("aRole")
				Else
					bRoleBased = "0"
					iAdRole = 0
				End If
				If AddAdvertising(Request("aTitle"), Request("aURL"), Now(), bRoleBased, iAdRole, bValid) Then 
					sInfoPage = GetTranslation("LANG_ADVERTISING") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_ADVERTISING") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			Case "updt" :
				If Request.Form("aValid") <> "" Then
					bValid = "1"
				Else
					bValid = "0"
				End If
				If Request.Form("aRoleBased") <> "" Then
					bRoleBased = "1"
					iAdRole = Request.Form("aRole")
				Else
					bRoleBased = "0"
					iAdRole = 0
				End If
				If ModifyAdvertising(Request("aID"), Request("aTitle"), Request("aURL"), bRoleBased, Request.Form("aRole"), bValid) Then 
					sInfoPage = GetTranslation("LANG_ADVERTISING") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_ADVERTISING") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del" : 
				If DeleteAdvertising(Request("aID")) Then 
					sInfoPage = GetTranslation("LANG_ADVERTISING") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_ADVERTISING") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub

	' Display admin advertising page
	' IN  : -
	' OUT : -
	Sub DisplayAdminAdvertisingPage()
		Dim bDisplayTop, bDisplayNav, bAscSorted, sSortedField
		
		bAscSorted = True
		sSortedField = ""
		
		sSortedField = Request.QueryString("sort")
		If sSortedField <> "" Then sSortedField = LCase(sSortedField)
		If Request.QueryString("sortype") = "desc" Then	bAscSorted = False

		bDisplayTop = True
		bDisplayNav = True
		
		Select Case Request("do")
			Case "search" :
				If Len(Request("name")) = 1 Then
					If Request("name") <> "0" Then
						DisplayAdvertisingSearch Request("name") & "%"
					Else
						DisplayAdvertisingSearch "[0-9]%"
					End If
				ElseIf Len(Request("name")) > 1 Then
					DisplayAdvertisingSearch Request("name") & "%"
				End If
				bDisplayTop = False
			Case "view" : 
				DisplayAdvertising Request("id")
				bDisplayTop = False
			Case "new"  : 
				EditAdvertising 0
				bDisplayTop = False
			Case "edit" : 
				EditAdvertising Request("id")
				bDisplayTop = False
			Case "cdel" : 
				ConfirmDeleteAdvertising Request("id")
				bDisplayTop = False
		End Select

		If bDisplayTop Then DisplayTopAdvertising 10, sSortedField, bAscSorted 
		If bDisplayNav Then DisplayAdvertisingNavigation()
	End Sub
%>