<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display smiley's information
	' IN  : iID (int) : smiley's tag (table Smileys, field SmileyTag)
	' OUT : -
	Sub DisplayAdminSmiley(iID)
		Dim oCn, oRs, rSQL
		
		Set oCn = DBConnexion(DB_FORUM)

		rSQL = "SELECT * FROM Smileys WHERE SmileyTag='" & iID & "'"
		
		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then
			CreateTopTable "Smiley", GetTranslation("LANG_SMILEYS")

			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_SMILEY") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("SmileyTag")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("SmileyName")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
			Response.Write "    <td><img src="""
			If Left(oRs("SmileyPath"), 7) <> "http://" Then Response.Write GLOBAL_SITE_IMAGES_SMILEYS_PATH
			Response.write Server.HTMLEncode(oRs("SmileyPath")) & """ border=""0""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
	
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display the list of all smileys (order by code)
	' IN  : -
	' OUT : -
	Sub DisplayAllSmileys()
		Dim oCn, oRs, rSQL, iLine
		
		Set oCn = DBConnexion(DB_FORUM)

		rSQL = "SELECT * FROM Smileys ORDER BY SmileyTag"
		
		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "Smileys", GetTranslation("LANG_SMILEYS")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_SMILEY") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF

		iLine = 1
		While Not oRs.EOF
			Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("SmileyName")) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("SmileyTag")) & "</td>" & vbCRLF
			Response.Write "    <td align=""center""><img src="""
			If Left(oRs("SmileyPath"), 7) <> "http://" Then Response.Write GLOBAL_SITE_IMAGES_SMILEYS_PATH
			Response.write Server.HTMLEncode(oRs("SmileyPath")) & """ border=""0""></td>" & vbCRLF
			Response.Write "    <td align=""center"">" & vbCRLF
			MenuAdmin(Server.URLEncode(oRs("SmileyTag")))
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1 + ((iLine-1) XOR 1)
			oRs.MoveNext
		WEnd

		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""4""><a href=""" & sUrlPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_SMILEY") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF

		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Edit smiley (add or update)
	' IN  : iID (int) : smiley's id (table smileys, field SmileyTag) if null then added
	' OUT : -
	Sub EditSmiley(iID)
		Dim oCn, oRs, rSQL
		Dim sEditTitle, sDo, sTitle, sTag, sPicture, X

		Set oCn = DBConnexion(DB_FORUM)

		If iID <> "" Then
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_SMILEY")
			sDo = "updt"
			rSQL = "SELECT * FROM Smileys WHERE SmileyTag='" & SQLEncrypt(iID) & "'"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sTitle = oRs("SmileyName")
				sTag = oRs("SmileyTag")
				sPicture = oRs("SmileyPath")
			End If
		Else
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_SMILEY")
			sDo = "add"
		End If
	
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
		Response.Write "     {" & vbCRLF
		Response.Write "       document.edition.submit();" & vbCRLF
		Response.Write "     }" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "  function openPicture()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "	var sMyPicture = document.edition.SmileyPath.value;" & vbCRLF
		Response.Write "    if (sMyPicture != '')"
		Response.Write "	{" & vbCRLF
		Response.Write "		if (sMyPicture.substr(0,7) != 'http://') sMyPicture = '" & GLOBAL_SITE_IMAGES_SMILEYS_PATH & "' + sMyPicture;"
		Response.Write "		window.open('" & GLOBAL_SITE_PATH & GLOBAL_SITE_VIEW_IMAGE_PAGE & "?img=' + sMyPicture, 'Picture', 'width=500,height=100,menubar=no,resizable=yes');" & vbCRLF
		Response.Write "	}" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		CreateTopTable "Edit", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""sID"" value=""" & iID & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLf
		Response.Write "    <td width=""120"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""SmileyName"" value=""" & Server.HTMLEncode(sTitle) & """ maxlength=""50"" size=""30"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_SMILEY") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""SmileyTag"" value=""" & Server.HTMLEncode(sTag) & """ maxlength=""5"" size=""5"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <input name=""SmileyPath"" value=""" & Server.HTMLEncode(sPicture) & """ class=""cell"" maxlength=""200"" size=""50"">" & vbCRLF
		Response.Write "      <a href=""javascript:openPicture()""><img src=""" & GLOBAL_SITE_IMAGES_PATH & "view.gif"" border=""0""></a>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value="" " & GetTranslation("LANG_SUBMIT") & " "" class=""button"" onClick=""confirmDo();""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add a new smiley (insert query)
	' IN  : sTitle (string) : smiley's name (table Smileys, field SmileyName)
	'     : sTag (string) : smiley's tag (table Smileys, field SmileyTag)
	'     : sPicture (string) : smiley's picture (table Smileys, field SmileyPath)
	' OUT : (boolean) : True if added
	Function AddSmiley(sTitle, sTag, sPicture)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_FORUM)
		rSQL = "INSERT INTO Smileys (SmileyTag, SmileyName, SmileyPath) VALUES ('" & SQLEncrypt(sTag) & "', '" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sPicture) & "')"
		oCn.Execute rSQL
		
		oCn.Close
		Set oCn = Nothing

		AddSmiley = True

		Application.Lock
		Application("Smileys") = ""
		Application.UnLock
	End Function

	' Modify smiley (update query)
	' IN  : sID (string) : smiley's tag to be changed (table Smileys, field SmileyTag)
	'     : sTitle (string) : smiley's name (table Smileys, field SmileyName)
	'     : sTag (string) : smiley's tag (table Smileys, field SmileyTag)
	'     : sPicture (string) : smiley's picture (table Smileys, field SmileyPath)
	' OUT : (boolean) : True if modified
	Function ModifySmiley(sID, sTitle, sTag, sPicture)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_FORUM)
		rSQL = "UPDATE Smileys SET SmileyName = '" & SQLEncrypt(sTitle) & "', SmileyTag = '" & SQLEncrypt(sTag) & "', SmileyPath ='" & SQLEncrypt(sPicture) & "' WHERE SmileyTag='" & SQLEncrypt(sID) & "'"
		oCn.Execute rSQL

		oCn.Close
		Set oCn = Nothing

		ModifySmiley = True

		Application.Lock
		Application("Smileys") = ""
		Application.UnLock
	End Function

	' Delete smiley (delete query)
	' IN  : iID (int) : smiley's tag (table Smileys, field SmileyTag)
	' OUT : -
	Function DeleteSmiley(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_FORUM)
		rSQL = "DELETE FROM Smileys WHERE SmileyTag='" & SQLEncrypt(iID) & "'"
		oCn.Execute rSQL

		oCn.Close
		Set oCn = Nothing

		DeleteSmiley = True					

		Application.Lock
		Application("Smileys") = ""
		Application.UnLock
	End Function

	' Display deleting's form
	' IN  : iID (int) : smiley's id (table Smileys, field SmileyTag)
	' OUT : -
	Sub ConfirmDeleteSmiley(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_FORUM)

		If iID <> "" Then
			rSQL = "SELECT * FROM Smileys WHERE SmileyTag= '" & SQLEncrypt(iID) & "'"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function DeleteVersion()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "DeleteSmiley", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""SmileyTag"" value=""" & iID & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td><td>" & Server.HTMLEncode(oRs("SmileyName")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_SMILEY") & "</td><td>" & Server.HTMLEncode(oRs("SmileyTag")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_IMAGE") & "</td><td><img src=""" 
				If Left(oRs("SmileyPath"), 7) <> "http://" Then Response.Write GLOBAL_SITE_IMAGES_SMILEYS_PATH
				Response.write Server.HTMLEncode(oRs("SmileyPath")) & """ border=""0""></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=2 align=right>" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=button onClick=""DeleteVersion();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=button onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminSmileys()
		Select Case Request("do") 
			Case "add"  : 
				If AddSmiley(Request.Form("SmileyName"), Request.Form("SmileyTag"), Request.Form("SmileyPath")) Then 
					sInfoPage = GetTranslation("LANG_SMILEY") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_SMILEY") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			Case "updt" : 
				If ModifySmiley(Request.Form("sID"), Request.Form("SmileyName"), Request.Form("SmileyTag"), Request.Form("SmileyPath")) Then 
					sInfoPage = GetTranslation("LANG_SMILEY") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_SMILEY") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del"  :
				If DeleteSmiley(Request.Form("SmileyTag")) Then 
					sInfoPage = GetTranslation("LANG_SMILEY") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_SMILEY") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub
	
	' Display admin versions page
	' IN  : -
	' OUT : -
	Sub DisplayAdminSmileysPage()
		Select Case Request("do")
			Case "view" : 
				DisplayAdminSmiley Request("id")
			Case "new"  : 
				EditSmiley ""
			Case "edit" : 
				EditSmiley Request("id")
			Case "cdel" : 
				ConfirmDeleteSmiley Request("id")
		End Select

		DisplayAllSmileys()
	End Sub
%>