<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display version's information
	' IN  : iID (int) : version's id (table versions, field vID)
	' OUT : -
	Sub DisplayAdminVersion(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT * FROM versions WHERE vID=" & iID
		
		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then
			CreateTopTable "Version", GetTranslation("LANG_VERSION")

			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("vCode")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("vTitle")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(""&oRs("vPicture")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
	
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display the list of all versions (order by code)
	' IN  : -
	' OUT : -
	Sub DisplayAllVersions()
		Dim oCn, oRs, rSQL, iLine

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT * FROM versions ORDER BY vCode"
		
		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "Versions", GetTranslation("LANG_VERSIONS")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_VERSIONS") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF

		iLine = 1
		While Not oRs.EOF
			Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("vTitle")) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("vCode")) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & vbCRLF
			MenuAdmin(oRs("vID"))
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1 + ((iLine-1) XOR 1)
			oRs.MoveNext
		WEnd

		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""3""><a href=""" & sUrlPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_VERSION") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF

		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Edit version (add or update)
	' IN  : iID (int) : version's id (table versions, field vID) if null or = 0 then added
	' OUT : -
	Sub EditVersion(iID)
		Dim oCn, oRs, rSQL
		Dim sEditTitle, sDo, sTitle, sCode, sPicture

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_VERSION")
			sDo = "updt"
			rSQL = "SELECT * FROM versions WHERE vID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sTitle = oRs("vTitle")
				sCode = oRs("vCode")
				sPicture = oRs("vPicture")
			End If
		Else
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_VERSION")
			sDo = "add"
		End If
	
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
		Response.Write "     {" & vbCRLF
		Response.Write "       document.edition.submit();" & vbCRLF
		Response.Write "     }" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		CreateTopTable "Edit", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""vID"" value=""" & iID & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLf
		Response.Write "    <td width=""120"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""vTitle"" value=""" & Server.HTMLEncode(sTitle) & """ maxlength=""50"" size=""30"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""vCode"" value=""" & Server.HTMLEncode(sCode) & """ maxlength=""5"" size=""5"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""vPicture"" value=""" & Server.HTMLEncode(sPicture&"") & """ maxlength=""50"" size=""20"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value="" " & GetTranslation("LANG_SUBMIT") & " "" class=""button"" onClick=""confirmDo();""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add a new version (insert query)
	' IN  : sTitle (string) : version's name (table versions, field vTitle)
	'     : sCode (string) : version's code (table versions, field vCode)
	'     : sPicture (string) : version's picture (table versions, field vPicture)
	' OUT : (boolean) : True if added
	Function AddVersion(sTitle, sCode, sPicture)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "INSERT INTO versions (vTitle, vCode, vPicture) VALUES ('" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sCode) & "', '" & SQLEncrypt(sPicture) & "')"
		oCn.Execute rSQL					

		oCn.Close
		Set oCn = Nothing

		AddVersion = True
	End Function

	' Modify version (update query)
	' IN  : iID (int) : version's id (table versions, field vID)
	'     : sTitle (string) : version's name (table versions, field vTitle)
	'     : sCode (string) : version's code (table versions, field vCode)
	'     : sPicture (string) : version's picture (table versions, field vPicture)
	' OUT : (boolean) : True if modified
	Function ModifyVersion(iID, sTitle, sCode, sPicture)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE versions SET vTitle = '" & SQLEncrypt(sTitle) & "', vCode = '" & SQLEncrypt(sCode) & "', vPicture='" & SQLEncrypt(sPicture) & "' WHERE vID=" & iID
		oCn.Execute rSQL					

		oCn.Close
		Set oCn = Nothing

		ModifyVersion = True
	End Function

	' Delete version (delete query)
	' IN  : iID (int) : version's id (table versions, field vID)
	' OUT : -
	Function DeleteVersion(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "DELETE FROM versions WHERE vID=" & iID
		oCn.Execute rSQL

		oCn.Close
		Set oCn = Nothing

		DeleteVersion = True					
	End Function

	' Display deleting's form
	' IN  : iID (int) : version's id (table versions, field vID)
	' OUT : -
	Sub ConfirmDeleteVersion(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT * FROM versions WHERE vID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function DeleteVersion()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "DeleteVersion", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""vID"" value=""" & iID & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td><td>" & Server.HTMLEncode(oRs("vTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td><td>" & Server.HTMLEncode(oRs("vCode")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=button onClick=""DeleteVersion();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=button onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminVersions()
		Select Case Request("do") 
			Case "add"  : 
				If AddVersion(Request.Form("vTitle"), Request.Form("vCode"), Request.Form("vPicture")) Then 
					sInfoPage = GetTranslation("LANG_VERSION") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_VERSION") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			Case "updt" : 
				If ModifyVersion(Request.Form("vID"), Request.Form("vTitle"), Request.Form("vCode"), Request.Form("vPicture")) Then 
					sInfoPage = GetTranslation("LANG_VERSION") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_VERSION") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del"  :
				If DeleteVersion(Request.Form("vID")) Then 
					sInfoPage = GetTranslation("LANG_VERSION") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_VERSION") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub
	
	' Display admin versions page
	' IN  : -
	' OUT : -
	Sub DisplayAdminVersionsPage()
		Select Case Request("do")
			Case "view" : 
				DisplayAdminVersion Request("id")
			Case "new"  : 
				EditVersion 0
			Case "edit" : 
				EditVersion Request("id")
			Case "cdel" : 
				ConfirmDeleteVersion Request("id")
		End Select

		DisplayAllVersions()
	End Sub
%>