<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	Const COMMENTS_MAX_RATING = 5

	' Display all comments from an item
	' IN  : iID (int) : item's id
	' IN  : iType (int) : item's type (news, downloads, images...)
	' OUT : -
	Sub DisplayComments(iID, iType)
		Dim oCn, oRs, oRs2, rSQL, iLine
		Dim sAuthor, iRate, iNbComments, iNbRate, iSumRate, iTotalRate

		Set oCn = DBConnexion(DB_MAIN)

		If iID = "" Then iID = 0

		rSQL = "SELECT cID, cAuthor, cDate, cRate, cText, cIP FROM Comments WHERE cItem=" & iID & " AND cType=" & iType & " AND cValid=1 ORDER BY cDate"

		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then
			CreateTopTable "Comments", GetTranslation("LANG_COMMENTS")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF

			rSQL = "SELECT Count(cRate) as NbRate, Sum(cRate) as SumRate FROM Comments WHERE cItem=" & iID & " AND cType=" & iType & " AND cValid=1 AND cRate>0"
			Set oRs2 = DBRecordSet(oCn, rSQL)
			iNbRate = oRs2("NbRate")
			iSumRate = oRs2("SumRate")
			
			rSQL = "SELECT Count(cID) as NbComments FROM Comments WHERE cItem=" & iID & " AND cType=" & iType & " AND cValid=1"
			Set oRs2 = DBRecordSet(oCn, rSQL)
			iNbComments = oRs2("NbComments")
			
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td>"
			If iNbComments > 0 Then
				If iNbComments > 1 Then
					Response.Write iNbComments & " " & GetTranslation("LANG_COMMENTS")
				Else
					Response.Write iNbComments & " " & GetTranslation("LANG_COMMENT")
				End If
				If iNbRate > 0 Then
					iTotalRate = Round(iSumRate/iNbRate, 1)
					Response.Write " - " & iTotalRate & "/" & COMMENTS_MAX_RATING & " - " & GetTranslation("LANG_VOTES") & " : " & iNbRate
				End If
			End If
			Response.Write "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				iRate = oRs("cRate")
				sAuthor = oRs("cAuthor").Value
				If Len(sAuthor) = 0 Then 
					sAuthor = GetTranslation("LANG_ANONYM")
				Else
					sAuthor = "<a href=""" & GLOBAL_SITE_PROFILE_PAGE & "?id=" & Server.URLEncode(sAuthor) & """>" & Server.HTMLEncode(sAuthor) & "</a>"
				End If
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & vbCRLF
				Response.Write "      <span class=""small"">" & Replace(Replace(GetTranslation("LANG_POST_DATE_BY"), "%1%", GetDateLitteralDDMMYYYYHHMMSS(StringToDate(oRs("cDate")))), "%2%", sAuthor) & "</span><a name=""comment_" & oRs("cID") & """></a>&nbsp;&nbsp;"
				Response.Write "<img src=""" & GLOBAL_SITE_IMAGES_PATH & "rate_" & iRate & ".gif"" border=""0"" alt=""" & iRate & "/" & COMMENTS_MAX_RATING & """>" & vbCRLF
				If IsAuthorized(ROLE_ADMIN) Then
					Response.Write " <span class=""small"">(" & GetTranslation("LANG_IP") & " : " & oRs("cIP") & ")</span>" & vbCRLF
				End If
				Response.Write "<br><br>" & vbCRLF
				Response.Write "      <blockquote>" & CodeMessage(oRs("cText"), False) & "</blockquote>" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)	
				oRs.MoveNext
			WEnd
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
		Set oRs2 = Nothing
	End Sub

	' Display the form to post a new comment
	' IN  : iID (int) : item's id
	'     : iType (int) : item's type (news, downloads, images...)
	' OUT : -
	Sub DisplayNewComment(iID, iType)
		Dim oCn, oRs, rSQL, X
		
		Set oCn = DBConnexion(DB_MAIN)
		
		If iID = "" Then iID = 0

		CreateTopTable "AddComments", GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_COMMENTS")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""add"" method=""post"" action=""" & sURLPage & "?" & Replace(Request.QueryString(), "do=new", "") & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""add""></td>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""cItem"" value=""" & iID & """></td>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""cType"" value=""" & iType & """></td>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_LOGIN") & "</td>" & vbCRLF
		Response.Write "    <td>"
		If sPseudo <> "" Then
			Response.Write Server.HTMLEncode(sPseudo)
			Response.Write "<input type=""hidden"" name=""cAuthor"" value=""" & Server.HTMLEncode(sPseudo) & """></td>" & vbCRLF
		Else
			Response.Write GetTranslation("LANG_ANONYM")
			Response.Write "<input type=""hidden"" name=""cAuthor"" value=""""></td>" & vbCRLF
		End If
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_MESSAGE") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""cText"" class=""cell"" cols=""50"" rows=""5""></textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_RATE_IT") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""cRate"" class=""cell"">" & vbCRLF
		Response.Write "        <option value=""0"" selected>-</a>" & vbCRLF
		For X = 1 to COMMENTS_MAX_RATING
			Response.Write "        <option value=""" & X & """>" & X & "</a>" & vbCRLF
		Next
		Response.Write "      </select> / " & COMMENTS_MAX_RATING & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""submit"" name=""submit"" class=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add a comment on an item
	' IN  : iID (int) : item's id
	'     : iType (int) : item's type (news, downloads, images...)
	'     : sAuthor (string) : comment's author (can be empty) (table comments, field cAuthor)
	'     : iRate (int) : comment's rate (if = 0 this will not be rated)
	'     : sText (string) : comment (table comments, field cText)
	' OUT : (boolean) : True if added
	Function AddComment(iID, iType, sAuthor, iRate, sText)
		Dim oCn, oRs, rSQL, bDone

		bDone = False
		Set oCn = DBConnexion(DB_MAIN)
		' Antiflood system
		rSQL = "SELECT cID FROM comments WHERE cItem=" & iID & " and cType=" & iType & " and cAuthor='" & SQLEncrypt(sAuthor) & "' and cText='" & SQLEncrypt(sText) & "' and cRate=" & iRate
		Set oRs = DBRecordSet(oCn, rSQL)
		If oRs.EOF Then ' Not already posted
			rSQL = "INSERT INTO Comments (cItem, cType, cAuthor, cDate, cText, cRate, cIP, cValid) VALUES (" & iID & ", " & iType & ", '" & SQLEncrypt(sAuthor) & "', '" & DateTimeToString(Now()) & "', '" & Server.HTMLEncode(SQLEncrypt(sText)) & "', " & iRate & ", '" & sIP & "', 1)"
			DBExecute oCn, rSQL
			bDone = True
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing

		AddComment = bDone
	End Function

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoComments()
		If Request("do") = "add" and Request.Form("cText") <> "" Then
			AddComment Request.Form("cItem"), Request.Form("cType"), Request.Form("cAuthor"), Request.Form("cRate"), Request.Form("cText")
		End If
	End Sub

	' Display page
	' IN  : -
	' OUT : -
	Sub DisplayCommentsPage()
		Dim sCommentType, iCommentType, iCommentOnID

		iCommentOnID = Request.QueryString("id")
		If iCommentOnID = "" Then iCommentOnID = 0

		If iCommentOnID > 0 Then
			Select Case LCase(Mid(sURLPage, Len(GLOBAL_SITE_PATH)+1))
				Case LCase(GLOBAL_SITE_NEWS_PAGE)		: iCommentType = CATEGORY_TYPE_NEWS
				Case LCase(GLOBAL_SITE_DIRECTORY_PAGE)	: iCommentType = CATEGORY_TYPE_DIRECTORY
				Case LCase(GLOBAL_SITE_DOWNLOADS_PAGE)	: iCommentType = CATEGORY_TYPE_DOWNLOADS
				Case LCase(GLOBAL_SITE_IMAGES_PAGE)		: iCommentType = CATEGORY_TYPE_IMAGES
				Case LCase(GLOBAL_SITE_ARTICLES_PAGE)	: iCommentType = CATEGORY_TYPE_ARTICLES
				Case Else								: iCommentType = CATEGORY_TYPE_NEWS
			End Select

			DisplayComments iCommentOnID, iCommentType
			DisplayNewComment iCommentOnID, iCommentType
		End If
	End Sub
%>