<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display the top downloads list (by date or by hits depending of the sort attribute
	' IN  : iTop (int) : number of results wanted
	'     : sTypeSort (string) : type of sort (date or hits)
	' OUT : -
	Sub DisplayTopDownloads(iTop, sTypeSort)
		Dim oCn, oRs, rSQL, iLine
		
		Set oCn = DBConnexion(DB_MAIN)
		
		rSQL = "SELECT TOP " & iTop & " * FROM downloads WHERE dValid=1"
		Select Case sTypeSort
			Case "date"
				rSQL = rSQL & " ORDER BY dDate DESC, dTitle"
			Case "hits"
				rSQL = rSQL & " ORDER BY dHits DESC, dTitle"
		End Select

		CreateTopTable "TopDownloads", GetTranslation("LANG_TOP") & " " & iTop & " - " & GetTranslation("LANG_DOWNLOADS") & " (" & Server.HTMLEncode(sTypeSort) & ")"

		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			If sTypeSort = "hits" Then
				Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
			Else
				Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			End If
			Response.Write "	</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td><a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_DOWNLOAD_PAGE & "?dl=" & oRs("dID") & """ target=""_blank"">" & Server.HTMLEncode(oRs("dTitle")) & "</a> <span class=""small""><a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_DOWNLOADS_PAGE & "?id=" & oRs("dID") & """>" & GetTranslation("LANG_MORE_INFORMATION") & "</a></span></td>" & vbCRLF
				If sTypeSort = "hits" Then
					Response.Write "    <td align=""center"">" & oRs("dHits") & "</td>" & vbCRLF
				Else
					Response.Write "    <td align=""center"">" & GetDateDDMMYYYY(StringToDate(oRs("dDate"))) & "</td>" & vbCRLF
				End If
				Response.Write "	</td>" & vbCRLF
				Response.Write "   </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				oRs.MoveNext
			WEnd
			Response.Write "</table>" & vbCRLF
		Else
			Response.Write GetTranslation("LANG_EMPTY_SECTION") & vbCRLF
		End If
		
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display information for a specific download
	' IN  : iID (int) : download's id (table downloads, field dID)
	' OUT : -
	Sub DisplayDownload(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT * FROM downloads WHERE dValid=1 AND dID=" & iID

		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then
			CreateTopTable "Download", GetTranslation("LANG_DOWNLOAD")
	
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "	<td>" & Server.HTMLEncode(oRs("dTitle")) & "</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
			Response.Write "	<td>" & CodeMessage(oRs("dDescription"), true) & "</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			Response.Write "	<td>" & GetDateDDMMYY(StringToDate(oRs("dDate"))) & "</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
			Response.Write "	<td>" & oRs("dHits") & "</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_SIZE") & "</td>" & vbCRLF
			Response.Write "	<td>"
			If oRs("dSize") < 1024 Then
				Response.Write oRs("dSize")  & " Ko"
			Else
				Response.Write Round(oRs("dSize")/1024, 1)  & " Mo"
			End If
			Response.Write "	</td>"
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2""><a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_DOWNLOAD_PAGE & "?dl=" & oRs("dID") & """ target=""_blank"">" & GetTranslation("LANG_DOWNLOAD_DO") & "</a></td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2""><a href=""" & sURLPage & "?cat=" & oRs("dCategory") & """>" & GetTranslation("LANG_BACK") & "</a></td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
		
			CreateBottomTable ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display all downloads for one category
	' IN  : iCategory (int) : download's category (table downloads, field nCategory)
	' OUT : -
	Sub DisplayDownloadsSearch(iCategory)
		Dim oCn, oRs, rSQL, iLine, iNum
		iNum = 0
		
		Set oCn = DBConnexion(DB_MAIN)
		
		If iCategory = "" Then iCategory = 0
		rSQL = "SELECT dId, dTitle, dDate, dHits FROM downloads WHERE dValid=1 AND dCategory=" & iCategory
		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Then
			CreateTopTable "DownloadsByCategory", GetTranslation("LANG_DOWNLOADS")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td><a href=""" & sURLPage & "?id=" & oRs("dID") & """>" & Server.HTMLEncode(oRs("dTitle")) & "</td>" & vbCRLF
				Response.Write "    <td width=""120"" align=""center"">" & GetDateDDMMYY(StringToDate(oRs("dDate"))) & "</td>" & vbCRLF
				Response.Write "    <td width=""100"" align=""center"">" & oRs("dHits") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				iNum = iNum + 1
				oRs.MoveNext
			WEnd

			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""3"">" & GetTranslation("LANG_DOWNLOADS_TOTAL") & " : " & iNum & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF

			CreateBottomTable ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display a navigation bar for downloads
	' IN  : iCategoryParent (int) : category's parent id (table categories, field cParent)
	' OUT : -
	Sub DisplayDownloadsNavigation(iCategoryParent)
		Dim oCn, oRs, oRs2, rSQL, iLine, iNum

		Set oCn = DBConnexion(DB_MAIN)

		If iCategoryParent = "" Then iCategoryParent = 0
		
		If iCategoryParent <> 0 Then
			rSQL = "SELECT cId, cParent, cTitle, cDescription, cImage FROM categories WHERE cID=" & iCategoryParent
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				CreateTopTable "DownloadCategory", CodeMessage(oRs("cTitle"), True)
				If oRs("cImage") <> "" Then
					Response.Write "<img src=""" & Server.HTMLEncode(oRs("cImage") & "") & """ border=""0"" align=""left"">"
				End If
				Response.Write CodeMessage(oRs("cDescription"), True)
				Response.Write "<br><br><a href=""" & sURLPage & "?cat=" & oRs("cParent") & """>" & GetTranslation("LANG_BACK") & "</a>" & vbCRLF
				CreateBottomTable ""
			End If
		End If
		
		rSQL = "SELECT cId, cTitle FROM categories WHERE cType=" & CATEGORY_TYPE_DOWNLOADS & " AND cParent=" & iCategoryParent & " ORDER BY cTitle"
		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Then
			If iCategoryParent = 0 Then
				CreateTopTable "SearchDownloadsCategories", GetTranslation("LANG_DOWNLOADS") & " - " & GetTranslation("LANG_CATEGORIES")
			Else
				CreateTopTable "SearchDownloadsCategories", GetTranslation("LANG_DOWNLOADS") & " - " & GetTranslation("LANG_SUB_CATEGORIES")
			End If
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			iLine = 1
			iNum = 0

			While Not oRs.EOF
				If iNum mod 2 = 0 Then Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				rSQL = "SELECT Count(dID) FROM downloads WHERE dValid=1 AND dCategory=" & oRs("cID")
				Set oRs2 = DBRecordSet(oCn, rSQL)
				Response.Write "    <td width=""50%""><a href=""" & sURLPage & "?cat=" & oRs("cID") & """>" & Server.HTMLEncode(oRs("cTitle"))
				If oRs2(0) > 0 Then Response.Write " (" & oRs2(0) & ")"
				Response.Write "</td>" & vbCRLF
				If iNum mod 2 = 1 Then 
					Response.Write "  </tr>" & vbCRLF
					iLine = 1 + ((iLine-1) XOR 1)
				End If

				iNum = iNum + 1
				oRs.MoveNext
			WEnd
			If iNum mod 2 = 1 Then 
				Response.Write "    <td>&nbsp;</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
			End If
			
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
		Set oRs2= Nothing
	End Sub

	' Display a line to let users post their downloads
	' IN  : iCat : download category
	' OUT : -
	Sub DisplayAddDownloads(iCat)
		If sPseudo <> "" Then
			CreateTable "AddMemberDownloads", "", "<a href=""" & GLOBAL_SITE_DOWNLOADS_PAGE & "?do=new&cat=" & iCat & """>" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_DOWNLOADS") & "</a>", ""
		End If
	End Sub

	' Display add download's form
	' IN  : iCat (int) : download's category (table downloads, field dCategory)
	' OUT : -
	Sub EditMemberDownload(iCat)
		Dim oCn, oRs, rSQL
		Dim iVersion

		If sPseudo <> "" Then
			Set oCn = DBConnexion(DB_MAIN)
	
			rSQL = "SELECT cID, cTitle FROM categories WHERE cType=" & CATEGORY_TYPE_DOWNLOADS
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function confirmDo()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
				Response.Write "     {" & vbCRLF
				Response.Write "       document.edition.submit();" & vbCRLF
				Response.Write "     }" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "EditDownloads", GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_DOWNLOAD")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & "?cat=" & iCat & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value=""add"">" & vbCRLF
				Response.Write "<input type=""hidden"" name=""dID"" value=""0"">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td width=""150"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td><input name=""dTitle"" value="""" maxlength=""100"" size=""50"" class=""cell""></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
				Response.Write "    <td>" & GetDateDDMMYYYY(Now()) & "<input type=""hidden"" name=""dDate"" value=""" & DateTimeToString(Now()) & """></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
				Response.Write "    <td><textarea name=""dDescription"" cols=""50"" rows=""8"" class=""cell""></textarea></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
				Response.Write "    <td><input name=""dURL"" value=""http://"" maxlength=""250"" size=""50"" class=""cell""></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_SIZE") & "</td>" & vbCRLF
				Response.Write "    <td><input name=""dSize"" value=""0"" maxlength=""10"" size=""10"" class=""cell""></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF
				Response.Write "      <select name=""dCategory"" class=""cell"">" & vbCRLF

				While Not oRs.EOF
					Response.Write "        <option value=""" & oRs("cID") & """"
					If oRs("cID") = iCat Then Response.Write " selected"
					Response.Write ">" & Server.HTMLEncode(oRs("cTitle")) & "</option>" & vbCRLF
					oRs.MoveNext
				WEnd

				Response.Write "      </select>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF
				Response.Write "      <select name=""dVersion"" class=""cell"">" & vbCRLF
		
				rSQL = "SELECT vID, vCode FROM Versions ORDER BY vCode"
				Set oRs = DBRecordSet(oCn, rSQL)
		
				While Not oRs.EOF
					Response.Write "        <option value=""" & oRs("vID") & """"
					If oRs("vCode") = sXMLVersion Then Response.Write " selected"
					Response.Write ">" & oRs("vCode") & "</option>" & vbCRLF
					oRs.MoveNext
				WEnd
		
				Response.Write "      </select>" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2""><input type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""confirmDo();"" id=1 name=1></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If

			oCn.Close
			Set oCn = Nothing
			Set oRs = Nothing
		End If
	End Sub

	' Add member's download (insert query)
	' IN  : sTitle (string) : download's title (table downloads, field dTitle)
	'     : sDate (string) : download add date (table downloads, field dDate)
	'     : sDescription (string) : download's description (table downloads, field dDescription)
	'     : sURL (string) : download's url (table downloads, field dURL)
	'     : iHits (int) : download's hits (table downloads, field dHits)
	'     : iSize (int) : download's size in kilobytes (table downloads, field dSize)
	'     : iCategory (int) : download's category (table downloads, field dCategory)
	'     : iVersion (int) : download's version language (table downloads, field dVersion)
	' OUT : (boolean) : True if added
	Function AddMemberDownload(sTitle, sDate, sDescription, sURL, iHits, iSize, iCategory, iVersion)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "INSERT INTO downloads (dTitle, dDate, dDescription, dURL, dHits, dSize, dCategory, dVersion, dValid) VALUES ('" & SQLEncrypt(sTitle) & "', '" & sDate & "', '" & SQLEncrypt(sDescription) & "', '" & SQLEncrypt(sURL) & "', " & iHits & ", " & iSize & ", " & iCategory & ", " & iVersion & ", 0)"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		AddMemberDownload = True
	End Function

	' Process action
	' IN  : -
	' OUT : -
	Sub DoDownloadsPage()
		If Request.Form("do") = "add" and Request.Form("dTitle") <> "" Then
			Dim iSize
			iSize = Request.Form("dSize")
			If IsNumeric(iSize) and iSize <> "" Then
				iSize = CInt(iSize)
			Else
				iSize = 0
			End If
			If AddMemberDownload(Request.Form("dTitle"), Request.Form("dDate"), Request.Form("dDescription"), Request.Form("dURL"), 0, iSize, Request.Form("dCategory"), Request.Form("dVersion")) Then
				sInfoPage = GetTranslation("LANG_DOWNLOADS") & " - " & GetTranslation("LANG_ADD_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_DOWNLOADS") & " - " & GetTranslation("LANG_ADD_ERROR")
			End If
		End If
	End Sub
	
	' Display page
	' IN  : -
	' OUT : -
	Sub DisplayDownloadsPage()
		Dim bDisplayTop, iCat, iDownloadID

		iCat = Request.QueryString("cat")
		If iCat <> "" and IsNumeric(iCat) Then
			iCat = CInt(iCat)
		Else
			iCat = 0
		End If	

		iDownloadID = Request.QueryString("id")
		If iDownloadID <> "" and IsNumeric(iDownloadID) Then
			iDownloadID = CInt(iDownloadID)
		Else
			iDownloadID = 0
		End If
		
		DisplayDownloadsNavigation(iCat)

		If iDownloadID = 0 and iCat = 0 Then
			Response.Write "<table width=""100%"" align=""center"" border=""0"" cellspacing=""0"">" & vbCRLF
			Response.Write "  <tr>" & vbCRLF
			Response.Write "    <td valign=""top"" width=""50%"">" & vbCRLF
			DisplayTopDownloads GLOBAL_DOWNLOADS_TOP, "date"
			Response.Write "    </td>" & vbCRLF
			Response.Write "    <td width=""10""></td>" & vbCRLF
			Response.Write "    <td valign=""top"" width=""50%"">" & vbCRLF
			DisplayTopDownloads GLOBAL_DOWNLOADS_TOP, "hits"
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
		Else
			If iCat <> 0 Then 
				If Request.QueryString("do") = "new" Then
					EditMemberDownload(iCat)
				Else
					DisplayAddDownloads(iCat)
					DisplayDownloadsSearch(iCat)
				End If
			End If
			If iDownloadID <> 0 Then DisplayDownload(iDownloadID)
		End If
	End Sub
%>