<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display the top images list (by date)
	' IN  : iTop (int) : number of results wanted
	' OUT : -
	Sub DisplayTopImages(iTop)
		Dim oCn, oRs, rSQL, iLine
		
		Set oCn = DBConnexion(DB_MAIN)

		If iTop = "" Then iTop = 0
		rSQL = "SELECT TOP " & iTop & " iID, iTitle, iDate, iHits FROM images WHERE iValid=True ORDER BY iDate DESC"

		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then
			CreateTopTable "TopImages", GetTranslation("LANG_TOP") & " " & iTop & " - " & GetTranslation("LANG_IMAGES")
		
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
			Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			Response.Write "	</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td><a href=""" & sURLPage & "?id=" & oRs("iID") & """>" & Server.HTMLEncode(oRs("iTitle")) & "</a></td>" & vbCRLF
				Response.Write "    <td align=""center"">" & oRs("iHits") & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & GetDateDDMMYYYY(StringToDate(oRs("iDate"))) & "</td>" & vbCRLF
				Response.Write "	</td>" & vbCRLF
				Response.Write "   </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				oRs.MoveNext
			WEnd
			
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		Else
			CreateTable "ImagesEmpty", "", GetTranslation("LANG_EMPTY_SECTION"), ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display information for a specific images
	' IN  : iID (int) : image's id (table images, field iID)
	' OUT : -
	Sub DisplayImage(iID, iPage)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT * FROM images WHERE iValid=True AND iID=" & iID

		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then
			rSQL = "UPDATE images SET iHits=" & oRs("iHits")+1 & " WHERE iID=" & iID
			DBExecute oCn, rSQL

			CreateTopTable "Image", Server.HTMLEncode(oRs("iTitle"))
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline1""><td align=""center""><a href=""javascript:history.back(1)""><img src=""" & Server.HTMLEncode(oRs("iSourceNormal")) & """ border=""0""></a></td></tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2""><td align=""center"">" & CodeMessage(oRs("iDescription"), False) & "</td></tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1""><td align=""center"">" & GetTranslation("LANG_HITS") & " : " & oRs("iHits")+1 & "</td></tr>" & vbCRLF
			Response.Write "  <tr class=""tablelinemain""><td align=""center""><a href=""javascript:history.back(1)"">" & GetTranslation("LANG_BACK") & "</a></td></tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""		
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display all images for one category
	' IN  : iCategory (int) : image's category (table images, field iCategory)
	'     : iPage (int) : current page
	' OUT : -
	Sub DisplayImagesSearch(iCategory, iPage)
		Dim oCn, oRs, oRs2, rSQL, iLine, iNum, sTitleCat, iNbImages, iNbPages, X
		iNum = 0
		
		Set oCn = DBConnexion(DB_MAIN)
		
		If iCategory <> "" and iCategory <> 0 Then
			rSQL = "SELECT cTitle FROM categories WHERE cID=" & iCategory
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then sTitleCat = " - " & Server.HTMLEncode(oRs(0))
			
			rSQL = "SELECT Count(iID) FROM images WHERE iValid=True AND iCategory=" & iCategory
			Set oRs = DBRecordSet(oCn, rSQL)
			iNbImages = oRs(0)

			rSQL = "SELECT TOP " & GLOBAL_IMAGES_PAGE*iPage & " iID FROM images WHERE iValid=True AND iCategory=" & iCategory & " ORDER BY iDate"
			oRs.PageSize = GLOBAL_IMAGES_PAGE
			Set oRs = DBRecordSet(oCn, rSQL)
			If oRs.RecordCount <> - 1 Then
				oRs.AbsolutePage = iPage
			Else
				For X = 1 To (iPage-1)*GLOBAL_IMAGES_PAGE
					oRs.MoveNext
				Next
			End If

			If Not oRs.EOF Then
				CreateTopTable "ImagesByCategory", GetTranslation("LANG_IMAGES") & sTitleCat

				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				iLine = 1
				While Not oRs.EOF
					rSQL = "SELECT iTitle, iSourceSmall, iHits FROM images WHERE iID=" & oRs(0)
					Set oRs2 = DBRecordSet(oCn, rSQL)
					
					If iNum Mod 3 = 0 Then Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td align=""center"" width=""33%"">" & vbCRLF
					Response.Write "      <a href=""" & sURLPage & "?id=" & oRs(0) & "&page=" & iPage & """>"
					Response.Write "<img src=""" & Server.HTMLEncode(oRs2("iSourceSmall")) & """ border=""0"">"
					Response.Write "<br>" & Server.HTMLEncode(oRs2("iTitle")) & "</a>"
					Response.Write "<br><span class=""small"">" & oRs2("iHits") & " " & GetTranslation("LANG_HITS") & "</span>"
					Response.Write "</td>" & vbCRLF
					If iNum Mod 3 = 2 Then 
						Response.Write "  </tr>" & vbCRLF
						iLine = 1 + ((iLine-1) XOR 1)
					End If
					iNum = iNum + 1
					oRs.MoveNext
				WEnd
				Select Case (iNum Mod 3)
					Case 1 : Response.Write "<td width=""33%"">&nbsp</td><td width=""33%"">&nbsp</td></tr>" & vbCRLF
					Case 2 : Response.Write "<td width=""33%"">&nbsp</td></tr>" & vbCRLF
				End Select

				' pages managing
				iNbPages = iNbImages\GLOBAL_IMAGES_PAGE
				If iNbImages mod GLOBAL_IMAGES_PAGE Then iNbPages = iNbPages + 1
				If iNbPages > 1 Then
					Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
					Response.Write "    <td align=""center"" colspan=""3"">" & vbCRLF
					If iPage <> 1 Then Response.Write "      &nbsp;<a href=""" & sURLPage & "?cat=" & iCategory & "&page=" & iPage-1 & """>&lt;&lt;</a>" & vbCRLF
					For X = 1 To iNbPages
						If X <> iPage Then 
							Response.Write "      &nbsp;<a href=""" & sURLPage & "?cat=" & iCategory & "&page=" & X & """>" & X & "</a>" & vbCRLF
						Else
							Response.Write "&nbsp;<b>" & X & "</b>" & vbCRLF
						End If
					Next
					If iPage <> iNbPages Then Response.Write "      &nbsp;<a href=""" & sURLPage & "?cat=" & iCategory & "&page=" & iPage+1 & """>&gt;&gt;</a>" & vbCRLF
					Response.Write "    </td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
				End If

				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td align=""center"" colspan=""3"">" & GetTranslation("LANG_IMAGES") & " : " & iNum & "/" & iNbImages & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF

				CreateBottomTable ""
			End If
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display a navigation bar for images
	' IN  : iCategoryParent (int) : image's parent category (table categories, field cParent)
	' OUT : -
	Sub DisplayImagesNavigation(iCategoryParent)
		Dim oCn, oRs, oRs2, rSQL, iLine, iNum

		Set oCn = DBConnexion(DB_MAIN)
		
		If iCategoryParent = "" Then iCategoryParent = 0

		If iCategoryParent <> 0 Then
			rSQL = "SELECT cId, cParent, cTitle, cDescription, cImage FROM categories WHERE cID=" & iCategoryParent
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				CreateTopTable "DownloadCategory", CodeMessage(oRs("cTitle"), True)
				If oRs("cImage") <> "" Then
					Response.Write "<img src=""" & Server.HTMLEncode(oRs("cImage") & "") & """ border=""0"" align=""left"">"
				End If
				Response.Write CodeMessage(oRs("cDescription"), True)
				Response.Write "<br><br><a href=""" & sURLPage & "?cat=" & oRs("cParent") & """>" & GetTranslation("LANG_BACK") & "</a>" & vbCRLF
				CreateBottomTable ""
			End If
		End If

		rSQL = "SELECT cId, cTitle, cImage FROM categories WHERE cType=" & CATEGORY_TYPE_IMAGES & " and cParent=" & iCategoryParent & " ORDER BY cTitle"
		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Then
			If iCategoryParent = 0 Then
				CreateTopTable "SearchImagesCategories", GetTranslation("LANG_IMAGES") & " - " & GetTranslation("LANG_CATEGORIES")
			Else
				CreateTopTable "SearchImagesCategories", GetTranslation("LANG_IMAGES") & " - " & GetTranslation("LANG_SUB_CATEGORIES")
			End If
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			iLine = 1
			iNum = 0

			While Not oRs.EOF
				If iNum mod 2 = 0 Then Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				rSQL = "SELECT Count(iID) FROM images WHERE iValid=True AND iCategory=" & oRs("cID")
				Set oRs2 = DBRecordSet(oCn, rSQL)
				
				If oRs("cImage") <> "" Then
					Response.Write "    <td width=""50%"" align=""center""><a href=""" & sURLPage & "?cat=" & oRs("cID") & """><img src=""" & Server.HTMLEncode(oRs("cImage")) & """ border=""0"" alt=""" & oRs("cTitle") & """><br>" & Server.HTMLEncode(oRs("cTitle")) & " (" & oRs2(0) & ")</td>" & vbCRLF
				Else
					Response.Write "    <td width=""50%""><a href=""" & sURLPage & "?cat=" & oRs("cID") & """>" &  Server.HTMLEncode(oRs("cTitle")) & " (" & oRs2(0) & ")</td>" & vbCRLF
				End If

				If iNum mod 2 = 1 Then 
					Response.Write "  </tr>" & vbCRLF
					iLine = 1 + ((iLine-1) XOR 1)
				End If

				iNum = iNum + 1
				oRs.MoveNext
			WEnd
			If iNum mod 2 = 1 Then 
				Response.Write "    <td>&nbsp;</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
			End If
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
		Set oRs2= Nothing
	End Sub

	' Display a line to let users post their images
	' IN  : iCat : download category
	' OUT : -
	Sub DisplayAddImages(iCat)
		If sPseudo <> "" Then
			CreateTable "AddMemberImages", "", "<a href=""" & GLOBAL_SITE_IMAGES_PAGE & "?do=new&cat=" & iCat & """>" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_IMAGES") & "</a>", ""
		End If
	End Sub

	' Display edit member's image's form
	' IN  : iCat (int) : image's category (table images, field iCategory)
	' OUT : -
	Sub EditMemberImage(iCat)
		Dim oCn, oRs, rSQL

		If sPseudo <> "" Then
			Set oCn = DBConnexion(DB_MAIN)

			rSQL = "SELECT cID, cTitle FROM categories WHERE cType=" & CATEGORY_TYPE_IMAGES
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function confirmDo()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
				Response.Write "     {" & vbCRLF
				Response.Write "       document.edition.submit();" & vbCRLF
				Response.Write "     }" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "  function openSmallPicture()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "	var sMyPicture = document.edition.iSourceSmall.value;" & vbCRLF
				Response.Write "    if (sMyPicture != '')"
				Response.Write "	{" & vbCRLF
				Response.Write "		window.open('" & GLOBAL_SITE_PATH & GLOBAL_SITE_VIEW_IMAGE_PAGE & "?img=' + sMyPicture, 'Picture', 'width=500,height=100,menubar=no,resizable=yes');" & vbCRLF
				Response.Write "	}" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "  function openNormalPicture()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "	var sMyPicture = document.edition.iSourceNormal.value;" & vbCRLF
				Response.Write "    if (sMyPicture != '')"
				Response.Write "	{" & vbCRLF
				Response.Write "		window.open('" & GLOBAL_SITE_PATH & GLOBAL_SITE_VIEW_IMAGE_PAGE & "?img=' + sMyPicture, 'Picture', 'width=500,height=100,menubar=no,resizable=yes');" & vbCRLF
				Response.Write "	}" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "Edit", GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_IMAGE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & "?cat=" & iCat & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value=""add"">" & vbCRLF
				Response.Write "<input type=""hidden"" name=""iID"" value=""0"">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td width=""150"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td><input name=""iTitle"" value="""" maxlength=""50"" size=""50"" class=""cell""></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
				Response.Write "    <td>" & GetDateDDMMYYYY(Now()) & "<input type=""hidden"" name=""iDate"" value=""" & DateTimeToString(Now()) & """></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
				Response.Write "    <td><textarea name=""iDescription"" cols=""50"" rows=""3"" class=""cell""></textarea></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_URL") & " " & GetTranslation("LANG_THUMBNAIL") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF
				Response.Write "      <input name=""iSourceSmall"" value=""http://"" maxlength=""250"" size=""50"" class=""cell"">" & vbCRLF
				Response.Write "      <a href=""javascript:openSmallPicture()""><img src=""" & GLOBAL_SITE_IMAGES_PATH & "view.gif"" border=""0""></a>" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_URL") & " " & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF
				Response.Write "      <input name=""iSourceNormal"" value=""http://"" maxlength=""250"" size=""50"" class=""cell"">" & vbCRLF
				Response.Write "      <a href=""javascript:openNormalPicture()""><img src=""" & GLOBAL_SITE_IMAGES_PATH & "view.gif"" border=""0""></a>" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF	
				Response.Write "      <select name=""iCategory"" class=""cell"">" & vbCRLF

				While Not oRs.EOF
					Response.Write "        <option value=""" & oRs("cID") & """"
					If oRs("cID") = iCat Then Response.Write " selected"
					Response.Write ">" & Server.HTMLEncode(oRs("cTitle")) & "</option>" & vbCRLF
					oRs.MoveNext
				WEnd
				Response.Write "      </select>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF
				Response.Write "      <select name=""iVersion"" class=""cell"">" & vbCRLF
		
				rSQL = "SELECT vID, vCode FROM Versions ORDER BY vCode"
				Set oRs = DBRecordSet(oCn, rSQL)
		
				While Not oRs.EOF
					Response.Write "        <option value=""" & oRs("vID") & """"
					If oRs("vCode") = sXMLVersion Then Response.Write " selected"
					Response.Write ">" & oRs("vCode") & "</option>" & vbCRLF
					oRs.MoveNext
				WEnd

				Response.Write "      </select>" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2""><input type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""confirmDo();"" id=1 name=1></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
			
			oCn.Close
			Set oCn = Nothing
			Set oRs = Nothing
		End If
	End Sub

	' Add member's image (insert query)
	' IN  : sTitle (string) : image's title (table images, field iTitle)
	'     : sDate (string) : image add date (table images, field iDate)
	'     : sDescription (string) : image's description (table images, field iDescription)
	'     : sSourceSmall (string) : image's source for thumbnail (table images, field iSourceSmal)
	'     : sSourceNormal (string) : image's source (table images, field iSourceNormal)
	'     : iHits (int) : number of times where image has been viewed (table images, field iHits)
	'     : iCategory (int) : image's category (table images, field iCategory)
	'     : iVersion (int) : image's version language (table images, field iVersion)
	' OUT : (boolean) : True if added
	Function AddMemberImage(sTitle, sDate, sDescription, sSourceSmall, sSourceNormal, iHits, iCategory, iVersion)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "INSERT INTO images (iTitle, iDate, iDescription, iSourceSmall, iSourceNormal, iHits, iCategory, iVersion, iValid) VALUES ('" & SQLEncrypt(sTitle) & "', '" & sDate & "', '" & SQLEncrypt(sDescription) & "', '" & SQLEncrypt(sSourceSmall) & "', '" & SQLEncrypt(sSourceNormal) & "', 0, " & iCategory & ", " & iVersion & ", 0)"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		AddMemberImage = True
	End Function

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoImagesPage()
		If Request.Form("do") = "add" and Request.Form("iTitle") <> "" Then
			If AddMemberImage(Request.Form("iTitle"), Request.Form("iDate"), Request.Form("iDescription"), Request.Form("iSourceSmall"), Request.Form("iSourceNormal"), 0, Request.Form("iCategory"), Request.Form("iVersion")) Then
				sInfoPage = GetTranslation("LANG_IMAGES") & " - " & GetTranslation("LANG_ADD_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_IMAGES") & " - " & GetTranslation("LANG_ADD_ERROR")
			End If
		End If
	End Sub

	' Display page
	' IN  : -
	' OUT : -
	Sub DisplayImagesPage()
		Dim iCat, iPage, iImage
		
		iCat = Request.QueryString("cat")
		If IsNumeric(iCat) and iCat <> "" Then
			iCat = CInt(iCat)
		Else
			iCat = 0
		End If

		iPage = Request.QueryString("page")
		If IsNumeric(iPage) and iPage <> "" Then
			iPage = CInt(iPage)
		Else
			iPage = 1
		End If
		
		iImage = Request.QueryString("id")

		DisplayImagesNavigation(iCat)

		If iImage <> "" Then
			DisplayImage(iImage), iPage
		ElseIf iCat <> 0 Then
			If Request.QueryString("do") = "new" Then
				EditMemberImage(iCat)
			Else
				DisplayAddImages(iCat)
				DisplayImagesSearch iCat, iPage
			End If
		Else
			DisplayTopImages GLOBAL_IMAGES_TOP
		End If		
	End Sub
%>