<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display a navigation's bar for searching members
	Sub DisplayMembersListNavigation()
		Dim X

		CreateTopTable "SearchMembers", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_MEMBERS")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <form name=""Search"" method=""get"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "    <input type=""hidden"" name=""Do"" value=""search"">" & vbCRLF
		Response.Write "    <td>"
		Response.Write "&nbsp;<a href=""" & sURLPage & """>" & GetTranslation("LANG_TOP") & "</a>" & vbCRLF
		For X = 0 to 25
			Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=" & Chr(Asc("a")+X) & """>" & Chr(Asc("a")+X) & "</a>" & vbCRLF
		Next
		Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=0"">0-9</a>" & vbCRLF
		Response.Write "    &nbsp;<input name=""name"" size=""10"" maxlength=""20"" class=""cell"" onEnter=""javascript:document.search.submit()""></td>"
		Response.Write "    </form>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
	End Sub

	' Display top last members
	Sub DisplayTopLastMembers(iTop)
		Dim oCn, oRs, rSQL, iLine
		Dim bDisplayProfil, sMyLogin, sURL, sEmail
		
		If iTop = "" or iTop <= 0 Then iTop = 1

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "SELECT TOP " & iTop & " uLogin, uEmail, uURL, uProfile FROM users ORDER BY uDate DESC"
		Set oRs = DBRecordSet(oCn, rSQL)	

		If Not oRs.EOF Then
			CreateTopTable "TopMembers", GetTranslation("LANG_TOP") & " - " & GetTranslation("LANG_MEMBERS")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""150"">" & GetTranslation("LANG_LOGIN") & "</td>" & vbCRLF
			Response.Write "    <td width=""200"">" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				bDisplayProfil = oRs("uProfile").Value
				sMyLogin = oRs("uLogin")
				sURL = oRs("uURL")
				sEmail = oRs("uEmail")
				
				' Force view if admin
				If IsAuthorized(ROLE_ADMIN) Then bDisplayProfil = True
				
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td><a href=""" & GLOBAL_SITE_PROFILE_PAGE & "?id=" & Server.URLEncode(sMyLogin) & """>" & Server.HTMLEncode(sMyLogin) & "</a></td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF
				If sEmail <> "" and bDisplayProfil Then
					Response.Write "<a href=""mailto:" & Server.HTMLEncode(sEmail) & """>" & Server.HTMLEncode(sEmail) & "</a>"
				Else
					Response.Write "-"
				End If
				Response.Write "</td>" & vbCRLF
				Response.Write "    <td>"
				If sURL <> "" and bDisplayProfil Then
					If Left(LCase(sURL), 7) <> "http://" Then sURL = "http://" & sURL
					Response.Write "<a href=""" & Server.HTMLEncode(sURL) & """ target=""_blank"">" & Server.HTMLEncode(sURL) & "</a>"
				Else
					Response.Write "-"
				End If
				Response.Write "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = ((iLine-1) XOr 1) + 1
				oRs.MoveNext
			WEnd
			
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display search's result on members list
	' IN  : sQuery (string) : query data
	' OUT : -
	Sub DisplayMembersListSearch(sQuery)
		Dim oCn, oRs, rSQL, iLine, iNum
		Dim bDisplayProfil, sMyLogin, sURL, sEmail

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT uLogin, uEmail, uURL, uProfile FROM users WHERE uLogin LIKE '" & SQLEncrypt(sQuery) & "%' ORDER BY uLogin"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "SearchMembers", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_MEMBERS") & " (" & Server.HTMLEncode(Replace(sQuery, "%", "")) & ")"
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td width=""150"">" & GetTranslation("LANG_LOGIN") & "</td>" & vbCRLF
		Response.Write "    <td width=""200"">" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF

		iLine = 1
		iNum = 0
		While Not oRs.EOF
			bDisplayProfil = oRs("uProfile").Value
			sMyLogin = oRs("uLogin")
			sURL = oRs("uURL")
			sEmail = oRs("uEmail")

			' Force view if admin
			If IsAuthorized(ROLE_ADMIN) Then bDisplayProfil = True

			Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
			Response.Write "    <td><a href=""" & GLOBAL_SITE_PROFILE_PAGE & "?id=" & Server.URLEncode(sMyLogin) & """>" & Server.HTMLEncode(sMyLogin) & "</a></td>" & vbCRLF
			Response.Write "    <td>" & vbCRLF
			If sEmail <> "" and bDisplayProfil Then
				Response.Write "<a href=""mailto:" & Server.HTMLEncode(sEmail) & """>" & Server.HTMLEncode(sEmail) & "</a>"
			Else
				Response.Write "-"
			End If
			Response.Write "</td>" & vbCRLF
			Response.Write "    <td>"
			If sURL <> "" and bDisplayProfil Then
				If Left(LCase(sURL), 7) <> "http://" Then sURL = "http://" & sURL
				Response.Write "<a href=""" & Server.HTMLEncode(sURL) & """ target=""_blank"">" & Server.HTMLEncode(sURL) & "</a>"
			Else
				Response.Write "-"
			End If
			Response.Write "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
				
			iLine = ((iLine-1) XOr 1) + 1
			iNum = iNum + 1
			oRs.MoveNext
		WEnd

		'Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		'Response.Write "    <td colspan=""3"">" & GetTranslation("LANG_ACC0UNTS_TOTAL") & " : " & iNum & "</td>" & vbCRLF
		'Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display list members' page
	' IN  : -
	' OUT : -
	Sub DisplayMembersListPage()
		Dim sQuery

		DisplayMembersListNavigation

		If Request.QueryString("do") = "search" Then 
			sQuery = Request.QueryString("name")
			If Len(sQuery) = 1 Then
				If sQuery <> "0" Then
					DisplayMembersListSearch sQuery & "%"
				Else
					DisplayMembersListSearch "[0-9]%"
				End If
			ElseIf Len(sQuery) > 1 Then
				DisplayMembersListSearch sQuery & "%"
			End If
		Else
			DisplayTopLastMembers 10
		End If
		
		CreateTable "Information", "", GetTranslation("LANG_MEMBERS_DESC"), ""
	End Sub	
%>