<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' !!! Important !!! Don't remove this code
	' Used to count any vote if valid
	If Request.Form("poll") <> "" and Request.Cookies("poll_" & Request.Form("poll")) <> "OK" Then
		AddPollResult Request.Form("poll"), Request.Form("result")
	End If

	' Add a vote
	' IN  : iPollID (int) : poll's id (table polls, field pID)
	'     : iResultID (int) : choice's id (table pollsresults, field prID)
	' OUT : -
	Sub AddPollResult(iPollID, iResultID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "UPDATE pollsresults SET prHits=prHits+1 WHERE prPoll=" & iPollID & " AND prID=" & iResultID
		DBExecute oCn, rSQL
		
		Response.Cookies("poll_" & iPollID) = "OK"
		Response.Cookies("poll_" & iPollID).Expires = Date+7

		oCn.Close
		Set oCn = Nothing
	End Sub
	
	' Display a poll
	' IN  : iID (int) : poll's id (table polls, field pID)
	'     : bIsInColumn (boolean) : change the display if poll is displayed in a column (small caps, displays a title (LANG_POLL))
	' OUT : -
	Sub DisplayPoll(iID, bIsInColumn)
		Dim oCn, oRs, rSQL, nbVotes, MaxHits, iTdWidth, iLine, sPrefix, sPrefixSpan, sSuffixSpan

		Set oCn = DBConnexion(DB_MAIN)

		nbVotes = 0
		MaxHits = 0
		sPrefix = ""
		If bIsInColumn Then
			sPrefixSpan = "<span class=""small"">"
			sSuffixSpan = "</span>"
		Else
			sPrefixSpan = ""
			sSuffixSpan = ""
		End If

		rSQL = "SELECT Sum(prHits), Max(prHits) FROM pollsresults WHERE prPoll=" & iID
		Set oRs = DBRecordSet(oCn, rSQL)

		nbVotes = oRs(0)
		MaxHits = oRs(1)
		If MaxHits <= 0 Then MaxHits = 1

		rSQL = "SELECT * FROM polls, pollsresults WHERE pID=prPoll AND pValid=1 AND pID=" & iID

		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then
			Response.Write "	  <a name=""poll_" & iID & """>" & vbCRLF
			If bIsInColumn Then
				CreateTopTable "poll_" & iID, GetTranslation("LANG_POLL")
				sPrefix = "_"
			Else
				CreateTopTable "poll_" & iID, ""
			End If
			If Request.Cookies("poll_" & iID) = "OK" or Request.QueryString("results") <> "" Then 
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""center"">" & sPrefixSpan &  Server.HTMLEncode(oRs("pTitle")) & sSuffixSpan & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				While Not oRs.EOF
					iTdWidth = Round(100*(oRs("prHits")/MaxHits))
					Response.Write "  <tr>" & vbCRLF
					Response.Write "    <td>" & sPrefixSpan & Server.HTMLEncode(oRs("prText")) & " (<b>" & oRs("prHits") & "</b>)" & sSuffixSpan & "<br>" & vbCRLF
					Response.Write "      <table width=""100%"" cellspacing=""0"" cellpadding=""0"">" & vbCRLF
					Response.Write "        <tr><td width=""" & iTdWidth & "%"" bgcolor=""" & oRs("pColor") & """><img src=""imgs/blank.gif"" height=""10"" border=""0""></td><td width=""" & 100-iTdWidth & "%""></td></tr>" & vbCRLF
					Response.Write "      </table>" & vbCRLF
					Response.Write "    </td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF

					oRs.MoveNext
				WEnd
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""center"">" & sPrefixSpan
				If Request.QueryString("results") <> "" Then Response.Write "<a href=""javascript:history.back()"">" & GetTranslation("LANG_POLL_VOTE") & "</a><br>"
				Response.Write GetTranslation("LANG_VOTES") & " : " & nbVotes & sSuffixSpan & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
			Else
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  var bCanVote_" & sPrefix & iID & " = false;" & vbCRLF
				Response.Write "  function votePoll_" & sPrefix & iID & "()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    if (bCanVote_" & sPrefix & iID & ")" & vbCRLF
				Response.Write "    {" & vbCRLF
				Response.Write "      document.poll_" & sPrefix & iID & ".submit();" & vbCRLF
				Response.Write "    }" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "  function voteOk_" & sPrefix & iID & "()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    bCanVote_" & sPrefix & iID & " = true;" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""poll_" & sPrefix & iID & """ method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""poll"" value=""" & iID & """>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""center"">" & sPrefixSpan & Server.HTMLEncode(oRs("pTitle")) & sSuffixSpan & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1
				While Not oRs.EOF
					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td width=""25""><input type=""radio"" name=""result"" onClick=""javascript:voteOk_" & sPrefix & iID & "()"" value=""" & oRs("prID") & """></td>" & vbCRLF
					Response.Write "    <td>" & sPrefixSpan & Server.HTMLEncode(oRs("prText")) & sSuffixSpan & "</td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
					
					iLine = 1 + ((iLine-1) XOR 1)
					oRs.MoveNext
				WEnd
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""center"">" & sPrefixSpan & "<a href=""javascript:votePoll_" & sPrefix & iID & "()"">" & GetTranslation("LANG_POLL_VOTE") & "</a>&nbsp;&nbsp;-&nbsp;&nbsp;<a href=""" & sURLPage & "?poll=" & iID & "&results=1"">" & GetTranslation("LANG_POLL_RESULTS") & "</a><br>" & GetTranslation("LANG_VOTES") & " : " & nbVotes & sSuffixSpan & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
			End If
			CreateBottomTable ""
		Else
			CreateTable "NoPoll", GetTranslation("LANG_POLLS"), GetTranslation("LANG_EMPTY_SECTION"), ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing		
	End Sub
	
	' Display the top polls (by Date)
	' IN  : iTop (int) : number of results wanted
	' OUT : -
	Sub DisplayTopPolls(iTop)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If iTop <> "" and IsNumeric(iTop) Then
			rSQL = "SELECT TOP " & iTop & " pID FROM polls, versions WHERE pDateBegin <= '" & DateTimeToString(Now()) & "' AND (pDateEnd >= '" & DateTimeToString(Now()) & "' OR pDateEnd < pDateBegin) AND pValid=1 AND pVersion=vID"
		Else
			rSQL = "SELECT pID FROM polls, versions WHERE pDateBegin <= '" & DateTimeToString(Now()) & "' AND (pDateEnd >= '" & DateTimeToString(Now()) & "' OR pDateEnd < pDateBegin) AND pValid=1 AND pVersion=vID"
		End If
		If sXMLVersion <> "" Then rSQL = rSQL & " AND vCode='" & SQLEncrypt(sXMLVersion) & "'"
		rSQL = rSQL & " ORDER BY pDateBegin DESC, pDateEnd DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then 
			While Not oRs.EOF
				DisplayPoll oRs("pID"), False
				oRs.MoveNext
			WEnd
		Else
			CreateTable "Poll", GetTranslation("LANG_POLL"), GetTranslation("LANG_EMPTY_SECTION"), ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	Sub DisplayLastPoll()
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT TOP 1 pID FROM polls, versions WHERE pDateBegin <= '" & DateTimeToString(Now()) & "' AND (pDateEnd >= '" & DateTimeToString(Now()) & "' OR pDateEnd < pDateBegin) AND pValid=1 AND pVersion=vID"
		If sXMLVersion <> "" Then rSQL = rSQL & " AND vCode='" & SQLEncrypt(sXMLVersion) & "'"
		rSQL = rSQL & " ORDER BY pDateBegin DESC, pDateEnd DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then DisplayPoll oRs("pID"), True

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub
%>