<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display a website's information
	' IN  : iID (int) : website's id (table directory, field dID)
	' OUT : -
	Sub DisplayAdminDirectorySite(iID)
		Dim oCn, oRs, oRs2, rSQL
		
		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT * FROM directory WHERE dID=" & iID
		
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				rSQL = "SELECT uHits FROM urls WHERE uUrl LIKE '%" & Replace(LCase(oRs("dURL")), "http://", "") & "%'"
				Set oRs2 = DBRecordSet(oCn, rSQL)
				CreateTopTable "Site_" & iID, Server.HTMLEncode(oRs("dTitle"))
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td width=""120"">" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("dAuthor")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
				Response.Write "    <td><a href=""" & GLOBAL_SITE_MAIL_PAGE & "?to=" & Server.HTMLEncode(oRs("dEmail")) & """>" & Server.HTMLEncode(oRs("dEmail")) & "</a></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("dDescription")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td width=""120"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
				Response.Write "    <td>"
				If Not oRs2.EOF Then
					Response.Write oRs2("uHits")
				Else
					Response.Write "0"
				End If
				Response.Write "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
				Response.Write "    <td><a href=""" & Server.HTMLEncode(oRs("dURL")) & """ target=""_blank"">" & Server.HTMLEncode(oRs("dURL")) & "</a></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
				Response.Write "    <td>" & GetDateDDMMYYHHMMSS(StringToDate(oRs("dDate"))) & "</a></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
				Response.Write "    <td>" & oRs("dValid") & "</a></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
		Set oRs2= Nothing
	End Sub

	' Display all sites by category
	' IN  : iCat (int) : selected category
	' OUT : -
	Sub DisplayAdminDirectorySites(iCat)
		Dim oCn, oRs, rSQL, iLine
		
		Set oCn = DBConnexion(DB_MAIN)
		
		If iCat <> "" and iCat <> 0 Then
			rSQL = "SELECT dID, dTitle, dURL, vCode FROM directory, versions WHERE dVersion=vID AND dCategory=" & iCat
			Set oRs = DBRecordSet(oCn, rSQL)
			
			CreateTopTable "CategorySites", GetTranslation("LANG_SITES")
	
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""120"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td >" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
			Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
			Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("dTitle")) & "</td>" & vbCRLF
				Response.Write "    <td><a href=""" & Server.HTMLEncode(oRs("dURL")) & """ target=""_blank"">" & Server.HTMLEncode(oRs("dURL")) & "</a></td>" & vbCRLF
				Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("vCode")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & vbCRLF
				MenuAdmin(oRs("dID") & "&cat=" & iCat)
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				oRs.MoveNext
			WEnd
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""4"">" & vbCRLF
			Response.Write "      <a href=""" & sURLPage & "?cat=" & iCat & "&do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_SITE") & "</a>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
				
			Response.Write "</table>" & vbCRLF
				
			CreateBottomTable ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display all sites queued for validation
	' IN  : -
	' OUT : -
	Sub DisplayAdminDirectorySitesToValidate()
		Dim oCn, oRs, rSQL, iLine
		
		Set oCn = DBConnexion(DB_MAIN)
		
		rSQL = "SELECT dID, dTitle, dURL, vCode FROM directory, Versions WHERE dVersion=vID AND dValid=0 ORDER BY dDate DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then
			CreateTopTable "SitesToValidate", GetTranslation("LANG_SITES") & " - " & GetTranslation("LANG_TO_VALIDATE")
	
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""120"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td >" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
			Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
			Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("dTitle")) & "</td>" & vbCRLF
				Response.Write "    <td><a href=""" & Server.HTMLEncode(oRs("dURL")) & """ target=""_blank"">" & Server.HTMLEncode(oRs("dURL")) & "</a></td>" & vbCRLF
				Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("vCode")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & vbCRLF
				MenuAdmin oRs("dID")
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) Xor 1)

				oRs.MoveNext
			WEnd				
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display subcategories
	' IN  : iCat (int) : parent category
	' OUT : -
	Sub DisplayAdminDirectoryCategories(iCat)
		Dim oCn, oRs, rSQL, sSectionTitle, iLine
		Dim iNbCat
		iNbCat = 0
		
		Set oCn = DBConnexion(DB_MAIN)

		' cParent (=iCat) = 0 correspond au niveau racine
		If iCat = "" Then iCat = 0

		If iCat <> 0 Then
			sSectionTitle = GetTranslation("LANG_SUB_CATEGORIES")
			rSQL = "SELECT cTitle, cDescription, cParent FROM Categories WHERE cID=" & iCat & " AND cType=" & CATEGORY_TYPE_DIRECTORY & " ORDER BY cTitle"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				CreateTopTable "Category", GetTranslation("LANG_CATEGORY")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td width=""100"">" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("cTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td width=""100"">" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("cDescription")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2""><a href=""" & sURLPage & "?cat=" & oRs("cParent") & """>" & GetTranslation("LANG_DIRECTORY_BACK") & "</a></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2""><a href=""" & sURLPage & "?cat=" & iCat & "&iscat=1&do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_CATEGORY") & "</a></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		Else
			sSectionTitle = GetTranslation("LANG_DIRECTORY")
		End If

		rSQL = "SELECT cID, cTitle, cDescription FROM Categories WHERE cParent=" & iCat & " AND cType=" & CATEGORY_TYPE_DIRECTORY
		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Or iCat = 0 Then
			CreateTopTable "Directory", sSectionTitle
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
			Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				iNbCat = iNbCat + 1
				
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td><a href=""" & sURLPage & "?cat=" & oRs("cID") & """>" & Server.HTMLEncode(oRs("cTitle")) & "</a></td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("cDescription")) & "</a></td>" & vbCRLF
				Response.Write "    <td align=""center"">" & vbCRLF
				MenuAdmin(oRs("cID") & "&cat=" & iCat & "&iscat=1")
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				oRs.MoveNext
			WEnd

			If iCat = 0 Then
				rSQL = "SELECT Count(dID) FROM directory WHERE dValid=True"
				Set oRs = DBRecordSet(oCn, rSQL)
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""3"">" & GetTranslation("LANG_DIRECTORY_TOTAL") & " : " & oRs(0) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""3""><a href=""" & sURLPage & "?cat=" & iCat & "&iscat=1&do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_CATEGORY") & "</a></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
			End If

			Response.Write "</table>" & vbCRLF

			CreateBottomTable ""
		End If
	
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Edit category (to add or modify)
	' IN  : iID (int) : category's id (table categories, field cID) if null or = 0 then add
	'     : iCat (int) : parent category
	' OUT : -
	Sub EditDirectoryCategory(iID, iCat)
		Dim oCn, oRs, rSQL
		Dim sEditTitle, sDo, sTitle, sDescription, iParent
	
		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sDo = "updt"
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_CATEGORY")
			rSQL = "SELECT cTitle, cDescription, cParent FROM Categories WHERE cID=" & iID & " AND cType=" & CATEGORY_TYPE_DIRECTORY
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sTitle = oRs("cTitle")
				sDescription = oRs("cDescription")
				iParent = oRs("cParent")
			End If
		Else
			sDo = "add"
			sEditTitle = GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_CATEGORY")
			iParent = iCat
		End If

		CreateTopTable "EditCategory", sEditTitle
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "')) document.edition.submit();" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.write "<form name=""Category"" method=""post"" action=""" & sURLPage & "?cat=" & iCat & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""cID"" value=""" & iID & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLf
		Response.Write "    <td width=""120"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input type=""text"" name=""cTitle"" size=""20"" maxlength=""50"" value=""" & Server.HTMLEncode(sTitle) & """ class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""cDescription"" cols=""40"" rows=""3"" class=""cell"">" & HTML2Text(sDescription) & "</textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_PARENT_CATEGORY") & "</td>" & vbCRLF
		Response.Write "    <td>"
		Response.Write "      <select name=""cParent"" class=""cell"">" & vbCRLF
		Response.Write "        <option value=""0"""
		If iParent = 0 Then Response.Write " selected"
		Response.Write ">-</option>" & vbCRLF

		rSQL = "SELECT cID, cTitle FROM Categories WHERE cType=" & CATEGORY_TYPE_DIRECTORY & " ORDER BY cTitle"
		Set oRs = DBRecordSet(oCn, rSQL)
		While Not oRs.EOF
			Response.Write "        <option value=""" & oRs("cID") & """"
			If CInt(iParent) = oRs("cID") Then Response.Write " selected"
			Response.Write ">" & Server.HTMLEncode(oRs("cTitle")) & "</option>" & vbCRLF
			
			oRs.MoveNext
		WEnd

		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2"" align=""right""><input type=""submit"" name=""submit"" class=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Edit website (to add or modify)
	' IN  : iID (int) : website's id (table directory, field dID) if null or = 0 then add
	'     : iCat (int) : parent category
	' OUT : -
	Sub EditDirectorySite(iID, iCat)
		Dim oCn, oRs, rSQL
		Dim sEditTitle, sDo, sTitle, sAuthor, sAuthorEmail, sDescription, dDate, sURL, iVersion, iCategory, bValide
		bValide = True

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sDo = "updt"
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_SITE")
			rSQL = "SELECT * FROM directory WHERE dID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sTitle = oRs("dTitle")
				sAuthor = oRs("dAuthor")
				sAuthorEmail = oRs("dEmail")
				sDescription = oRs("dDescription")
				dDate = StringToDate(oRs("dDate"))
				sURL = oRs("dURL")
				iVersion = oRs("dVersion")
				iCategory = oRs("dCategory")
				bValide = oRs.Fields("dValid").Value
			End If
		Else
			sDo = "add"
			sEditTitle = GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_SITE")
			iVersion = 1
			iCategory = CInt(iCat)
			sAuthor = sPseudo
			sAuthorEmail = sEmail
			sURL = "http://"
			dDate = Now()
			bValide = False
		End If

		CreateTopTable "EditSite", sEditTitle
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
		Response.Write "     {" & vbCRLF
		Response.Write "       document.edition.submit();" & vbCRLF
		Response.Write "     }" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" action=""" & sURLPage & "?cat=" & iCat & """ method=""post"">" & vbCRLF
		Response.Write "<input type=""hidden"" name=""dID"" value=""" & iID & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""dTitle"" value=""" & Server.HTMLEncode(sTitle) & """ size=""20"" maxlength=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""dAuthor"" value=""" & Server.HTMLEncode(sAuthor) & """ size=""20"" maxlength=""20"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""dEmail"" value=""" & Server.HTMLEncode(sAuthorEmail) & """ size=""20"" maxlength=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""dDescription"" class=""cell"" rows=""3"" cols=""40"">" & Server.HTMLEncode(sDescription) & "</textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""dURL"" value=""" & Server.HTMLEncode(sURL) & """ size=""50"" maxlength=""100"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""dCategory"" class=""cell"">" & vbCRLF
		
		rSQL = "SELECT cID, cTitle FROM categories WHERE cType=" & CATEGORY_TYPE_DIRECTORY & " ORDER BY cTitle"
		Set oRs = DBRecordSet(oCn, rSQL)
		While Not oRs.EOF
			Response.Write "        <option value=""" & oRs("cID") & """"
			If iCategory = oRs("cID") Then Response.Write " selected"
			Response.Write ">" & oRs("cTitle") & "</option>" & vbCRLF
			oRs.MoveNext
		WEnd

		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""dVersion"" class=""cell"">" & vbCRLF
		
		rSQL = "SELECT vID, vCode FROM Versions ORDER BY vCode"
		Set oRs = DBRecordSet(oCn, rSQL)
		While Not oRs.EOF
			Response.Write "        <option value=""" & oRs("vID") & """"
			If iVersion = oRs("vID") Then Response.Write " selected"
			Response.Write ">" & oRs("vCode") & "</option>" & vbCRLF
			oRs.MoveNext
		WEnd

		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
	
		If IsAuthorized(ROLE_NEWS) Then
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			Response.Write "    <td>" & GetDateDDMMYYHHMMSS(dDate) & "<input type=""hidden"" name=""dDate"" value=""" & dDate & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
			Response.Write "    <td><input type=""checkbox"" name=""dValid"""
			If bValide Then	Response.Write " checked"
			Response.Write "></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			If Not bValide Then
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_SENDMAIL") & "</td>" & vbCRLF
				Response.Write "    <td><input name=""dSendIt"" type=""checkbox"" value=""on""></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
			End If
		Else
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td colspan=""2"">" & GetTranslation("LANG_ADD_USER_SITE") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "    <input type=""hidden"" name=""dDate"" value=""" & dDate & """>" & vbCRLF
			Response.Write "    <input type=""hidden"" name=""dValid"" value="""">" & vbCRLF
		End If

		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""confirmDo();""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add website (insert query)
	' IN  : sTitle (string) : website's name (table directory, field dTitle)
	'     : sAuthor (string) : website's author or poster (table directory, field dAuthor)
	'     : sAuthorEmail (string) : website's author or poster's email (table directory, field dEmail)
	'     : sDescription (string) : website's description (table directory, field dDescription)
	'     : sURL (string) : website's url (table directory, field dURL)
	'     : dDate (datetime) : website's post date (table directory, field dDate)
	'     : iCategory (int) : website's category (table directory, field dCategory)
	'     : iVersion (int) : website's version language (table directory, field dVersion)
	'     : bValid (boolean) : website's validation (table directory, field dValid)
	' OUT : (boolean) : True if added
	Function AddDirectorySite(sTitle, sAuthor, sAuthorEmail, sDescription, sURL, dDate, iCategory, iVersion, bValide)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "INSERT INTO directory (dTitle, dAuthor, dEmail, dDescription, dURL, dCategory, dDate, dVersion, dValid) VALUES ('" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sAuthor) & "', '" & SQLEncrypt(sAuthorEmail) & "', '" & SQLEncrypt(sDescription) & "', '" & SQLEncrypt(sURL) & "', " & iCategory & ", '" & DateTimeToString(dDate) & "', " & iVersion & ", " & bValide & ")"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		AddDirectorySite = True
	End Function

	' Modify website (update query)
	' IN  : iID (int) : website's id (table directory, field dID)
	'     : sTitle (string) : website's name (table directory, field dTitle)
	'     : sAuthor (string) : website's author or poster (table directory, field dAuthor)
	'     : sAuthorEmail (string) : website's author or poster's email (table directory, field dEmail)
	'     : sDescription (string) : website's description (table directory, field dDescription)
	'     : sURL (string) : website's url (table directory, field dURL)
	'     : dDate (datetime) : website's post date (table directory, field dDate)
	'     : iCategory (int) : website's category (table directory, field dCategory)
	'     : iVersion (int) : website's version language (table directory, field dVersion)
	'     : bValid (boolean) : website's validation (table directory, field dValid)
	' OUT : (boolean) : True if added
	Function ModifyDirectorySite(iID, sTitle, sAuthor, sAuthorEmail, sDescription, sURL, dDate, iCategory, iVersion, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE directory SET dTitle='" & SQLEncrypt(sTitle) & "', dAuthor='" & SQLEncrypt(sAuthor) & "', dEmail='" & SQLEncrypt(sAuthorEmail) & "', dDescription='" & SQLEncrypt(sDescription) & "', dURL='" & SQLEncrypt(sURL) & "', dDate='" & DateTimeToString(dDate) & "', dCategory=" & iCategory & ", dVersion=" & iVersion & ", dValid=" & bValid & " WHERE dID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		ModifyDirectorySite = True
	End Function

	' Delete website (delete query)
	' IN  : iID (int) : website's id (table directory, field dID)
	' OUT : (boolean) : True if deleted
	Function DeleteDirectorySite(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "DELETE FROM directory WHERE dID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		DeleteDirectorySite = True
	End Function

	' Display deleting page
	' IN  : iID (int) : website's id
	' OUT : -
	Sub ConfirmDeleteDirectorySite(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT * FROM directory WHERE dID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delSite()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "ConfirmDel", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""dID"" value=""" & oRs("dID") & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td><td>" & Server.HTMLEncode(oRs("dTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td><td>" & Server.HTMLEncode(oRs("dDescription")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_URL") & "</td><td>" & Server.HTMLEncode(oRs("dURL")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=""button"" onClick=""javascript:delSite();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=""button"" onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add a new category (insert query)
	' IN  : sTitle (string) : category's name (table category, field cTitle)
	'     : sDescription (string) : category's description (table category, field cDescription)
	'     : iParent (int) : category's parent (table category, field cParent) If = 0 then main category !
	' OUT : (boolean) : True if added
	Function AddDirectoryCategory(sTitle, sDescription, iParent)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "INSERT INTO Categories (cTitle, cDescription, cParent, cImage, cType) VALUES ('" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sDescription) & "', " & iParent & ", '', " & CATEGORY_TYPE_DIRECTORY & ")"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		AddDirectoryCategory = True
	End Function

	' Modify category (update query)
	' IN  : iID (int) : category's id (table category, field cID)
	'     : sTitle (string) : category's name (table category, field cTitle)
	'     : sDescription (string) : category's description (table category, field cDescription)
	'     : iParent (int) : category's parent (table category, field cParent) If = 0 then main category !
	' OUT : (boolean) : True if modified
	Function ModifyDirectoryCategory(iID, sTitle, sDescription, iParent)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE Categories SET cTitle='" & SQLEncrypt(sTitle) & "', cDescription='" & SQLEncrypt(sDescription) & "', cParent=" & iParent & " WHERE cID=" & iID & " AND cType=" & CATEGORY_TYPE_DIRECTORY
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		ModifyDirectoryCategory = True
	End Function

	' Delete category (delete query)
	' IN  : iID (int) : category's id (table category, field cID)
	' OUT : (boolean) : True if added
	Function DeleteDirectoryCategory(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "DELETE FROM directory WHERE dCategory=" & iID
		DBExecute oCn, rSQL
		rSQL = "DELETE FROM Categories WHERE cParent=" & iID
		DBExecute oCn, rSQL
		rSQL = "DELETE FROM Categories WHERE cID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		DeleteDirectoryCategory = True
	End Function

	' Dispay deleting form
	' IN  : iID (int) : category's id (table category, field cID)
	' OUT : -
	Sub ConfirmDeleteDirectoryCategory(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT * FROM Categories WHERE cID=" & iID & " AND cType=" & CATEGORY_TYPE_DIRECTORY
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delCategorie()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "ConfirmDel", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""cID"" value=""" & oRs("cID") & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"">" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td><td>" & Server.HTMLEncode(oRs("cTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td><td>" & Server.HTMLEncode(oRs("cDescription")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=""button"" onClick=""javascript:delCategorie();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=""button"" onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Process page
	' IN  : -
	' OUT : -
	Sub DoAdminDirectory()
		Dim bValide, sTemp

		bValide = "0"
		If Request.Form("dValid") <> "" Then bValide = "1"

		Select Case Request("do") 
			Case "add"  : 
				If Request("dTitle") <> "" Then
					If AddDirectorySite(Request.Form("dTitle"), Request.Form("dAuthor"), Request.Form("dEmail"), Request.Form("dDescription"), Request.Form("dURL"), Request.Form("dDate"), Request.Form("dCategory"), Request.Form("dVersion"), bValide) Then 
						sInfoPage = GetTranslation("LANG_SITE") & " - " & GetTranslation("LANG_ADD_SUCCESS")
						If Request.Form("dSendIt") <> "" Then 
							sTemp = Replace(GetTranslation("LANG_SITE_ADDED"), "%1%", Request.Form("dAuthor"))
							sTemp = Replace(sTemp, "%2%", Request.Form("dTitle"))
							sTemp = Replace(sTemp, "%3%", Request.Form("dURL"))
							sTemp = Replace(sTemp, "%4%", Request.Form("dDescription"))
							sTemp = sTemp & "<br><br>" & GLOBAL_SITE_NAME & "<br>" & GLOBAL_SITE_URL
							SendMail GLOBAL_SITE_EMAIL, Request.Form("dEmail"), GetTranslation("LANG_DIRECTORY") & " - " & GLOBAL_SITE_NAME, sTemp, True
						End If
					Else
						sInfoPage = GetTranslation("LANG_SITE") & " - " & GetTranslation("LANG_ADD_ERROR")
					End If
				Else
					If AddDirectoryCategory(Request.Form("cTitle"), Request.Form("cDescription"), Request.Form("cParent")) Then 
						sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_ADD_SUCCESS")
					Else
						sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_ADD_ERROR")
					End If
				End If
			Case "updt"  : 
				If Request("dTitle") <> "" Then
					If ModifyDirectorySite(Request.Form("dID"), Request.Form("dTitle"), Request.Form("dAuthor"), Request.Form("dEmail"), Request.Form("dDescription"), Request.Form("dURL"), Request.Form("dDate"), Request.Form("dCategory"), Request.Form("dVersion"), bValide) Then 
						sInfoPage = GetTranslation("LANG_SITE") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
						If Request.Form("dSendIt") <> "" Then 
							sTemp = Replace(GetTranslation("LANG_SITE_ADDED"), "%1%", Request.Form("dAuthor"))
							sTemp = Replace(sTemp, "%2%", Request.Form("dTitle"))
							sTemp = Replace(sTemp, "%3%", Request.Form("dURL"))
							sTemp = Replace(sTemp, "%4%", Request.Form("dDescription"))
							sTemp = sTemp & "<br><br>" & GLOBAL_SITE_NAME & "<br>" & GLOBAL_SITE_URL
							SendMail GLOBAL_SITE_EMAIL, Request.Form("dEmail"), GetTranslation("LANG_DIRECTORY") & " - " & GLOBAL_SITE_NAME, sTemp, True
						End If
					Else
						sInfoPage = GetTranslation("LANG_SITE") & " - " & GetTranslation("LANG_MODIFY_ERROR")
					End If
				Else
					If ModifyDirectoryCategory(Request.Form("cID"), Request.Form("cTitle"), Request.Form("cDescription"), Request.Form("cParent")) Then 
						sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
					Else
						sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_MODIFY_ERROR")
					End If
				End If
			Case "del"  : 
				If Request("dID") <> "" Then
					If DeleteDirectorySite(Request.Form("dID")) Then 
						sInfoPage = GetTranslation("LANG_SITE") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
					Else
						sInfoPage = GetTranslation("LANG_SITE") & " - " & GetTranslation("LANG_DELETE_ERROR")
					End If
				Else
					If DeleteDirectoryCategory(Request.Form("cID")) Then 
						sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
					Else
						sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_DELETE_ERROR")
					End If
				End If
		End Select
	End Sub

	' Display page
	' IN  : -
	' OUT : -
	Sub DisplayAdminDirectoryPage()
		Dim oCn, oRs, rSQL, iCat, bDisplayMore

		bDisplayMore = True

		iCat = Request.QueryString("cat")
		If iCat <> "" and IsNumeric(iCat) Then
			iCat = CInt(iCat)
		Else
			iCat = 0
		End If

		Select Case Request("do")
			Case "view" :
				If Request.QueryString("iscat") Then
					DisplayDirectoryCategory Request("id")
				Else
					DisplayAdminDirectorySite Request("id")
				End If
				bDisplayMore = False
			Case "new"  : 
				If Request.QueryString("iscat") Then
					EditDirectoryCategory 0, iCat
				Else
					EditDirectorySite 0, iCat
				End If
				bDisplayMore = False
			Case "edit" : 
				If Request.QueryString("iscat") Then
					EditDirectoryCategory Request("id"), iCat
				Else
					EditDirectorySite Request("id"), iCat
				End If
				bDisplayMore = False
			Case "cdel" : 
				If Request.QueryString("iscat") Then
					ConfirmDeleteDirectoryCategory Request("id")
				Else
					ConfirmDeleteDirectorySite Request("id")
				End If
				bDisplayMore = False
		End Select

		DisplayAdminDirectoryCategories iCat
		DisplayAdminDirectorySites iCat
		If bDisplayMore and iCat = 0 Then 
			DisplayTopDirectory GLOBAL_DIRECTORY_TOP, 0
			DisplayAdminDirectorySitesToValidate
		End If
	End Sub
%>