<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' update table forums
	'IN  : iForumID (int) : Forum's id (table Forums, field ForumId)
	'    : sTitle (string) : Forum's name (table Forums, field ForumName)
	'    : sDescription (string) : Forum's description (table Forums, field ForumDescription)
	'    : iLevel (int) : Forum's level access (table Forums, field ForumLevel)
	'OUT : (boolean) Always true
	Function UpdateForum(iForumID, sTitle, sDescription, iLevel)
		Dim Conn, rSQL

		Set Conn = DBConnexion(DB_FORUM)
		
		rSQL = "UPDATE Forums SET ForumName='" & SQLEncrypt(sTitle) & "', ForumDescription='" & SQLEncrypt(sDescription) & "', ForumLevel=" & iLevel & " WHERE ForumID=" & iForumID
		DBExecute Conn, rSQL

		Conn.Close
		Set Conn = Nothing

		UpdateForum = True
	End Function

	' Display the edit form
	' IN  : iForumID (int) : Forum's id (table Forums, field ForumID)
	' OUT : -
	Function EditForum(iForumID)
		Dim oCn, oRs, rSQL
		Dim sTitle, sDescription, iLevel

		If IsNumeric(iForumID) and iForumID <> "" Then
			iForumID = CInt(iForumID)
		Else
			iForumID = 0
		End If

		If IsOwner <> "" and iForumID <> 0 Then
			Set oCn = DBConnexion(DB_FORUM)
		
			rSQL = "SELECT * FROM Forums WHERE ForumID=" & iForumID

			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				sTitle = oRs("ForumName")
				sDescription = oRs("ForumDescription")
				iLevel = oRs("ForumLevel")

				Response.Write "<script language=""javaScript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  	function updateForum() {" & vbCRLF
				Response.Write "      		var ok = true;" & vbCRLF
				Response.Write "      		var msg = '" & GetTranslation("LANG_MUST_FILL") & "';" & vbCRLF
				Response.Write "      		if (document.edition.ForumName.value == '') { ok = false; msg += '\n - " & JSencrypt(GetTranslation("LANG_TITLE")) & "'; }" & vbCRLF
				Response.Write "      		if (document.edition.ForumDescription.value == '') { ok = false; msg += '\n - " & JsEncrypt(GetTranslation("LANG_DESCRIPTION")) & "'; }" & vbCRLF
				Response.Write "      		if (ok) {" & vbCRLF
				Response.Write "			document.edition.Do.value = 'updt';" & vbCRLF
				Response.Write "			document.edition.submit();" & vbCRLF
				Response.Write "		}" & vbCRLF
				Response.Write "      		else alert(msg);" & vbCRLF
				Response.Write "      	}" & vbCRLF
				Response.Write "</script>" & vbCRLF

				CreateTopTable "EditForum", GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_FORUM")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""edition"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
				Response.Write "<input name=""ForumID"" type=""hidden"" value=""" & iForumID & """>" & vbCRLF
				Response.Write "<input name=""ForumLevel"" type=""hidden"" value=""" & iLevel & """>" & vbCRLF
				Response.Write "<input name=""Do"" type=""hidden"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "      <td width=""120"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "      <td><input name=""ForumName"" class=""cell"" maxlength=""200"" value=""" & Server.HTMLEncode(sTitle) & """></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "      <td valign=""top"">" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
				Response.Write "      <td><textarea name=""ForumDescription"" rows=""3"" cols=""60"" class=""cell"">" & Server.HTMLEncode(sDescription) & "</textarea></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"">" & vbCRLF
				Response.Write "      <input name=""poster"" type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""javascript:updateForum();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2""><a href=""Forum.asp"">" & GetTranslation("LANG_BACK") & "</a></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If

			oCn.Close
			Set oCn = Nothing
			Set oRs = Nothing
		End If
	End Function

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoEditForum()
		If Request.Form("Do") = "updt" Then
			If UpdateForum(Request.Form("ForumID"), Request.Form("ForumName"), Request.Form("ForumDescription"), Request.Form("ForumLevel")) Then
				sInfoPage = GetTranslation("LANG_FORUM") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_FORUM") & " - " & GetTranslation("LANG_MODIFY_ERROR")
			End If
		End If
	End Sub
%>