<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' update table Sections
	'IN  : iSectionID (int) : section's id (table sections, field SectionId)
	'    : sTitle (string) : section's name (table sections, field SectionName)
	'    : sDescription (string) : section's description (table sections, field SectionDescription)
	'    : iForum (int) : section's forum (table sections, field SectionForum)
	'    : iLevel (int) : section's level access (table sections, field SectionLevel)
	'    : bModerated (boolean) : section's moderation (table sections, field SectionModerated)
	'OUT : (boolean) Always true
	Function UpdateSection(iSectionID, sTitle, sDescription, iForum, iLevel, bModerated)
		Dim Conn, rSQL

		Set Conn = DBConnexion(DB_FORUM)
		
		rSQL = "UPDATE Sections SET SectionName='" & SQLEncrypt(sTitle) & "', SectionDescription='" & SQLEncrypt(sDescription) & "', SectionForum=" & iForum & ", SectionLevel=" & iLevel & ", SectionModerated=" & bModerated & " WHERE SectionID=" & iSectionID
		DBExecute Conn, rSQL

		Conn.Close
		Set Conn = Nothing

		UpdateSection = True
	End Function

	' Display the edit form
	' IN  : iSectionID (int) : section's id (table sections, field SectionID)
	' OUT : -
	Function EditSection(iSectionID)
		Dim oCn, oRs, rSQL
		Dim sTitle, sDescription, iForum, iLevel, bModerated, X

		If IsNumeric(iSectionID) and iSectionID <> "" Then
			iSectionID = CInt(iSectionID)
		Else
			iSectionID = 0
		End If

		If (IsAdministrator <> "" Or IsOwner <> "") and iSectionID <> 0 Then
			Set oCn = DBConnexion(DB_FORUM)
		
			rSQL = "SELECT * FROM Sections WHERE SectionID=" & iSectionID

			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				sTitle = oRs("SectionName")
				sDescription = oRs("SectionDescription")
				iForum = oRs("SectionForum")
				iLevel = oRs("SectionLevel")
				bModerated = oRs("SectionModerated").Value

				Response.Write "<script language=""javaScript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  	function updateSection() {" & vbCRLF
				Response.Write "      		var ok = true;" & vbCRLF
				Response.Write "      		var msg = '" & GetTranslation("LANG_MUST_FILL") & "';" & vbCRLF
				Response.Write "      		if (document.edition.SectionName.value == '') { ok = false; msg += '\n - " & JSencrypt(GetTranslation("LANG_TITLE")) & "'; }" & vbCRLF
				Response.Write "      		if (document.edition.SectionDescription.value == '') { ok = false; msg += '\n - " & JsEncrypt(GetTranslation("LANG_DESCRIPTION")) & "'; }" & vbCRLF
				Response.Write "      		if (ok) {" & vbCRLF
				Response.Write "			document.edition.Do.value = 'updt';" & vbCRLF
				Response.Write "			document.edition.submit();" & vbCRLF
				Response.Write "		}" & vbCRLF
				Response.Write "      		else alert(msg);" & vbCRLF
				Response.Write "      	}" & vbCRLF
				Response.Write "</script>" & vbCRLF

				CreateTopTable "EditSection", GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_SECTION")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""edition"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
				Response.Write "<input name=""SectionID"" type=""hidden"" value=""" & iSectionID & """>" & vbCRLF
				Response.Write "<input name=""SectionLevel"" type=""hidden"" value=""" & iLevel & """>" & vbCRLF
				If bModerated Then
					Response.Write "<input name=""SectionModerated"" type=""hidden"" value=""1"">" & vbCRLF
				Else
					Response.Write "<input name=""SectionModerated"" type=""hidden"" value="""">" & vbCRLF
				End If
				Response.Write "<input name=""Do"" type=""hidden"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "      <td width=""120"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "      <td><input name=""SectionName"" class=""cell"" maxlength=""200"" value=""" & Server.HTMLEncode(sTitle) & """></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "      <td valign=""top"">" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
				Response.Write "      <td><textarea name=""SectionDescription"" rows=""3"" cols=""60"" class=""cell"">" & Server.HTMLEncode(sDescription) & "</textarea></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "      <td>" & GetTranslation("LANG_FORUM") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF
				Response.Write "		<select name=""SectionForum"" class=""cell"">" & vbCRLF

				rSQL = "SELECT ForumID, ForumName FROM Forums ORDER BY ForumName"					

				Set oRs = DBRecordSet(oCn, rSQL)
						
				While Not oRs.EOF
					X = oRs("ForumID")
					Response.Write "			<option value=""" & X & """"
					If X = iForum Then Response.Write " selected"
					Response.Write """>" & Server.HTMLEncode(oRs("ForumName")) & "</option>" & vbCRLF
							
					oRs.MoveNext
				WEnd

				Response.Write "		</select>" & vbCRLF
				Response.Write "	</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"">" & vbCRLF
				Response.Write "      <input name=""poster"" type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""javascript:updateSection();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2""><a href=""Forum.asp?forum=" & myForum & """>" & GetTranslation("LANG_BACK") & "</a></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If

			oCn.Close
			Set oCn = Nothing
			Set oRs = Nothing
		End If
	End Function

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoEditSection()
		Dim bModerated

		If Request.Form("Do") = "updt" Then
			If Request.Form("SectionModerated") <> "" Then
				bModerated = "1"
			Else
				bModerated = "0"
			End If

			If UpdateSection(Request.Form("SectionID"), Request.Form("SectionName"), Request.Form("SectionDescription"), Request.Form("SectionForum"), Request.Form("SectionLevel"), bModerated) Then
				sInfoPage = GetTranslation("LANG_SECTION") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_SECTION") & " - " & GetTranslation("LANG_MODIFY_ERROR")
			End If
		End If
	End Sub
%>