<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	Sub DisplayForumPath(myForum, mySection, myPost)
		Dim Conn, Rs, RsTemp, rSQL, rSQLTemp, X, Y
		
		Set Conn = DBConnexion(DB_FORUM)

		CreateTopTable "ForumPath", GetTranslation("LANG_FORUM") & " " & GLOBAL_SITE_NAME
		Response.Write "<a href=""Forum.asp"">" & GetTranslation("LANG_FORUM") & "</a>" & vbCRLF

		If myForum <> "" Then
			rSQL = "SELECT ForumName FROM Forums WHERE ForumID=" & myForum
			Set Rs = DBRecordSet(Conn, rSQL)
			If Not Rs.EOF Then Response.Write "  &nbsp;<b>&gt;</b>&nbsp;<a href=""Forum.asp?forum=" & myForum & """>" & Rs("ForumName") & "</a>" & vbCRLF
			Set Rs = Nothing
			If mySection <> "" Then
				rSQL = "SELECT SectionName FROM Sections WHERE SectionID=" & mySection
				Set Rs = DBRecordSet(Conn, rSQL)
				If Not Rs.EOF Then Response.Write "  &nbsp;<b>&gt;</b>&nbsp;<a href=""Forum.asp?forum=" & myForum & "&section=" & mySection & """>" & Rs("SectionName") & "</a>" & vbCRLF
				Set Rs = Nothing
	
				If myPost <> "" Then
					rSQL = "SELECT PostTitle FROM Posts WHERE PostID=" & myPost
					Set Rs = DBRecordSet(Conn, rSQL)
					If Not Rs.EOF Then Response.Write "  &nbsp;<b>&gt;</b>&nbsp;<a href=""Forum.asp?forum=" & myForum & "&section=" & mySection & "&post="& myPost & """>" & Rs("PostTitle") & "</a>" & vbCRLF
					Set Rs = Nothing
				End If
			End If
		End If
		
		Response.Write "<div align=""right"">" & vbCRLF
		If sPseudo <> "" Then 
			Response.Write "<a href=""Search.asp?" & myForumPath & """>" & GetTranslation("LANG_SEARCH") & "</a>"
		Else
			Response.Write "<a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_AUTHENTICATION_PAGE & """>" & GetTranslation("LANG_AUTHENTICATION") & "</a>"
		End If
		If isAdministrator <> "" or isModerator <> "" Then
			If operatorMode = "oui" Then
				Response.Write "&nbsp;|&nbsp;<a href=""" & sUrlPage & "?forum=" & myForum & "&section=" & mySection & "&post=" & myPost & "&operatorMode=non"">Console [OFF]</a>"
			Else
				Response.Write "&nbsp;|&nbsp;<a href=""" & sUrlPage & "?forum=" & myForum & "&section=" & mySection & "&post=" & myPost & "&operatorMode=oui"">Console [ON]</a>"
			End If
			If isAdministrator <> "" Then Response.Write "&nbsp;|&nbsp;<a href=""Admin.asp?forum=" & myForum & "&section=" & mySection & "&post=" & myPost & """>" & GetTranslation("LANG_ADMINISTRATION") & "</a>"
		End If
		Response.Write "&nbsp;|&nbsp;<a href=""Top.asp?forum=" & myForum & "&section=" & mySection & "&post=" & myPost& """>Top " & FORUM_TOP_POSTS & "</a>"			
		Response.Write "</div>" & vbCRLF
		CreateBottomTable ""
		
		Conn.Close
		Set Conn = Nothing
		Set Rs = Nothing
	End Sub
	
	Function GetPostLastPage(iPostID)
		Dim oCn, oRs, rSQL, iNbPages, iNbPosts
		
		iNbPages = 1

		If iPostID <> "" and iPostID <> 0 Then
			Set oCn = DBConnexion(DB_FORUM)

			rSQL = "SELECT PostParent FROM Posts WHERE PostID=" & iPostID & " AND PostValid=True"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				rSQL = "SELECT count(PostID) FROM Posts WHERE PostParent=" & oRs(0) & " AND PostValid=True"
				Set oRs = DBRecordSet(oCn, rSQL)
				iNbPosts = oRs(0)
				If iNbPosts > FORUM_MAX_THREADS Then
					iNbPages = iNbPosts\FORUM_MAX_THREADS
					If iNbPosts mod FORUM_MAX_THREADS <> 0 Then iNbPages = iNbPages + 1
				End If
			End If		
			oCn.Close
			Set oCn = Nothing
			Set oRs = Nothing
		End If

		GetPostLastPage = iNbPages
	End Function

	Function AuthorisationForum(sUserLogin, forum)
		If forum <> "" Then		
			Dim Conn, Rs, rSQL

			AuthorisationForum = True
	
			Set Conn = DBConnexion(DB_FORUM)
			rSQL = "SELECT LevelName FROM Forums, Levels WHERE ForumLevel=LevelID and ForumID=" & forum
			Set Rs = DBRecordSet(Conn, rSQL)
			If Not Rs.EOF Then 
				Select Case Rs(0)
					Case "Moderator" : AuthorisationForum = GetIsModeratorOfForum(sUserLogin, forum)
					Case "Administrator": AuthorisationForum = GetIsAdministrator(sUserLogin, forum)
				End Select
			End If

			Conn.Close
			Set Rs   = Nothing
			Set Conn = Nothing
		End If
	End Function

	Function AuthorisationSection(sUserLogin, section)
		If section <> "" Then
			Dim Conn, Rs, rSQL
	
			AuthorisationSection = True
	
			Set Conn = DBConnexion(DB_FORUM)
			rSQL = "SELECT LevelName FROM Sections, Levels WHERE SectionLevel=LevelID and SectionID=" & section
			Set Rs = DBRecordSet(Conn, rSQL)
			If Not Rs.EOF Then 
				Select Case Rs("LevelName")
					Case "Moderator" : AuthorisationSection = GetIsModerator(sUserLogin, section)
					Case "Administrator": AuthorisationSection = GetIsAdministratorOfSection(sUserLogin, section)
				End Select
			End If
			
			Conn.Close
			Set Rs   = Nothing
			Set Conn = Nothing
		End If
	End Function

	Function GetIsAdministratorOfSection(sUserLogin, section)
		GetIsAdministratorOfSection = False

		If sUserLogin <> "" and section <> "" Then
			Dim Conn, Rs, rSQL

			Set Conn = DBConnexion(DB_FORUM)
			rSQL = "SELECT AdministratorID FROM Administrators WHERE AdministratorID LIKE '" & SQLEncrypt(sUserLogin) & "' AND AdministratorForum IN (SELECT SectionForum FROM Sections WHERE SectionID=" & section & ")"
			Set Rs = DBRecordSet(Conn, rSQL)
			If Not Rs.EOF Then GetIsAdministratorOfSection = True
			
			Conn.Close
			Set Rs   = Nothing
			Set Conn = Nothing
		End If
	End Function

	Function GetIsAdministrator(sUserLogin, forum)
		GetIsAdministrator = False

		If sUserLogin <> "" and forum <> "" Then		
			Dim Conn, Rs, rSQL

			Set Conn = DBConnexion(DB_FORUM)
			rSQL = "SELECT AdministratorID FROM Administrators WHERE AdministratorID LIKE '" & SQLEncrypt(sUserLogin) & "' AND AdministratorForum=" & forum
			Set Rs = DBRecordSet(Conn, rSQL)
			If Not Rs.EOF Then GetIsAdministrator = True
			
			Conn.Close
			Set Rs   = Nothing
			Set Conn = Nothing
		End If
	End Function

	Function GetIsModeratorOfForum(sUserLogin, forum)
		GetIsModeratorOfForum = False

		If sUserLogin <> "" and forum <> "" Then		
			Dim Conn, Rs, rSQL

			Set Conn = DBConnexion(DB_FORUM)
			rSQL = "SELECT ModeratorID FROM Moderators WHERE ModeratorID LIKE '" & SQLEncrypt(sUserLogin) & "' AND ModeratorSection IN (SELECT SectionID FROM Sections WHERE SectionForum=" & forum & ")"
			Set Rs = DBRecordSet(Conn, rSQL)
			If Not Rs.EOF Then GetIsModeratorOfForum = True
			
			Conn.Close
			Set Rs   = Nothing
			Set Conn = Nothing
		End If
	End Function

	Function GetIsModerator(sUserLogin, section)
		GetIsModerator = False
		If sUserLogin <> "" and section <> "" Then		
			Dim Conn, Rs, rSQL

			Set Conn = DBConnexion(DB_FORUM)
			rSQL = "SELECT ModeratorID FROM Moderators WHERE ModeratorID='" & SQLEncrypt(sUserLogin) & "' AND ModeratorSection=" & section
			Set Rs = DBRecordSet(Conn, rSQL)
			If Not Rs.EOF Then GetIsModerator = True
			
			Conn.Close
			Set Rs   = Nothing
			Set Conn = Nothing
		End If
	End Function

	Function GetIsOwner(sUserLogin)
		GetIsOwner = False

		If sUserLogin <> "" Then
			Dim Conn, Rs, rSQL

			Set Conn = DBConnexion(DB_FORUM)
			rSQL = "SELECT OwnerID FROM Owners WHERE OwnerID LIKE '" & SQLEncrypt(sUserLogin) & "'"
			Set Rs = DBRecordSet(Conn, rSQL)
			If Not Rs.EOF Then GetIsOwner = True
			
			Conn.Close
			Set Rs   = Nothing
			Set Conn = Nothing
		End If
	End Function
	
	Function GetIsValid(sUserLogin)
		GetIsValid = False
		
		If sUserLogin <> "" Then
			Dim Conn, Rs, rSQL

			Set Conn = DBConnexion(DB_FORUM)
			rSQL = "SELECT UserValid FROM Users WHERE UserLogin='" & SQLEncrypt(sUserLogin) & "'"
			Set Rs = DBRecordSet(Conn, rSQL)
			If Not Rs.EOF Then GetIsValid = Rs(0).Value

			Conn.Close
			Set Rs   = Nothing
			Set Conn = Nothing
		End If
	End Function
%>