<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	Sub DisplaySearchResult(sQuery, iType)
		Dim Conn, Rs, RsTemp, rSQL, rSQL2, rSQLTemp, iResults, tQuery, X, sTemp, iLine, iNbResultsFound
		
		CreateTopTable "SearchResult", GetTranslation("LANG_SEARCH_RESULTS")

		tQuery = Split(sQuery, " ")

		If UBound(tQuery) >= 0 Then
			For X = 0 To UBound(tQuery)
				sTemp = tQuery(X)
				If sTemp <> "" Then
					Select Case iType
						Case 1 :
							rSQLTemp = rSQLTemp & " OR PostTitle LIKE '%" & SQLEncrypt(sTemp) & "%'"
						Case 2 :
							rSQLTemp = rSQLTemp & " OR PostMessage LIKE '%" & SQLEncrypt(sTemp) & "%'"
						Case 3 :
							rSQLTemp = rSQLTemp & " OR PostTitle LIKE '%" & SQLEncrypt(sTemp) & "%' OR PostMessage LIKE '%" & SQLEncrypt(sTemp) & "%'"
						Case 4 :
							rSQLTemp = rSQLTemp & " OR PostUser='" & SQLEncrypt(sTemp) & "'"
					End Select
				End If
			Next

			Set Conn = DBConnexion(DB_FORUM)

			rSQL = "SELECT DISTINCT TOP " & FORUM_MAX_SEARCH_RESULTS & " PostParent FROM Posts WHERE PostValid=True"
			rSQL2 = "SELECT Count(PostParent) FROM Posts WHERE PostValid=True"
			If rSQLTemp <> "" Then
				rSQLTemp = Mid(rSQLTemp, 5)
				rSQL = rSQL & " AND (" & rSQLTemp & ")"
				rSQL2 = rSQL2 & " AND (" & rSQLTemp & ")"
			End If
			rSQL = rSQL & " ORDER BY PostParent DESC"

			Set Rs = DBRecordSet(Conn, rSQL)

			iNbResultsFound = 0

			If Not Rs.EOF Then
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_SUBJECT") & "</td>" & vbCRLF
				Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_READ") & "</td>" & vbCRLF
				Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
				Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = 1
				While Not Rs.EOF
					rSQLTemp = "SELECT PostTitle, PostUser, PostHits, PostDate, PostSection, SectionForum FROM Posts, Sections WHERE PostSection=SectionID AND PostValid=True AND PostID=" & Rs("PostParent")
					Set RsTemp = DBRecordSet(Conn, rSQLTemp)
					If Not RsTemp.EOF Then
						Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
						Response.Write "    <td><a href=""Forum.asp?forum=" & RsTemp("SectionForum") & "&section=" & RsTemp("PostSection") & "&post=" & Rs("PostParent") & """>" & CodeMessage(RsTemp("PostTitle"), True) & "</a></td>" & vbCRLF
						Response.Write "    <td width=""50"" align=""center"">" & RsTemp("PostHits") & "</td>" & vbCRLF
						Response.Write "    <td width=""120"" align=""center"">" & Server.HTMLEncode(RsTemp("PostUser")) & "</td>" & vbCRLF
						Response.Write "    <td width=""100"" align=""center"">" & StringToDate(RsTemp("PostDate")) & "</td>" & vbCRLF
						Response.Write "  </tr>" & vbCRLF

						iLine = ((iLine - 1) XOr 1) + 1
						iNbResultsFound = iNbResultsFound + 1
					End If
					Rs.MoveNext
				WEnd

				If iNbResultsFound >= FORUM_MAX_SEARCH_RESULTS Then
					Set Rs = DBRecordSet(Conn, rSQL2)
					If Not Rs.EOF Then
						iResults = Rs(0)
					Else
						iResults = FORUM_MAX_SEARCH_RESULTS
					End If
					Response.Write "  <tr class=""tablelinemain""><td colspan=""4"" align=""center"">" & Replace(Replace(GetTranslation("LANG_SEARCH_TOTAL"), "%1%", FORUM_MAX_SEARCH_RESULTS), "%2%", iResults) & "</td></tr>" & vbCRLF
				Else
					Response.Write "  <tr class=""tablelinemain""><td colspan=""4"" align=""center"">" & Replace(Replace(GetTranslation("LANG_SEARCH_TOTAL"), "%1%", iNbResultsFound), "%2%", iNbResultsFound) & "</td></tr>" & vbCRLF
				End If

				Response.Write "</table>" & vbCRLF
			Else
				Response.Write GetTranslation("LANG_SEARCH_EMPTY") & vbCRLF
			End If

			Conn.Close
			Set Rs   = Nothing
			Set Conn = Nothing
		Else
			Response.Write GetTranslation("LANG_SEARCH_EMPTY") & vbCRLF
		End If

		CreateBottomTable ""
	End Sub

	Sub DisplayForumSearch()
		Dim iType, sQuery

		sQuery = ""
		iType = 1
		
		If Request.Form("Do") = "search" Then
			iType = Request.Form("searchon")
			sQuery = Request.Form("query")
		End If

		CreateTopTable "Search", GetTranslation("LANG_SEARCH")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""searchforum"" method=""post"" action=""" & sURLPage & "?" & myForumPath & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""search"">" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td width=""120"">" & GetTranslation("LANG_QUERY") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""query"" maxlength=""100"" size=""40"" value=""" & Server.HTMLEncode(sQuery) & """></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td width=""120"">&nbsp;</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <input type=""radio"" name=""searchon"" value=""1"""
		If iType = 1 Then Response.Write " checked"
		Response.Write ">" & GetTranslation("LANG_SUBJECT") & "<br>" & vbCRLF
		Response.Write "      <input type=""radio"" name=""searchon"" value=""2"""
		If iType = 2 Then Response.Write " checked"
		Response.Write ">" & GetTranslation("LANG_TEXT") & "<br>" & vbCRLF
		Response.Write "      <input type=""radio"" name=""searchon"" value=""3"""
		If iType = 3 Then Response.Write " checked"
		Response.Write ">" & GetTranslation("LANG_TEXT") & " + " & GetTranslation("LANG_SUBJECT") & "<br>" & vbCRLF
		Response.Write "      <input type=""radio"" name=""searchon"" value=""4"""
		If iType = 4 Then Response.Write " checked"
		Response.Write ">" & GetTranslation("LANG_AUTHOR") & "<br>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""submit"" name=""submit"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		If sQuery <> "" Then DisplaySearchResult sQuery, iType

	End Sub
%>