<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Create a new account
	' IN  : sMyLogin (string) : login (table users, field uLogin)
	'       sMyPassword (string) : password (table users, field uPassword)
	'       sMyEmail (string) : email address (table users, field uEmail)
	' OUT : (boolean) : account has been created
	Function AddAccount(sMyLogin, sMyPassword, sMyEmail)
		Dim oCn, oCn2, oRs, rSQL, rSQL2, rSQL3, BodyText, sURL

		Set oCn = DBConnexion(DB_MAIN)

		If bAutoSignup Then
			rSQL = "INSERT INTO users (uLogin, uPassword, uEmail, uMSN, uYahoo, uICQ, uAIM, uURL, uSignature, uRole, uDate, uNewsletter, uProfile, uValid) VALUES ('" & SQLEncrypt(sMyLogin) & "', '" & SQLEncrypt(sMyPassword) & "', '" & SQLEncrypt(sMyEmail) & "', '', '', '', '', '', '', " & ROLE_USER & ", '" & DateTimeToString(Now()) & "', 0, 0, 1)"
			rSQL2 = "INSERT INTO Users (UserLogin, UserPosts, UserValid) VALUES ('" & SQLEncrypt(sMyLogin) & "', 0, 1)"
		Else
			rSQL = "INSERT INTO users (uLogin, uPassword, uEmail, uMSN, uYahoo, uICQ, uAIM, uURL, uSignature, uRole, uDate, uNewsletter, uProfile, uValid) VALUES ('" & SQLEncrypt(sMyLogin) & "', '" & SQLEncrypt(sMyPassword) & "', '" & SQLEncrypt(sMyEmail) & "', '', '', '', '', '', '', " & ROLE_USER & ", '" & DateTimeToString(Now()) & "', 0, 0, 0)"
			rSQL2 = "INSERT INTO Users (UserLogin, UserPosts, UserValid) VALUES ('" & SQLEncrypt(sMyLogin) & "', 0, 0)"
		End If

		rSQL3 = "SELECT * FROM users WHERE uLogin='" & SQLEncrypt(sMyLogin) & "'"
		Set oRs = DBRecordSet(oCn, rSQL3)
		If oRs.EOF Then
			' Create an account in the main database
			DBExecute oCn, rSQL
			' Create an account in the forum database
			Set oCn2 = DBConnexion(DB_FORUM)
			DBExecute oCn2, rSQL2

			BodyText = GetTranslation("LANG_SIGNUP_TEXT") & vbCRLF & vbCRLF
			BodyText = BodyText & "  " & GetTranslation("LANG_LOGIN") & " : " & sMyLogin & vbCRLF
			BodyText = BodyText & "  " & GetTranslation("LANG_PASSWORD") & " : " & sMyPassword & vbCRLF
			BodyText = BodyText & "  " & GetTranslation("LANG_EMAIL") & " : " & sMyEmail & vbCRLF

			If Not bAutoSignup Then
				rSQL = "SELECT uID FROM users WHERE uLogin='" & SQLEncrypt(sMyLogin) & "'"
				Set oRs = DBRecordSet(oCn, rSQL)
				If Not oRs.EOF Then
					sURL = GLOBAL_SITE_URL
					If Right(sURL, 1) <> "/" Then sURL = sURL & "/"
					sURL = sURL & GLOBAL_SITE_SIGNUP_PAGE & "?confirm=1&login=" & Server.URLEncode(sMyLogin) & "&password=" & Server.URLEncode(sMyPassword) & "&id=" & Server.URLEncode(oRs("uID"))
					BodyText = BodyText & vbCRLF & Replace(GetTranslation("LANG_SIGNUP_CONFIRM_LINK"), "%1%", "<a href=""" & sURL & """ target=""_blank"">" & sURL & "</a>") & vbCRLF & vbCRLF
				End If
			End If

			BodyText = BodyText & vbCRLF & vbCRLF & GLOBAL_SITE_NAME & vbCRLF & vbCRLF
			BodyText = BodyText & GLOBAL_SITE_URL
			SendMail GLOBAL_ACCOUNTS_EMAIL, sMyEmail, GetTranslation("LANG_SIGNUP_SUBJECT") & " - " & GLOBAL_SITE_NAME, BodyText, True

			oCn2.Close
			Set oCn2 = Nothing
			AddAccount = True
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function
	
	' Confirm account registration if bAutoSignup is set to False
	' IN  : iUserId (int) : user's id (table users, field uID)
	'     : sUserLogin (string) : user's login (table users, field uLogin)
	'     : sUserPassword (string) : user's password (table users, field uPassword)
	Function ConfirmAccount(iUserID, sUserLogin, sUserPassword)
		Dim oCn, oCn2, oRs, rSQL, bDone
		
		bDone = False

		If iUserID <> "" Then		
			Set oCn = DBConnexion(DB_MAIN)

			rSQL = "SELECT uID FROM Users WHERE uID=" & iUserID & " AND uLogin='" & SQLEncrypt(sUserLogin) & "' AND uPassword='" & SQLEncrypt(sUserPassword) & "' AND uValid=0"
			Set oRs = DBRecordSet(oCn, rSQL)
		
			If Not oRs.EOF Then
				rSQL = "UPDATE Users SET uValid=1 WHERE uID=" & iUserID
				DBExecute oCn, rSQL

				Set oCn2 = DBConnexion(DB_FORUM)
				rSQL = "UPDATE Users SET UserValid=1 WHERE UserLogin='" & SQLEncrypt(sUserLogin) & "'"

				bDone = True
				
				oCn2.Close
				Set oCn2 = Nothing
			End If
		
			oCn.Close
			Set oCn = Nothing
			Set oRs = Nothing
		End If
		
		ConfirmAccount = bDone
	End Function

	' Modify personnal account (update query)
	' IN  : sUserLogin (string) : user's login (table users, field uLogin)
	'       sUserEmail (string) : user's email (table users, field uEmail)
	'       sUserMSN (string) : user's msn messenger id (table users, field uMSN)
	'       sUserYahoo (string) : user's yahoo messenger (table users, field uYahoo)
	'       sUserICQ (string) : user's email (table users, field uICQ)
	'       sUserAIM (string) : user's email (table users, field uAIM)
	'       sUserURL (string) : user's email (table users, field uURL)
	'       sUserSignature (string) : user's signature (table users, field uSignature)
	'       bUserNewsletter (boolean) : receive the newsletter (table users, field uNewsletter)
	'       bUserProfile (boolean) : can display user's profile (table users, field uProfile)
	' OUT : (boolean) : True if modified
	Function ModifyAccount(sUserLogin, sUserEmail, sUserMSN, sUserYahoo, sUserICQ, sUserAIM, sUserURL, sUserSignature, bUserNewsletter, bUserProfile)
		Dim oCn, rSQL
		
		Set oCn = DBConnexion(DB_MAIN)
		sUserEmail = Replace(sUserEmail, """", "")
		rSQL = "UPDATE Users SET uEmail='" & SQLEncrypt(sUserEmail) & "', uMSN='" & SQLEncrypt(sUserMSN) & "', uYahoo='" & SQLEncrypt(sUserYahoo) & "', uICQ='" & SQLEncrypt(sUserICQ) & "', uAIM='" & SQLEncrypt(sUserAIM) & "', uURL='" & SQLEncrypt(sUserURL) & "', uSignature='" & SQLEncrypt(sUserSignature) & "', uNewsletter=" & bUserNewsLetter & ", uProfile=" & bUserProfile & " WHERE uLogin='" & SQLEncrypt(sUserLogin) & "'"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		ModifyAccount = True
	End Function
	
	' Modify Avatar (insert or update query)
	' IN  : iAvatarID (int) : avatar's id (table Users, fields UserAvatar) DB_FORUM
	'     : sAvatarPath (string) : avatar's path if personnal avatar (table Avatars, field AvatarPath) DB_FORUM
	' OUT : (boolean) : True if modified
	Function ModifyAvatar(iAvatarID, sAvatarPath)
		Dim oCn, oRs, rSQL
		
		Set oCn = DBConnexion(DB_FORUM)

		ModifyAvatar = True
		
		If sAvatarPath <> "" Then
			' Process only http adress
			If Left(LCase(sAvatarPath), 7) = "http://" Then
				' Personnal avatar
				' Verify if user has already an avatar. If so, then update, else insert
				rSQL = "SELECT AvatarID FROM Avatars WHERE AvatarName='" & SQLEncrypt(sPseudo) & "' AND AvatarPrivate=1"
				Set oRs = DBRecordSet(oCn, rSQL)
				If Not oRs.EOF Then
					' User have already an avatar, just update it (but no change made to the AvatarValid)
					If bAutoAcceptPrivateAvatar Then
						rSQL = "UPDATE Avatars SET AvatarPath = '" & SQLEncrypt(sAvatarPath) & "' WHERE AvatarID=" & oRs("AvatarID")
					Else
						rSQL = "UPDATE Avatars SET AvatarPath = '" & SQLEncrypt(sAvatarPath) & "', AvatarValid=0 WHERE AvatarID=" & oRs("AvatarID")
					End If
					DBExecute oCn, rSQL
					' Update users information (force update)
					rSQL = "UPDATE Users SET UserAvatar = " & oRs("AvatarID") & " WHERE UserLogin='" & SQLEncrypt(sPseudo) & "'"
					DBExecute oCn, rSQL
				Else
					' Create a new avatar for user
					' Make it valid by default....
					If bAutoAcceptPrivateAvatar Then
						rSQL = "INSERT INTO Avatars (AvatarName, AvatarPath, AvatarPrivate, AvatarValid) VALUES ('" & SQLEncrypt(sPseudo) & "', '" & SQLEncrypt(sAvatarPath) & "', 1, 1)"
					Else
						rSQL = "INSERT INTO Avatars (AvatarName, AvatarPath, AvatarPrivate, AvatarValid) VALUES ('" & SQLEncrypt(sPseudo) & "', '" & SQLEncrypt(sAvatarPath) & "', 1, 0)"
					End If
					DBExecute oCn, rSQL
					' Get the AvatarID
					rSQL = "SELECT AvatarID FROM Avatars WHERE AvatarName='" & SQLEncrypt(sPseudo) & "' AND AvatarPrivate=1"
					Set oRs = DBRecordSet(oCn, rSQL)
					If Not oRs.EOF Then
						rSQL = "UPDATE Users SET UserAvatar = " & oRs("AvatarID") & " WHERE UserLogin='" & SQLEncrypt(sPseudo) & "'"
						DBExecute oCn, rSQL
					Else
						ModifyAvatar = False
					End If
				End If
			End If
		ElseIf iAvatarID <> "" Then
			' Existing avatar
			rSQL = "UPDATE Users SET UserAvatar = " & iAvatarID & " WHERE UserLogin='" & SQLEncrypt(sPseudo) & "'"
			DBExecute oCn, rSQL
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function

	' Modify password (update query)
	' IN  : sUserLogin (string) : user's login (table users, field uLogin)
	'       sUserPassword (string) : user's old password (table users, field uPassword)
	'       sUserNewPassword (string) : user's new password (table users, field uPassword)
	' OUT : (boolean) : True if modified
	Function ModifyAccountPassword(sUserLogin, sUserPassword, sUserNewPassword)
		Dim oCn, oRs, rSQL

		ModifyAccountPassword = False

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "SELECT uPassword FROM users WHERE uLogin='" & SQLEncrypt(sUserLogin) & "'"
		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Then
			If oRs("uPassword") = sUserPassword Then
				rSQL = "UPDATE users SET uPassword='" & SQLEncrypt(sUserNewPassword) & "' WHERE uLogin='" & SQLEncrypt(sUserLogin) & "'"
				DBExecute oCn, rSQL
				ModifyAccountPassword = True
			End If
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function

	' Display member's account
	' IN  : sMyLogin (string) : account's login to display (table users, field cLogin)
	' OUT : -
	Sub DisplayMyAccountPage(sMyLogin)
		Dim oCn, oCn2, oRs, oRs2, rSQL, oFs, oThemesFolder, oFolder, sMyAvatar, iMyAvatar, bMyAvatarIsPrivate
		Dim sMySignature, sSelectedAvatar, iSelectedAvatar, sTempAvatars, tTempAvatars, X

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT * FROM users WHERE uLogin='" & SQLEncrypt(sMyLogin) & "'"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then
			iSelectedAvatar = 0
			sMySignature = oRs("uSignature") & ""
			CreateTopTable "MyAccount", GetTranslation("LANG_MODIFY_ACCOUNT")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "<form name=""profil"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""200"">" & GetTranslation("LANG_LOGIN") & "</td>" & vbCRLF
			Response.Write "    <td align=""right"">" & Server.HTMLEncode(oRs("uLogin")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
			Response.Write "    <td align=""right""><input name=""uEmail"" size=""30"" maxlength=""50"" class=""cell"" value=""" & Server.HTMLEncode(oRs("uEmail")) & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>MSN</td>" & vbCRLF
			Response.Write "    <td align=""right""><input name=""uMSN"" size=""30"" maxlength=""50"" class=""cell"" value=""" & Server.HTMLEncode(oRs("uMSN")) & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>Yahoo Messenger</td>" & vbCRLF
			Response.Write "    <td align=""right""><input name=""uYahoo"" size=""30"" maxlength=""50"" class=""cell"" value=""" & Server.HTMLEncode(oRs("uYahoo")) & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>ICQ</td>" & vbCRLF
			Response.Write "    <td align=""right""><input name=""uICQ"" size=""30"" maxlength=""50"" class=""cell"" value=""" & Server.HTMLEncode(oRs("uICQ")) & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>AIM</td>" & vbCRLF
			Response.Write "    <td align=""right""><input name=""uAIM"" size=""30"" maxlength=""50"" class=""cell"" value=""" & Server.HTMLEncode(oRs("uAIM")) & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_SITE") & "</td>" & vbCRLF
			Response.Write "    <td align=""right""><input name=""uURL"" size=""50"" maxlength=""250"" class=""cell"" value=""" & Server.HTMLEncode(oRs("uURL")) & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_SIGNATURE") & "</td>" & vbCRLF
			Response.Write "    <td align=""right""><textarea name=""uSignature"" cols=""40"" rows=""5"" class=""cell"">" & Server.HTMLEncode(sMySignature) & "</textarea></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_SIGNATURE") & " (" & GetTranslation("LANG_PREVIEW") & ")</td>" & vbCRLF
			Response.Write "    <td>" & CodeMessage(sMySignature, True) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_SHOW_PROFILE") & "</td>" & vbCRLF
			Response.Write "    <td align=""right""><input name=""uProfile"" type=""checkbox"""
			If oRs("uProfile").Value Then Response.Write " checked"
			Response.Write "></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			If bNewsletter Then
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_NEWSLETTER") & "</td>" & vbCRLF
				Response.Write "    <td align=""right""><input type=""checkbox"" name=""uNewsletter"""
				If oRs.Fields("uNewsletter") Then Response.Write " checked"
				Response.Write "></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
			End If
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2"" align=""right""><input type=""submit"" name=""bProfil"" class=""button"" value=""" & GetTranslation("LANG_MODIFY") & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF
			Response.Write "</table>" & vbCRLF
		
			CreateBottomTable ""
			
			CreateTopTable "MyAvatar", GetTranslation("LANG_AVATAR")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "<form name=""avatar"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""200"" valign=""top"">" & GetTranslation("LANG_AVAILABLE_AVATARS") & "</td>" & vbCRLF
			Response.Write "    <td align=""right"" valign=""top"">" & vbCRLF

			Set oCn2 = DBConnexion(DB_FORUM)
			rSQL = "SELECT UserAvatar FROM Users WHERE UserLogin='" & SQLEncrypt(sPseudo) & "'"

			iMyAvatar = 0
			sMyAvatar = ""
			bMyAvatarIsPrivate = False

			Set oRs2 = DBRecordSet(oCn2, rSQL)
			If Not oRs2.EOF Then
				iMyAvatar = oRs2("UserAvatar")
				If iMyAvatar > 0 Then
					rSQL = "SELECT AvatarPath, AvatarPrivate FROM Avatars WHERE AvatarID=" & iMyAvatar
					Set oRs2 = DBRecordSet(oCn2, rSQL)
					If Not oRs2.EOF Then
						sMyAvatar = oRs2("AvatarPath")
						If oRs2("AvatarPrivate").Value Then	bMyAvatarIsPrivate = True
					End If
				End If
			End If

			Response.Write "      <img name=""selectedAvatar"" src=""" & GLOBAL_SITE_IMAGES_PATH & "blank.gif"" border=""0"" hspace=""5"">" & vbCRLF
			Response.Write "      <select name=""uAvatar"" class=""cell"" onChange=""javascript:changeAvatar()"">" & vbCRLF
			Response.Write "        <option value=""0"""
			If iMyAvatar = 0 Then Response.Write " selected"
			Response.Write ">-</option>" & vbCRLF

			rSQL = "SELECT AvatarID, AvatarName, AvatarPrivate, AvatarPath FROM Avatars WHERE AvatarValid=1 AND ((AvatarPrivate=0) OR (AvatarPrivate=1 AND AvatarName='" & SQLEncrypt(sPseudo) & "'))"
			Set oRs2 = DBRecordSet(oCn2, rSQL)

			If Not oRs2.EOF Then
				X = 0
				While Not oRs2.EOF
					Response.Write "        <option value=""" & oRs2("AvatarID") & """"
					If oRs2("AvatarID") = iMyAvatar Then 
						Response.Write " selected"
						sSelectedAvatar = oRs2("AvatarPath")
						iSelectedAvatar = X + 1
					End If
					Response.Write ">" & Server.HTMLEncode(oRs2("AvatarName"))
					If oRs2("AvatarPrivate").Value Then Response.Write " (" & GetTranslation("LANG_PRIVATE_AVATAR") & ")"
					Response.Write "</option>" & vbCRLF
					If sTempAvatars = "" Then
						sTempAvatars = oRs2("AvatarPath")
					Else
						sTempAvatars = sTempAvatars & "" & oRs2("AvatarPath")
					End If
					
					X = X + 1
					oRs2.MoveNext
				WEnd
				tTempAvatars = Split(sTempAvatars, "")
			End If

			oCn.Close
			oCn2.Close
			Set oCn  = Nothing
			Set oCn2 = Nothing

			Response.Write "      </select>" & vbCRLF
			Response.Write "      <script language=""javascript"" type=""text/javascript"">" & vbCRLF
			Response.Write "        var tAvatars = new Array();" & vbCRLF
			Response.Write "        tAvatars[0] = '" & GLOBAL_SITE_IMAGES_PATH & "blank.gif';" & vbCRLF
			If IsArray(tTempAvatars) Then
				For X = 0 To UBound(tTempAvatars)
					Response.Write "        tAvatars[" & X+1 & "] = '"
					If Left(LCase(tTempAvatars(X)), 7) <> "http://" Then Response.Write GLOBAL_SITE_PATH & FORUM_AVATARS_PATH
					Response.Write JSEncrypt(Server.HTMLEncode(tTempAvatars(X))) & "';" & vbCRLF
				Next
			End If
			Response.Write "        function changeAvatar()" & vbCRLF
			Response.Write "        {" & vbCRLF
			If bAllowPrivateAvatars Then Response.Write "          document.avatar.uPrivateAvatar.value='';" & vbCRLF
			Response.Write "          document.images[""selectedAvatar""].src = tAvatars[document.avatar.uAvatar.selectedIndex];" & vbCRLF
			Response.Write "        }" & vbCRLF
			If sSelectedAvatar <> "" Then
				Response.Write "		document.images[""selectedAvatar""].src = tAvatars[" & iSelectedAvatar & "];" & vbCRLF
			End If
			Response.Write "      </script>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td valign=""top"">" & GetTranslation("LANG_ACTUAL_AVATAR") & "</td>" & vbCRLF
			Response.Write "    <td align=""right"" valign=""top"">"
			If sMyAvatar <> "" Then
				Response.Write "<img name=""myAvatar"" src="""
				If Left(LCase(sMyAvatar), 7) <> "http://" Then Response.Write GLOBAL_SITE_PATH & FORUM_AVATARS_PATH
				Response.Write Server.HTMLEncode(sMyAvatar) & """ border=""0"">"
			Else
				Response.Write "-" & vbCRLF
			End If
			Response.Write "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			If bAllowPrivateAvatars Then
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_PRIVATE_AVATAR") & "</td>" & vbCRLF
				Response.Write "    <td align=""right""><input name=""uPrivateAvatar"" maxlength=""250"" size=""40"" class=""cell"" value="""
				If bMyAvatarIsPrivate Then Response.Write Server.HTMLEncode(sMyAvatar)
				Response.Write """></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
			End If

			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td align=""right"" colspan=""2""><input type=""submit"" name=""submitavatar"" class=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			
			CreateBottomTable ""

			On Error Resume Next
			Set oFs = Server.CreateObject("Scripting.FileSystemObject")
			If Err.number <> 0 Then
				Err.Clear
			Else
				If oFs.FolderExists(Server.MapPath(GLOBAL_SITE_THEMES_PATH)) Then
					CreateTopTable "MyTheme", GetTranslation("LANG_THEMES")
					Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
					Response.Write "<form name=""themes"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
					Response.Write "  <tr class=""tableline1"">" & vbCRLF
					Response.Write "    <td>" & GetTranslation("LANG_THEME") & "</td>" & vbCRLF
					Response.Write "    <td width=""150"" align=""right"">" & vbCRLF
					Response.Write "      <select name=""CurrentTheme"" class=""cell"">" & vbCRLF
			
					Set oThemesFolder = oFs.GetFolder(Server.MapPath(GLOBAL_SITE_THEMES_PATH))
					For Each oFolder In oThemesFolder.SubFolders
						Response.Write "        <option value=""" & oFolder.Name & """"
						If oFolder.Name = sTheme Then Response.Write " selected"
						Response.Write ">" & oFolder.Name & "</option>" & vbCRLF
					Next

					Response.Write "      </select>" & vbCRLF
					Response.Write "    </td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
					Response.Write "  <tr class=""tableline2"">" & vbCRLF
					Response.Write "    <td>" & GetTranslation("LANG_THEME_DESC") & "</td>" & vbCRLF
					Response.Write "    <td align=""right""><input type=""submit"" name=""bTheme"" class=""button"" value=""" & GetTranslation("LANG_MODIFY") & """></td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
					Response.Write "</form>" & vbCRLF
					Response.Write "</table>" & vbCRLF
					CreateBottomTable ""
				End If
				Set oFs = Nothing
			End If
			On Error Goto 0

			CreateTopTable "MyAccount", GetTranslation("LANG_MODIFY_PASSWORD")
	
			Response.Write "	<script language=""javascript"" type=""text/javascript"">" & vbCRLF
			Response.Write "		function formSubmit()" & vbCRLF
			Response.Write "		{" & vbCRLF
			Response.Write "			var ok = true;" & vbCRLF
			Response.Write "			var texte = '" & GetTranslation("LANG_MUST_FILL") & "';" & vbCRLF
			Response.Write "			if (document.password.uPassword.value == '')" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				ok = false;" & vbCRLF
			Response.Write "				texte = texte + '\n - " & GetTranslation("LANG_OLD_PASSWORD") & "';" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			if (document.password.uNewPassword.value == '')" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				ok = false;" & vbCRLF
			Response.Write "				texte = texte + '\n - " & GetTranslation("LANG_PASSWORD") & "';" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			if (document.password.uNewPassword2.value == '')" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				ok = false;" & vbCRLF
			Response.Write "				texte = texte + '\n - " & GetTranslation("LANG_PASSWORD_BIS") & "';" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			if (document.password.uNewPassword.value != document.password.uNewPassword2.value)" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				ok = false;" & vbCRLF
			Response.Write "				texte = '" & GetTranslation("LANG_PASSWORDS_DIFF") & "';" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			if (ok)" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				document.password.submit();" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			else" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				alert(texte);" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "		}" & vbCRLF
			Response.Write "	</script>" & vbCRLF
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "<form name=""password"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""200"">" & GetTranslation("LANG_OLD_PASSWORD") & "</td>" & vbCRLF
			Response.Write "    <td align=""right""><input name=""uPassword"" type=""password"" maxlength=""20"" class=""cell""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""200"">" & GetTranslation("LANG_PASSWORD") & "</td>" & vbCRLF
			Response.Write "    <td align=""right""><input name=""uNewPassword"" type=""password"" maxlength=""20"" class=""cell""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""200"">" & GetTranslation("LANG_PASSWORD_BIS") & "</td>" & vbCRLF
			Response.Write "    <td align=""right""><input name=""uNewPassword2"" type=""password"" maxlength=""20"" class=""cell""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2"" align=""right""><input type=""button"" name=""bPassword"" class=""button"" value=""" & GetTranslation("LANG_MODIFY") & """ onClick=""javascript:formSubmit()""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			
			CreateBottomTable ""		
		End If

		CreateTopTable "BlockDesigner", GetTranslation("LANG_TITLE_BLOCKS_DESIGNER")
		Response.Write "<a href=""" & GLOBAL_SITE_PATTERN_PAGE & """>" & GetTranslation("LANG_BLOCKS_DESIGNER_TEXT") & "</a>" & vbCRLF
		CreateBottomTable ""
	End Sub

	' Process account's actions
	' Process actions
	' IN  : -
	' OUT : -
	Sub DoMyAccount()
		Dim oCn, rSQL, bNewsLetter, bProfile
		
		If Request.Form("uEmail") <> "" Then
			Set oCn = DBConnexion(DB_MAIN)
			If Request.Form("uNewsletter") <> "" Then
				bNewsLetter = "1"
			Else
				bNewsLetter = "0"
			End If
			If Request.Form("uProfile") <> "" Then
				bProfile = "1"
			Else
				bProfile = "0"
			End If
			If ModifyAccount(sPseudo, Request.Form("uEmail"), Request.Form("uMSN"), Request.Form("uYahoo"), Request.Form("uICQ"), Request.Form("uAIM"), Request.Form("uURL"), Request.Form("uSignature"), bNewsletter, bProfile) Then
				sInfoPage = GetTranslation("LANG_ACCOUNT") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_ACCOUNT") & " - " & GetTranslation("LANG_MODIFY_ERROR")
			End If
		ElseIf Request.Form("uPassword") <> "" and Request.Form("uNewPassword") <> "" Then
			If ModifyAccountPassword(sPseudo, Request.Form("uPassword"), Request.Form("uNewPassword")) Then
				sInfoPage = GetTranslation("LANG_PASSWORD") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_MODIFY_ERROR") & " (" & GetTranslation("LANG_BAD_PASSWORD") & ")"
			End If
		ElseIf Request.Form("uAvatar") <> "" or Request.Form("uPrivateAvatar") <> "" Then
			If ModifyAvatar(Request.Form("uAvatar"), Request.Form("uPrivateAvatar")) Then
				sInfoPage = GetTranslation("LANG_AVATAR") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
			Else
				sInfoPage = GetTranslation("LANG_AVATAR") & " - " & GetTranslation("LANG_MODIFY_ERROR")
			End If
		End If
	End Sub
%>