<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display user account
	' IN  : uID (string) : user's login
	' OUT : -
	Sub DisplayAdminAccount(uID)
		Dim oCn, oRs, rSQL
		
		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT * FROM users, roles WHERE uRole=rID AND uLogin='" & SQLEncrypt(uID) & "'"
		Set oRs = DBRecordSet(oCn, rSQL)

		CreateTopTable "Account", GetTranslation("LANG_ACCOUNT")
		If Not oRs.EOF Then
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""150"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_LOGIN") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("uLogin")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
			Response.Write "    <td><a href=""" & GLOBAL_SITE_MAIL_PAGE & "?to=" & Server.HTMLEncode(oRs("uEmail")) & """>" & Server.HTMLEncode(oRs("uEmail")) & "</a></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>MSN</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("uMSN")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>Yahoo Messenger</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("uYahoo")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>ICQ</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("uICQ")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>AIM</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("uAIM")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_SITE") & "</td>" & vbCRLF
			Response.Write "    <td><a href=""" & Server.HTMLEncode(oRs("uURL")) & """ target=""_blank"">" & Server.HTMLEncode(oRs("uURL")) & "</a></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_SIGNATURE") & "</td>" & vbCRLF
			Response.Write "    <td>" & CodeMessage(oRs("uSignature"), True) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DATE_CREATED") & "</td>" & vbCRLF
			Response.Write "    <td>" & GetDateDDMMYYHHMMSS(StringToDate(oRs("uDate"))) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_ROLE") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("rTitle")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			If bNewsLetter Then
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_NEWSLETTER") & "</td>" & vbCRLF
				Response.Write "    <td>"
				If oRs("uNewsletter").Value Then 
					Response.Write GetTranslation("LANG_YES")
				Else
					Response.Write GetTranslation("LANG_NO")
				End If
				Response.Write "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
			End If
			Response.Write "</table>" & vbCRLF
		End If
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display top user accounts sorted by creation's date
	' IN  : iTop (int) : numbers of results wanted
	'     : sSortedField (string) : field sorted
	'     : bAscSort (boolean) : if true = ASC sort, else DESC
	' OUT : -
	Sub DisplayTopAccounts(iTop, sSortedField, bAscSort)
		Dim oCn, oRs, rSQL, iLine, sSortDesc
		
		Set oCn = DBConnexion(DB_MAIN)

		Select Case LCase(sSortedField)
			Case "ulogin" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_LOGIN")
			Case "uemail" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_EMAIL")
			Case "udate" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_DATE")
			Case Else :
				' default value
				sSortedField = "uDate"
				bAscSort = False
				sSortDesc = GetTranslation("LANG_DATE")
		End Select

		If iTop <> "" and iTop <> 0 Then
			rSQL = "SELECT TOP " & iTop & " uLogin, uEmail, uDate FROM users ORDER BY " & sSortedField
		Else
			rSQL = "SELECT uLogin, uEmail, uDate FROM users ORDER BY " & sSortedField
		End If

		If Not bAscSort Then
			rSQL = rSQL & " DESC"
			sSortDesc = sSortDesc & " (DESC)"
		Else
			sSortDesc = sSortDesc & " (ASC)"
		End If

		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "TopAccounts", GetTranslation("LANG_TOP") & " " & iTop & " - " & GetTranslation("LANG_ACCOUNTS") & "&nbsp;|&nbsp;<span class=""small"">" & Replace(GetTranslation("LANG_SORT_BY"), "%1%", sSortDesc)  & "</span>"
		If Not oRs.EOF Then
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""100"">"
			SortMenu GetTranslation("LANG_LOGIN"), "uLogin", sSortedField, bAscSort
			Response.Write "</td>" & vbCRLF
			Response.Write "    <td width=""200"">"
			SortMenu GetTranslation("LANG_EMAIL"), "uEmail", sSortedField, bAscSort
			Response.Write "</td>" & vbCRLF
			Response.Write "    <td width=""120"">"
			SortMenu GetTranslation("LANG_DATE"), "uDate", sSortedField, bAscSort
			Response.Write "</td>" & vbCRLF
			Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("uLogin")) & "</td>" & vbCRLF
				Response.Write "    <td><a href=""" & GLOBAL_SITE_MAIL_PAGE & "?to=" & Server.HTMLEncode(oRs("uEmail")) & """>" & Server.HTMLEncode(oRs("uEmail")) & "</a></td>" & vbCRLF
				Response.Write "    <td align=""center"">" & StringToDate(oRs("uDate")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & vbCRLF
				MenuAdmin(Server.HTMLEncode(oRs("uLogin")))
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				oRs.MoveNext
			WEnd
			Response.Write "</table>" & vbCRLF
		End If
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display search's result on user accounts
	' IN  : sQuery (string) : query data
	' OUT : -
	Sub DisplayAccountsSearch(sQuery)
		Dim oCn, oRs, rSQL, iLine, iNum

		iNum = 0
	
		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT uLogin, uEmail, uDate FROM users WHERE uLogin LIKE '" & SQLEncrypt(sQuery) & "'"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "SearchAccounts", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_ACCOUNTS") & " (" & Server.HTMLEncode(Replace(sQuery, "%", "")) & ")"
		If Not oRs.EOF Then
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_LOGIN") & "</td>" & vbCRLF
			Response.Write "    <td width=""200"">" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
			Response.Write "    <td width=""120"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("uLogin")) & "</td>" & vbCRLF
				Response.Write "    <td><a href=""" & GLOBAL_SITE_MAIL_PAGE & "?to=" & Server.HTMLEncode(oRs("uEmail"))& """>" & Server.HTMLEncode(oRs("uEmail")) & "</a></td>" & vbCRLF
				Response.Write "    <td align=""center"">" & StringToDate(oRs("uDate")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & vbCRLF
				MenuAdmin(oRs(0))
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				iNum = iNum + 1
				oRs.MoveNext
			WEnd
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""4"">" & GetTranslation("LANG_ACC0UNTS_TOTAL") & " : " & iNum & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
		End If
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display a navigation bar for user accounts
	' IN  : -
	' OUT : -
	Sub DisplayAccountsNavigation()
		Dim X
		
		CreateTopTable "SearchAccounts", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_ACCOUNTS")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <form name=""Search"" method=""get"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "    <input type=""hidden"" name=""Do"" value=""search"">" & vbCRLF
		Response.Write "    <td>"
		Response.Write "&nbsp;<a href=""" & sURLPage & """>" & GetTranslation("LANG_TOP") & "</a>" & vbCRLF
		For X = 0 to 25
			Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=" & Chr(Asc("a")+X) & """>" & Chr(Asc("a")+X) & "</a>" & vbCRLF
		Next
		Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=0"">0-9</a>" & vbCRLF
		Response.Write "    &nbsp;<input name=""name"" size=""10"" maxlength=""20"" class=""cell"" onEnter=""javascript:document.search.submit()""></td>"
		Response.Write "    </form>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
	End Sub

	' Display edit user account's form (add or update data)
	' IN  : uID (string) : account's id (table users, field uLogin), if null then add account
	' OUT : -
	Sub EditAccount(uID)
		Dim oCn, oRs, oRs2, rSQL
		Dim sUserPseudo, sUserEmail, sUserDate, sMSN, sYahoo, sICQ, sAIM, sURL, sSignature, bUserNewsletter, iRole, sDo, sEditTitle

		Set oCn = DBConnexion(DB_MAIN)

		If uID <> "" Then
			sDo = "updt"
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_ACCOUNT")
			rSQL = "SELECT * FROM users WHERE uLogin LIKE '" & SQLEncrypt(uID) & "'"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sUserPseudo = oRs("uLogin")
				sUserEmail = oRs("uEmail")
				sUserDate = oRs("uDate")
				sMSN = oRs("uMSN")
				sYahoo = oRs("uYahoo")
				sICQ = oRs("uICQ")
				sAIM = oRs("uAIM")
				sURL = oRs("uURL")
				sSignature = oRs("uSignature")
				bUserNewsletter = oRs.Fields("uNewsletter").Value
				iRole = oRs("uRole")
			End If
		Else
			sDo = "add"
			sEditTitle = GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_ACCOUNT")
		End If
	
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "')) document.edition.submit();" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		CreateTopTable "Edit", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""uID"" value=""" & uID & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLf
		Response.Write "    <td width=""150"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_LOGIN") & "</td>" & vbCRLF
		Response.Write "    <td>" & Server.HTMLEncode(sUserPseudo) & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""uEMail"" value=""" & Server.HTMLEncode(sUserEmail) & """ maxlength=""50"" size=""30"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DATE_CREATED") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetDateDDMMYYHHMMSS(StringToDate(sUserDate)) & "<input type=""hidden"" name=""uDate"" value=""" & StringToDate(sUserDate) & """></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>MSN</td>" & vbCRLF
		Response.Write "    <td><input name=""uMSN"" value=""" & Server.HTMLEncode(sMSN) & """ size=""20"" maxlength=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>Yahoo Messenger</td>" & vbCRLF
		Response.Write "    <td><input name=""uYahoo"" value=""" & Server.HTMLEncode(sYahoo) & """ size=""20"" maxlength=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>ICQ</td>" & vbCRLF
		Response.Write "    <td><input name=""uICQ"" value=""" & Server.HTMLEncode(sICQ) & """ size=""20"" maxlength=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>AIM</td>" & vbCRLF
		Response.Write "    <td><input name=""uAIM"" value=""" & Server.HTMLEncode(sAIM) & """ size=""20"" maxlength=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_SITE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""uURL"" value=""" & Server.HTMLEncode(sURL) & """ size=""40"" maxlength=""250"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_SIGNATURE") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""uSignature"" class=""cell"">" & Server.HTMLEncode(sSignature) & "</textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_ROLE") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""uRole"" class=""button"">" & vbCRLF
		Response.Write "        <option value=""0"""
		If iRole = 0 Then Response.Write " selected"
		Response.Write ">-</option>" & vbCRLF
		
		rSQL = "SELECT rID, rTitle FROM roles ORDER BY rID"
		Set oRs2 = DBRecordSet(oCn, rSQL)
		While Not oRs2.EOF
			Response.Write "        <option value=""" & oRs2("rID") & """"
			If iRole = oRs2("rID") Then Response.Write " selected"
			Response.Write ">" & Server.HTMLEncode(oRs2("rTitle")) & "</option>" & vbCRLF
			oRs2.MoveNext
		WEnd

		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		If bNewsletter Then
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_NEWSLETTER") & "</td>" & vbCRLF
			Response.Write "    <td><input type=""checkbox"" name=""uNewsletter"""
			If bUserNewsletter Then Response.Write " checked"
			Response.Write "></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
		End If
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""confirmDo();""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
		Set oRs2 = Nothing
	End Sub

	' Modify user account (update query)
	' IN  : uID (string) : user's login (table users, field uLogin)
	'     : sMyEmail (string) : user's email (table users, field uEmail)
	'     : sMSN (string) : user's msn messenger id (table users, field uMSN)
	'     : sYahoo (string) : user's yahoo messenger id (table users, field uYahoo)
	'     : sICQ (string) : user's icq id (table users, field uICQ)
	'     : sAIM (string) : user's aim id (table users, field uAIM)
	'     : sURL (string) : user's website (table users, field uURL)
	'     : sSignature (string) : user's signature (table users, field uSignature)
	'     : dDate (datetime) : user's creation date (table users, field uDate)
	'     : bNewsletter (boolean) : user's newsletter signup (table users, field uNewsletter)
	'     : iRole (int) : user's role (table users, field uRole)
	' OUT : (boolean) : True if modified
	Function ModifyAccount(uID, sMyEmail, sMSN, sYahoo, sICQ, sAIM, sURL, sSignature, dDate, bNewsletter, iRole)
		Dim oCn, rSQL
		Set oCn = Server.CreateObject("ADODB.Connection")
		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE users SET uEmail='" & SQLEncrypt(sMyEmail) & "', uDate='" & DateTimeToString(dDate) & "', uMSN='" & SQLEncrypt(sMSN) & "', uYahoo='" & SQLEncrypt(sYahoo) & "', uICQ='" & SQLEncrypt(sICQ) & "', uAIM='" & SQLEncrypt(sAIM) & "', uURL='" & SQLEncrypt(sURL) & "', uSignature='" & SQLEncrypt(sSignature) & "', uNewsletter=" & bNewsletter & ", uRole=" & iRole & " WHERE uLogin='" & SQLEncrypt(uID) & "'"
		DBExecute oCn, rSQL
		oCn.Close
		Set oCn = Nothing
		ModifyAccount = True
	End Function

	' Delete user account (delete query)
	' IN  : uID (string) : user's login (table users, field uLogin)
	' OUT : True if deleted
	Function DeleteAccount(uID)
		Dim oCn, rSQL
		Set oCn = Server.CreateObject("ADODB.Connection")
		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "DELETE FROM users WHERE uLogin='" & SQLEncrypt(uID) & "'"
		DBExecute oCn, rSQL
		oCn.Close
		Set oCn = Nothing
		DeleteAccount = True
	End Function

	' Display deleting's form (to confirm)
	' IN  : uID (string) : user's login (table users, field uLogin)
	' OUT : -
	Sub ConfirmDeleteAccount(uID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If uID <> "" Then
			rSQL = "SELECT * FROM users WHERE uLogin='" & SQLEncrypt(uID) & "'"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delAccount()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "ConfirmDel", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""uLogin"" value=""" & Server.HTMLEncode(oRs("uLogin")) & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td><td>" & Server.HTMLEncode(oRs("uLogin")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_AUTHOR") & "</td><td>" & Server.HTMLEncode(oRs("uEMail")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td><td>" & StringToDate(oRs("uDate")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=""button"" onClick=""javascript:delAccount();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=""button"" onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If
		
		oCn.Close
		Set oCn = Nothing
	End Sub

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminAccounts()
		Dim bNewsletter
		Select Case Request("do")
			Case "updt" :
				If Request.Form("uNewsletter") <> "" Then
					bNewsletter = "1"
				Else
					bNewsletter = "0"
				End If
				If ModifyAccount(Request.Form("uID"), Request.Form("uEMail"), Request.Form("uMSN"), Request.Form("uYahoo"), Request.Form("uICQ"), Request.Form("uAIM"), Request.Form("uURL"), Request.Form("uSignature"), Request.Form("uDate"), bNewsletter, Request.Form("uRole")) Then 
					sInfoPage = GetTranslation("LANG_ACCOUNT") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_ACCOUNT") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del" : 
				If DeleteAccount(Request("uLogin")) Then 
					sInfoPage = GetTranslation("LANG_ACCOUNT") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_ACCOUNT") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub

	' Display user accounts page
	' IN  : -
	' OUT : -
	Sub DisplayAdminAccountsPage()
		Dim bDisplayTop, bDisplayNav, bAscSorted, sSortedField
		
		bAscSorted = True
		sSortedField = ""
		
		sSortedField = Request.QueryString("sort")
		If sSortedField <> "" Then sSortedField = LCase(sSortedField)
		If Request.QueryString("sortype") = "desc" Then	bAscSorted = False

		bDisplayTop = True
		bDisplayNav = True
		
		Select Case Request("do")
			Case "search" :
				If Len(Request("name")) = 1 Then
					If Request("name") <> "0" Then
						DisplayAccountsSearch Request("name") & "%"
					Else
						DisplayAccountsSearch "[0-9]%"
					End If
				ElseIf Len(Request("name")) > 1 Then
					DisplayAccountsSearch Request("name") & "%"
				End If
				bDisplayTop = False
			Case "view" : 
				DisplayAdminAccount Request("id")
				bDisplayTop = False
			Case "new"  : 
				EditAccount 0
				bDisplayTop = False
			Case "edit" : 
				EditAccount Request("id")
				bDisplayTop = False
			Case "cdel" : 
				ConfirmDeleteAccount Request("id")
				bDisplayTop = False
		End Select

		If bDisplayTop Then DisplayTopAccounts 10, sSortedField, bAscSorted
		If bDisplayNav Then DisplayAccountsNavigation()
	End Sub
%>