<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Gives information since the last visit
	Sub AllInfo()
		Dim oCn, oRs, rSQL, iLine, sTemp
		
		Set oCn = DBConnexion(DB_MAIN)

		CreateTable "LastVisit", Replace(GetTranslation("LANG_TITLE_DEFAULT2"), "%1%", Server.HTMLEncode(sPseudo)),  Replace(GetTranslation("LANG_LAST_VISIT"), "%1%", GetDateLitteralDDMMYYYYHHMMSS(StringToDate(sLastVisit))), ""

		' Last news
		If GLOBAL_NEWS_TOP > 0 Then
			rSQL = "SELECT TOP 10 nID, nTitle, nAuthor, nDate FROM news where nDate > '" & sLastVisit & "' ORDER BY nDate DESC"
			Set oRs = DBRecordSet(oCn, rSQL)

			CreateTopTable "LastNews", GetTranslation("LANG_NEWS")
			If Not oRs.EOF Then
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
				Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = 1
				While Not oRs.EOF
					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td><a href=""" & GLOBAL_SITE_NEWS_PAGE & "?do=view&id=" & oRs("nID") & """>" & CodeMessage(oRs("nTitle"), True) & "</a></td>" & vbCRLF
					Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("nAuthor")) & "</td>" & vbCRLF
					Response.Write "    <td align=""center"" width=""120"">" & GetDateDDMMYYYY(StringToDate(oRs("nDate"))) & "</td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
					
					iLine = ((iLine - 1) XOr 1) + 1
					oRs.MoveNext
				WEnd
				Response.Write "</table>" & vbCRLF
			End If
			CreateBottomTable ""

			' Last comments
			rSQL = "SELECT TOP 10 cID, cAuthor, cRate, cType, cText FROM comments where cDate > '" & sLastVisit & "' ORDER BY cDate DESC"
			Set oRs = DBRecordSet(oCn, rSQL)

			CreateTopTable "LastComments", GetTranslation("LANG_COMMENTS")
			If Not oRs.EOF Then
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td width=""100"">" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TEXT") & "</td>" & vbCRLF
				Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_TYPE") & "</td>" & vbCRLF
				Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_RATING") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = 1
				While Not oRs.EOF
					sTemp = oRs("cText")
					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td>"
					If oRs("cAuthor") = "" Then
						Response.Write GetTranslation("LANG_ANONYM")
					Else
						Response.Write Server.HTMLEncode(oRs("cAuthor"))
					End If
					Response.Write "</td>" & vbCRLF
					Response.Write "    <td><a href=""" & GLOBAL_SITE_COMMENTS_PAGE & "?do=view&id=" & oRs("cID") & """>" & CodeMessageEx(sTemp, 40, True, True) & "</a></td>" & vbCRLF
					Response.Write "    <td align=""center"">" 
					Select Case oRs("cType")
						Case CATEGORY_TYPE_NEWS : Response.Write GetTranslation("LANG_NEWS")
						Case CATEGORY_TYPE_DOWNLOADS : Response.Write GetTranslation("LANG_DOWNLOADS")
						Case CATEGORY_TYPE_DIRECTORY : Response.Write GetTranslation("LANG_DIRECTORY")
						Case CATEGORY_TYPE_IMAGES : Response.Write GetTranslation("LANG_IMAGES")
						Case CATEGORY_TYPE_ARTICLES : Response.Write GetTranslation("LANG_ARTICLES")
						Case Else : Response.Write "-"
					End Select
					Response.Write "</td>" & vbCRLF
					Response.Write "    <td align=""center""><img src=""" & GLOBAL_SITE_IMAGES_PATH & "rate_" & oRs("cRate") & ".gif"" border=""0""></td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
					
					iLine = ((iLine - 1) XOr 1) + 1
					oRs.MoveNext
				WEnd
				Response.Write "</table>" & vbCRLF
			End If
			CreateBottomTable ""
		End If

		' Last articles
		If GLOBAL_ARTICLES_TOP > 0 Then
			rSQL = "SELECT TOP 10 arID, arTitle, arAuthor, arDate FROM articles where arDate > '" & sLastVisit & "' ORDER BY arDate DESC"
			Set oRs = DBRecordSet(oCn, rSQL)

			CreateTopTable "LastArticles", GetTranslation("LANG_ARTICLES")
			If Not oRs.EOF Then
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
				Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = 1
				While Not oRs.EOF
					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td><a href=""" & GLOBAL_SITE_ARTICLES_PAGE & "?do=view&id=" & oRs("arID") & """>" & CodeMessage(oRs("arTitle"), True) & "</a></td>" & vbCRLF
					Response.Write "    <td align=""center"" width=""100"">" & Server.HTMLEncode(oRs("arAuthor")) & "</td>" & vbCRLF
					Response.Write "    <td align=""center"" width=""120"">" & GetDateDDMMYYYY(StringToDate(oRs("arDate"))) & "</td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
					
					iLine = ((iLine - 1) XOr 1) + 1
					oRs.MoveNext
				WEnd
				Response.Write "</table>" & vbCRLF
			End If
			CreateBottomTable ""
		End If

		' Last downloads
		If GLOBAL_DOWNLOADS_TOP > 0 Then
			rSQL = "SELECT TOP 10 dID, dTitle, dHits, cTitle, vCode FROM downloads, categories, versions where dCategory=cID AND dVersion=vID AND dDate > '" & sLastVisit & "' ORDER BY dDate DESC"
			Set oRs = DBRecordSet(oCn, rSQL)

			CreateTopTable "LastDownloads", GetTranslation("LANG_DOWNLOADS")
			If Not oRs.EOF Then
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td width=""150"" align=""center"">" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
				Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
				Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1
				While Not oRs.EOF
					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td><a href=""" & GLOBAL_SITE_DOWNLOADS_PAGE & "?do=view&id=" & oRs("dID") & """>" & Server.HTMLEncode(oRs("dTitle")) & "</a></td>" & vbCRLF
					Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("cTitle")) & "</td>" & vbCRLF
					Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("vCode")) & "</td>" & vbCRLF
					Response.Write "    <td align=""center"">" & oRs("dHits") & "</td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
					
					iLine = ((iLine - 1) XOr 1) + 1
					oRs.MoveNext
				WEnd
				Response.Write "</table>" & vbCRLF
			End If
			CreateBottomTable ""
		End If

		' Last websites in directory
		rSQL = "SELECT TOP 10 dID, dTitle, dURL, dValid, dCategory, vCode, cTitle FROM directory, versions, categories WHERE dCategory=cID AND dVersion=vID AND dDate > '" & sLastVisit & "' ORDER BY dDate DESC"
		Set oRs = DBRecordSet(oCn, rSQL)

		CreateTopTable "LastWebsites", GetTranslation("LANG_DIRECTORY")
		If Not oRs.EOF Then
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
			Response.Write "    <td width=""150"" align=""center"">" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
			Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
			Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td><a href=""" & GLOBAL_SITE_DIRECTORY_PAGE & "?do=view&id=" & oRs("dID") & "&cat=" & oRs("dCategory") & """>" & Server.HTMLEncode(oRs("dTitle")) & "</a></td>" & vbCRLF
				Response.Write "    <td><a href=""" & Server.HTMLEncode(oRs("dURL")) & """ target=_""blank"">" & Server.HTMLEncode(oRs("dURL")) & "</a></td>" & vbCRLF
				Response.Write "    <td width=""150"" align=""center"">" & Server.HTMLEncode(oRs("cTitle")) & "</td>" & vbCRLF
				Response.Write "    <td width=""50"" align=""center"">" & Server.HTMLEncode(oRs("vCode")) & "</td>" & vbCRLF
				Response.Write "    <td width=""50"" align=""center"">" & oRs("dValid") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = ((iLine - 1) XOr 1) + 1
				oRs.MoveNext
			WEnd
			Response.Write "</table>" & vbCRLF
		End If
		CreateBottomTable ""

		' Last images
		rSQL = "SELECT TOP 10 iID, iTitle, iHits, cTitle, vCode FROM images, categories, versions where iCategory=cID AND iVersion=vID AND iDate > '" & sLastVisit & "' ORDER BY iDate DESC"
		Set oRs = DBRecordSet(oCn, rSQL)

		CreateTopTable "LastImages", GetTranslation("LANG_IMAGES")
		If Not oRs.EOF Then
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td width=""150"" align=""center"">" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
			Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
			Response.Write "    <td width=""50"" align=""center"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td><a href=""" & GLOBAL_SITE_IMAGES_PAGE & "?do=view&id=" & oRs("iID") & """>" & Server.HTMLEncode(oRs("iTitle")) & "</a></td>" & vbCRLF
				Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("cTitle")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("vCode")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & oRs("iHits") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = ((iLine - 1) XOr 1) + 1
				oRs.MoveNext
			WEnd
			Response.Write "</table>" & vbCRLF
		End If
		CreateBottomTable ""

		' Last polls
		If GLOBAL_POLLS_TOP > 0 Then
			rSQL = "SELECT TOP 10 * FROM polls where pDateBegin > '" & sLastVisit & "' ORDER BY pDateBegin DESC, pDateEnd DESC"
			Set oRs = DBRecordSet(oCn, rSQL)

			CreateTopTable "LastPolls", GetTranslation("LANG_POLLS")
			If Not oRs.EOF Then
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_DATE_BEGIN") & "</td>" & vbCRLF
				Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_DATE_END") & "</td>" & vbCRLF
				Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = 1
				While Not oRs.EOF
					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td><a href=""" & GLOBAL_SITE_POLLS_PAGE & "?do=view&id=" & oRs("pID") & """>" & Server.HTMLEncode(oRs("pTitle")) & "</a></td>" & vbCRLF
					Response.Write "    <td align=""center"">" & StringToDate(oRs("pDateBegin")) & "</td>" & vbCRLF
					Response.Write "    <td align=""center"">" & StringToDate(oRs("pDateEnd")) & "</td>" & vbCRLF
					Response.Write "    <td align=""center"">" & oRs("pValid") & "</td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
					
					iLine = ((iLine - 1) XOr 1) + 1
					oRs.MoveNext
				WEnd
				Response.Write "</table>" & vbCRLF
			End If
			CreateBottomTable ""
		End If

		' Last accounts
		rSQL = "SELECT TOP 10 uLogin, uEMail, uURL, rTitle FROM users, roles where uRole=rID AND uDate > '" & sLastVisit & "' ORDER BY uDate DESC"
		Set oRs = DBRecordSet(oCn, rSQL)

		CreateTopTable "LastAccounts", GetTranslation("LANG_ACCOUNTS")
		If Not oRs.EOF Then
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_LOGIN") & "</td>" & vbCRLF
			Response.Write "    <td width=""150"">" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
			Response.Write "    <td width=""250"">" & GetTranslation("LANG_SITE") & "</td>" & vbCRLF
			Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ROLE") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			
			iLine = 1
			While Not oRs.EOF
				sTemp = oRs("uURL")
				If sTemp <> "" Then
					If Left(LCase(sTemp), 7) <> "http://" Then sTemp = "http://" & sTemp
				End If
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td><a href=""" & GLOBAL_SITE_ACCOUNTS_PAGE & "?do=view&id=" & oRs("uLogin") & """>" & Server.HTMLEncode(oRs("uLogin")) & "</a></td>" & vbCRLF
				Response.Write "    <td><a href=""" & GLOBAL_SITE_MAIL_PAGE & "?to=" & Server.HTMLEncode(oRs("uEmail")) & """>" & Server.HTMLEncode(oRs("uEmail")) & "</a></td>" & vbCRLF
				Response.Write "    <td><a href=""" & Server.HTMLEncode(sTemp) & """ target=""_blank"">" & Server.HTMLEncode(sTemp) & "</a></td>" & vbCRLF
				Response.Write "    <td align=""center"">" & Server.HTMLEncode(oRs("rTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = ((iLine - 1) XOr 1) + 1
				oRs.MoveNext
			WEnd
			Response.Write "</table>" & vbCRLF
		End If
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub
%>