<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display categorie's information
	' IN  : iID (int) : categorie's id (table categories, field cID)
	' OUT : -
	Sub DisplayCategory(iID)
		Dim oCn, oRs, rSQL
		
		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT cTitle, cDescription, cImage, tcTitle  FROM categories, typescategories WHERE cType=tcID AND cID=" & iID
		
		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then 
			CreateTopTable "Category", GetTranslation("LANG_CATEGORY")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""120"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("cTitle")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("cDescription")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td valign=""top"">" & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
			Response.Write "    <td>"
			If oRs("cImage") <> "" Then
				Response.Write "<img src=""" &  Server.HTMLEncode(oRs("cImage"))  & """ border=""0"">"
			Else
				Response.Write "-"
			End If
			Response.Write "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TYPE") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("tcTitle")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display all categories by type
	' IN  : iType (int) : category's type
	'     : iCategoryParent (int) : category's parent (0 if root)
	' OUT : -
	Sub DisplayAllCategories(iType, iCategoryParent)
		Dim oCn, oRs, oRs2, rSQL, iLine, sTypeTitle, sSubCatTitle, iSubCatParent

		If iType <> 0 and iType <> "" Then
			Set oCn = DBConnexion(DB_MAIN)
			iSubCatParent = 0

			rSQL = "SELECT * FROM typescategories WHERE tcID=" & iType

			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				sTypeTitle = oRs("tcTitle")
				If iCategoryParent <> 0 Then
					rSQL = "SELECT cParent, cTitle FROM categories WHERE cType=" & iType & " AND cID=" & iCategoryParent
					Set oRs = DBRecordSet(oCn, rSQL)
					If Not oRs.EOF Then
						sSubCatTitle = oRs("cTitle")
						iSubCatParent = oRs("cParent")
					End If
				End If
				
				If sSubCatTitle <> "" Then
					CreateTopTable "AllCategories", GetTranslation("LANG_CATEGORIES") & " - " & Server.HTMLEncode(sSubCatTitle) & " / " & Server.HTMLEncode(sTypeTitle)
				Else
					CreateTopTable "AllCategories", GetTranslation("LANG_CATEGORIES") & " / " & Server.HTMLEncode(sTypeTitle)
				End If

				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				rSQL = "SELECT cID, cTitle FROM categories WHERE cType=" & iType & " AND cParent=" & iCategoryParent & " ORDER BY cTitle"
				Set oRs = DBRecordSet(oCn, rSQL)

				iLine = 1
				While Not oRs.EOF
					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					
					rSQL = "SELECT Count(*) FROM categories WHERE cParent=" & oRs("cID")
					Set oRs2 = DBRecordSet(oCn, rSQL)

					If oRs2(0) > 0 Then
						Response.Write "    <td><a href=""" & sURLPage & "?type=" & iType & "&icat=" & oRs("cID") & """>" & Server.HTMLEncode(oRs("cTitle")) & "</a> (" & oRs2(0) & ")</td>" & vbCRLF
					Else
						Response.Write "    <td>" & Server.HTMLEncode(oRs("cTitle")) & "</td>" & vbCRLF				
					End If
					Response.Write "    <td align=""center"">" & vbCRLF
					MenuAdmin(oRs("cID")&"&type=" & iType & "&icat=" & iCategoryParent)
					Response.Write "    </td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF

					iLine = ((iLine-1) XOR 1) + 1
					oRs.MoveNext
				WEnd

				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2""><a href=""" & sUrlPage & "?do=new&type=" & iType & """>" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_CATEGORY") & "</a></td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				If iCategoryParent <> 0 Then
					Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
					Response.Write "    <td colspan=""2""><a href=""" & sUrlPage & "?type=" & iType & "&icat=" & iSubCatParent & """>" & GetTranslation("LANG_BACK") & "</a></td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
				End If
				Response.Write "</table>" & vbCRLF

				CreateBottomTable ""
			End If

			oCn.Close
			Set oCn = Nothing	
			Set oRs = Nothing
			Set oRs2 = Nothing
		End If
	End Sub

	' Display menu of different categories type
	' IN  : -
	' OUT : -
	Sub DisplayCategoriesNavigation()
		Dim oCn, oRs, rSQL, iLine, X

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT * FROM typescategories ORDER BY tcID"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "SearchCategories", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_CATEGORIES")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		X = 0
		iLine = 1

		While Not oRs.EOF
			If X Mod 2 = 0 Then 
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				iLine = ((iLine - 1 ) XOr 1) + 1
			End If
			Response.Write "    <td width=""50%""><a href=""" & sURLPage & "?type=" & oRs("tcID") & """>" & Server.HTMLEncode(oRs("tcTitle")) & "</td>" & vbCRLF
			If X Mod 2 = 1 Then Response.Write "  </tr>" & vbCRLF

			X = X + 1
			oRs.MoveNext
		WEnd

		If X Mod 2 = 1 Then 
			Response.Write "    <td width=""50%"">&nbsp;</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
		End If

		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Edit category (add or update)
	' IN  : iID (int) : categorie's id (table categories, field cID) if null or = 0 then added
	'     : iType (int) : categorie's type (table categories, field cType)
	' OUT : -
	Sub EditCategory(iID, iType)
		Dim oCn, oRs, rSQL
		Dim sEditTitle, sDo, sTitle, sDescription, sImage, iParent, sCatTypeTitle

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_CATEGORY")
			sDo = "updt"
			rSQL = "SELECT cTitle, cDescription, cParent, cType, cImage, tcTitle FROM categories, typescategories WHERE cType=tcID AND  cID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				sTitle = oRs("cTitle")
				sDescription = oRs("cDescription")
				iParent = oRs("cParent")
				sImage = oRs("cImage")
				sCatTypeTitle = oRs("tcTitle")
			End If
		Else
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_CATEGORY")
			rSQL = "SELECT tcTitle FROM typescategories WHERE tcID = " & iType
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				sCatTypeTitle = oRs("tcTitle")
			End If
			sDo = "add"
			iParent = 0		
			sTitle = ""
			sDescription = ""
			sImage = ""
		End If
	
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
		Response.Write "     {" & vbCRLF
		Response.Write "       document.edition.submit();" & vbCRLF
		Response.Write "     }" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "  function openPicture()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "	var sMyPicture = document.edition.cImage.value;" & vbCRLF
		Response.Write "    if (sMyPicture != '')"
		Response.Write "	{" & vbCRLF
		Response.Write "		window.open('" & GLOBAL_SITE_PATH & GLOBAL_SITE_VIEW_IMAGE_PAGE & "?img=' + sMyPicture, 'Picture', 'width=500,height=100,menubar=no,resizable=yes');" & vbCRLF
		Response.Write "	}" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		CreateTopTable "Edit", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & "?type=" & iType & "&icat=" & iParent & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""cID"" value=""" & iID & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td width=""120"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""cTitle"" value=""" & Server.HTMLEncode(sTitle & "") & """ maxlength=""50"" size=""30"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""cDescription"" value=""" & Server.HTMLEncode(sDescription & "") & """ maxlength=""250"" size=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <input name=""cImage"" value=""" & Server.HTMLEncode(sImage & "") & """ maxlength=""200"" size=""50"" class=""cell"">" & vbCRLF
		Response.Write "      <a href=""javascript:openPicture()""><img src=""" & GLOBAL_SITE_IMAGES_PATH & "view.gif"" border=""0""></a>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_PARENT_CATEGORY") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""cParent"" class=""cell"">" & vbCRLF
		Response.Write "        <option value=""0"""
		If iParent = 0 Then Response.Write " selected"
		Response.Write ">-</option>" & vbCRLF

		rSQL = "SELECT cTitle, cID FROM categories WHERE cType=" & iType & " ORDER BY cTitle"
		Set oRs = DBRecordSet(oCn, rSQL)
	
		While Not oRs.EOF
			Response.Write "        <option value=""" & oRs("cID") & """"
			If iParent = oRs("cID") Then Response.Write " selected"
			Response.Write ">" & Server.HTMLEncode(oRs("cTitle")) & "</option>" & vbCRLF
			oRs.MoveNext
		WEnd

		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TYPE") & "</td>" & vbCRLF
		Response.Write "    <td>" & Server.HTMLEncode(sCatTypeTitle) & "<input type=""hidden"" name=""cType"" value=""" & iType & """></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value="" " & GetTranslation("LANG_SUBMIT") & " "" class=""button"" onClick=""confirmDo();""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add a new category (insert query)
	' IN  : sTitle (string) : category's name (table categories, field cTitle)
	'     : sDescription (string) : category's description (table categories, field cDescription)
	'     : sImage (string) : category's picture (table categories, field cImage)
	'     : iParent (int) : category's parent (table categories, field cParent)
	'     : iType (int) : category's type (table categories, field cType)
	' OUT : (boolean) : True if added
	Function AddCategory(sTitle, sDescription, sImage, iParent, iType)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "INSERT INTO categories (cTitle, cDescription, cImage, cParent, cType) VALUES ('" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sDescription) & "', '" & SQLEncrypt(sImage) & "', " & iParent & ", " & iType & ")"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		AddCategory = True
	End Function

	' Modify category (update query)
	' IN  : iID (int) : category's id (table categories, field cID)
	'     : sTitle (string) : category's name (table categories, field cTitle)
	'     : sDescription (string) : category's description (table categories, field cDescription)
	'     : sImage (string) : category's picture (table categories, field cImage)
	'     : iParent (int) : category's parent (table categories, field cParent)
	'     : iType (int) : category's type (table categories, field cType)
	' OUT : (boolean) : True if modified
	Function ModifyCategory(iID, sTitle, sDescription, sImage, iParent, iType)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE categories SET cTitle = '" & SQLEncrypt(sTitle) & "', cDescription = '" & SQLEncrypt(sDescription) & "', cImage = '" & SQLEncrypt(sImage) & "', cParent = " & iParent & ", cType=" & iType & " WHERE cID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		ModifyCategory = True
	End Function

	' Delete category (delete query)
	' IN  : iID (int) : category's id (table categories, field cID)
	' OUT : -
	Function DeleteCategory(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)			
		rSQL = "DELETE FROM categories WHERE cID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		DeleteCategory = True			
	End Function
	
	' Display deleting's form
	' IN  : iID (int) : category's id (table categories, field cID)
	' OUT : -
	Sub ConfirmDeleteCategory(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT cTitle, cDescription FROM categories WHERE cID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function DeleteCategory()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "DeleteCategory", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""cID"" value=""" & iID & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td><td>" & Server.HTMLEncode(oRs("cTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td><td>" & Server.HTMLEncode(oRs("cDescription")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=button onClick=""DeleteCategory();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=button onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub
	
	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminCategories()
		Select Case Request("do") 
			Case "add"  : 
				If AddCategory(Request.Form("cTitle"), Request.Form("cDescription"), Request.Form("cImage"), Request.Form("cParent"), Request.Form("cType")) Then 
					sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			Case "updt" : 
				If ModifyCategory(Request.Form("cID"), Request.Form("cTitle"), Request.Form("cDescription"), Request.Form("cImage"), Request.Form("cParent"), Request.Form("cType")) Then 
					sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del"  :
				If DeleteCategory(Request.Form("cID")) Then 
					sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_CATEGORY") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub
	
	' Display page
	' IN  : -
	' OUT : -
	Sub DisplayAdminCategoriesPage()
		Dim iType, iCategory

		iType = Request.QueryString("type")
		If iType <> "" And IsNumeric(iType) Then 
			iType = CInt(iType)
		Else
			iType = 0
		End If
		iCategory = Request.QueryString("icat")
		If iCategory <> "" And IsNumeric(iCategory) Then 
			iCategory = CInt(iCategory)
		Else
			iCategory = 0
		End If	

		Select Case Request("do")
			Case "view" : 
				DisplayCategory Request("id")
			Case "new"  : 
				EditCategory 0, iType
			Case "edit" : 
				EditCategory Request("id"), iType
			Case "cdel" : 
				ConfirmDeleteCategory Request("id")
		End Select

		DisplayCategoriesNavigation()
		If iType <> 0 Then DisplayAllCategories iType, iCategory
	End Sub
%>