<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display poll
	' IN  : iID (int) : poll's id (table polls, field pID)
	' OUT : -
	Sub DisplayAdminPoll(iID)
		Dim oCn, oRs, rSQL, nbVotes, MaxHits, iTdWidth

		Set oCn = DBConnexion(DB_MAIN)

		nbVotes = 0
		MaxHits = 0
		rSQL = "SELECT Sum(prHits) as nbVotes, Max(prHits) as MaxHits FROM pollsresults WHERE prPoll=" & iID
		Set oRs = DBRecordSet(oCn, rSQL)
		nbVotes = oRs("nbVotes")
		MaxHits = oRs("MaxHits")
		If MaxHits <= 0 Then MaxHits = 1

		rSQL = "SELECT * FROM polls, pollsresults WHERE pID=prPoll AND pID=" & iID

		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then
			Response.Write "	  <a name=""poll_" & oRs("pID") & """>" & vbCRLF
			CreateTopTable "poll_" & oRs("pID"), GetTranslation("LANG_POLL")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2"" align=""center"">" &  Server.HTMLEncode(oRs("pTitle")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			While Not oRs.EOF
				iTdWidth = Round(100*(oRs("prHits")/MaxHits))
				Response.Write "  <tr>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("prText")) & " (<b>" & oRs("prHits") & "</b>)<br>" & vbCRLF
				Response.Write "      <table width=""100%"" cellspacing=""0"" cellpadding=""0"">" & vbCRLF
				Response.Write "        <tr><td width=""" & iTdWidth & "%"" bgcolor=""" & oRs("pColor") & """><img src=""imgs/blank.gif"" height=""10"" border=""0""></td><td width=""" & 100-iTdWidth & "%""></td></tr>" & vbCRLF
				Response.Write "      </table>" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				oRs.MoveNext
			WEnd
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2"" align=""center"">" & GetTranslation("LANG_VOTES") & " : " & nbVotes & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing		
	End Sub

	' Display the top polls list by date
	' IN  : iTop (int) : number of results wanted
	' OUT : -
	Sub DisplayAdminTopPolls(iTop)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT TOP " & iTop & " pID FROM polls WHERE pDateBegin <= '" & DateTimeToString(Now()) & "' AND (pDateEnd >= '" & DateTimeToString(Now()) & "' OR pDateEnd < pDateBegin) ORDER BY pDateBegin DESC, pDateEnd DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then 
			While Not oRs.EOF
				DisplayPoll oRs("pID")
				oRs.MoveNext
			WEnd
		End If
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing		
	End Sub

	' Display all polls
	' IN  : -
	' OUT : -
	Sub DisplayAdminAllPolls()
		Dim oCn, oRs, rSQL, iLine

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT pID, pTitle, pDateBegin, pDateEnd, pValid, Sum(prHits) as NbVotes FROM polls, pollsresults WHERE prPoll=pID GROUP BY pID, pTitle, pDateBegin, pDateEnd, pValid ORDER BY pDateBegin DESC, pDateEnd DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "AllPolls", GetTranslation("LANG_POLLS")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td width=""150"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td align=""center"">" & GetTranslation("LANG_DATE_BEGIN") & "</td>" & vbCRLF
		Response.Write "    <td align=""center"">" & GetTranslation("LANG_DATE_END") & "</td>" & vbCRLF
		Response.Write "    <td width=""40"" align=""center"">" & GetTranslation("LANG_VOTES") & "</td>" & vbCRLF
		Response.Write "    <td width=""40"" align=""center"">" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
			
		iLine = 1
		While Not oRs.EOF
			Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("pTitle")) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & StringToDate(oRs("pDateBegin")) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & StringToDate(oRs("pDateEnd")) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & oRs("nbVotes") & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & oRs("pValid") & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & vbCRLF
			MenuAdmin(oRs("pID"))
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1 + ((iLine-1) XOR 1)
			oRs.MoveNext
		WEnd
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""6""><a href=""" & sURLPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_POLL") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Edit poll (to add or modify)
	' IN  : iID (int) : poll's id (table polls, field pID)
	' OUT : -
	Sub EditPoll(iID)
		Dim oCn, oRs, rSQL, X, iLine
		Dim sEditTitle, sDo, sTitle, dDateBegin, dDateEnd, sColor, iVersion, bValid

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sDo = "updt"
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_POLL")
			rSQL = "SELECT * FROM polls WHERE pID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sTitle = oRs("pTitle")
				dDateBegin = StringToDate(oRs("pDateBegin"))
				dDateEnd = StringToDate(oRs("pDateEnd"))
				sColor = oRs("pColor")
				bValid = oRs("pValid").Value
				iVersion = oRs("pVersion")
			End If
		Else
			sDo = "add"
			sEditTitle = GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_POLL")
			sColor = "#000000"
			iVersion = 1
			dDateBegin = Now()
			dDateEnd = DateAdd("d", 7, Now())
		End If

		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
		Response.Write "     {" & vbCRLF
		Response.Write "       document.edition.submit();" & vbCRLF
		Response.Write "     }" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF

		CreateTopTable "EditPoll", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=edition method=post action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""pID"" value=""" & iID & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""pTitle"" value=""" & sTitle & """ maxlength=""150"" size=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DATE_BEGIN") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""sJourDebut"" class=""cell"">" & vbCRLF
		For X = 1 to 31
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Day(dDateBegin) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      <select name=""sMoisDebut"" class=""cell"">" & vbCRLF
		For X = 1 to 12
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Month(dDateBegin) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      <select name=""sAnneeDebut"" class=""cell"">" & vbCRLF
		For X = Year(DateAdd("yyyy", -2, dDateBegin)) to Year(DateAdd("yyyy", 2, Date))
			Response.Write "      <option value=""" & X & """"
			If X = Year(dDateBegin) Then Response.Write " selected"
			Response.Write ">" & X & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "       " & vbCRLF
		Response.Write "      <select name=""sHeureDebut"" class=""cell"">" & vbCRLF
		For X = 0 to 23
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Hour(dDateBegin) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      h " & vbCRLF
		Response.Write "      <select name=""sMinuteDebut"" class=""cell"">" & vbCRLF
		For X = 0 to 59
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Minute(dDateBegin) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      mn" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DATE_END") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""sJourFin"" class=""cell"">" & vbCRLF
		For X = 1 to 31
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Day(dDateEnd) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      <select name=""sMoisFin"" class=""cell"">" & vbCRLF
		For X = 1 to 12
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Month(dDateEnd) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      <select name=""sAnneeFin"" class=""cell"">" & vbCRLF
		For X = Year(DateAdd("yyyy", -2, dDateEnd)) to Year(DateAdd("yyyy", 2, Date))
			Response.Write "      <option value=""" & X & """"
			If X = Year(dDateEnd) Then Response.Write " selected"
			Response.Write ">" & CStr(X) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "       " & vbCRLF
		Response.Write "      <select name=""sHeureFin"" class=""cell"">" & vbCRLF
		For X = 0 to 23
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Hour(dDateEnd) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      h " & vbCRLF
		Response.Write "      <select name=""sMinuteFin"" class=""cell"">" & vbCRLF
		For X = 0 to 59
			Response.Write "      <option value=""" & Right("0" & CStr(X), 2) & """"
			If X = Minute(dDateEnd) Then Response.Write " selected"
			Response.Write ">" & Right("0" & CStr(X), 2) & "</option>" & vbCRLF
		Next
		Response.Write "      </select>" & vbCRLF
		Response.Write "      mn" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_COLOR") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <input name=""pColor"" class=""cell"" maxlength=""10"" size=""10"" value=""" & sColor & """>" & vbCRLF
		Response.Write "	</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
		Response.Write "    <td><input type=""checkbox"" name=""pValid"""
		If bValid Then Response.Write " checked"
		Response.Write "></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF

		X = 0
		iLine = 2
		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT * FROM pollsresults WHERE prPoll=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)

			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td><b>" & X+1 & "</b></td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("prText")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				X = X + 1
				iLine = 1 + ((iLine-1) XOR 1)
				oRs.MoveNext
			WEnd
			X = GLOBAL_POLLS_MAX_RESULTS
		End If

		While X < GLOBAL_POLLS_MAX_RESULTS
			Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
			Response.Write "    <td><b>" & X+1 & "</b></td>" & vbCRLF
			Response.Write "    <td>" & vbCRLF
			Response.Write "	  <input type=""hidden"" name=""rpID_" & X & """ value="""">" & vbCRLF
			Response.Write "	  <input name=""prText_" & X & """ class=""cell"" size=""50"" maxlength=""100"" value="""">" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			X = X + 1
			iLine = 1 + ((iLine-1) XOR 1)
		WEnd
		
		Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""pVersion"" class=""cell"">" & vbCRLF
		
		rSQL = "SELECT vID, vCode FROM Versions"
		Set oRs = DBRecordSet(oCn, rSQL)
		While Not oRs.EOF
			Response.Write "        <option value=""" & oRs("vID") & """"
			If oRs("vID") = iVersion Then Response.Write " selected"
			Response.Write ">" & Server.HTMLEncode(oRs("vCode")) & "</option>" & vbCRLF
			oRs.MoveNext
		WEnd

		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""confirmDo();"" name=""benvoi""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display deleting page
	' IN  : iID (int) : poll's id
	' OUT : -
	Sub ConfirmDeletePoll(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT * FROM polls WHERE pID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delPoll()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "DeletePoll", GetTranslation("LANG_DELETE") & " - " & GetTranslation("LANG_POLL")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""pID"" value=""" & iID & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td><td>" & Server.HTMLEncode(oRs("pTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DATE_BEGIN") & "</td><td>" & StringToDate(oRs("pDateBegin")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DATE_END") & "</td><td>" & StringToDate(oRs("pDateEnd")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=button name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=""button"" onClick=""delPoll();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=button name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=""button"" onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add a new poll (insert query)
	' IN  : sTitle (string) : poll's title (table polls, field pTitle)
	'     : dDateBegin (datetime) : poll's beginning date (table polls, field pDateBegin)
	'     : dDateEnd (datetime) : poll's ending date (table polls, field pDateEnd)
	'     : tAnswers (string table) : poll's answers (table pollsresults, field prTitle)
	'     : sColor (string) : poll's display bars color (table polls, field pColor)
	'     : iVersion (int) : poll's version (table polls, field pVersion)
	'     : bValid (boolean) : poll's validation (table polls, field pValid)
	' OUT : (boolean) : True if added
	Function AddPoll(sTitle, dDateBegin, dDateEnd, tAnswers, sColor, iVersion, bValid)
		Dim oCn, oRs, rSQL, X

		AddPoll = False

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "INSERT INTO polls (pTitle, pDateBegin, pDateEnd, pColor, pVersion, pValid) VALUES ('" & SQLEncrypt(sTitle) & "', '" & DateTimeToString(dDateBegin) & "', '" & DateTimeToString(dDateEnd) & "', '" & SQLEncrypt(sColor) & "', " & iVersion & ", " & bValid & ")"
		DBExecute oCn, rSQL
		
		rSQL = "SELECT TOP 1 pID FROM polls ORDER BY pID DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then
			For X = 0 To UBound(tAnswers)
				If Len(tAnswers(X)) > 0 Then
					rSQL = "INSERT INTO pollsresults (prPoll, prText, prHits) VALUES (" & oRs(0) & ", '" & SQLEncrypt(tAnswers(X)) & "', 0)"
					DBExecute oCn, rSQL
				End If
			Next
			AddPoll = True
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function

	' Modify poll (update query)
	' IN  : iID (int) : poll's id (table polls, field pID)
	'     : sTitle (string) : poll's title (table polls, field pTitle)
	'     : dDateBegin (datetime) : poll's beginning date (table polls, field pDateBegin)
	'     : dDateEnd (datetime) : poll's ending date (table polls, field pDateEnd)
	'     : tAnswers (string table) : poll's answers (table pollsresults, field prTitle)
	'     : sColor (string) : poll's display bars color (table polls, field pColor)
	'     : iVersion (int) : poll's version (table polls, field pVersion)
	'     : bValid (boolean) : poll's validation (table polls, field pValid)
	' OUT : (boolean) : True if added
	Function ModifyPoll(iID, sTitle, dDateBegin, dDateEnd, sColor, iVersion, bValid)
		Dim oCn, rSQL, X

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE polls SET pTitle='" & SQLEncrypt(sTitle) & "', pDateBegin='" & DateTimeToString(dDateBegin) & "', pDateEnd='" & DateTimeToString(dDateEnd) & "', pColor='" & SQLEncrypt(sColor) & "', pVersion=" & iVersion & ", pValid=" & bValid & " WHERE pID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		ModifyPoll = True
	End Function

	' Not finalized.......
	Function ModifyPollResults(iID, tAnswers)
		Dim oCn, oRs, rSQL, X

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT rpID FROM pollsresults WHERE prPoll=" & iID
		Set oRs = DBRecordSet(oCn, rSQL)
		
		X = 0
		While Not oRs.EOF
			If X <= UBound(tAnswers) Then
				rSQL = "UPDATE pollsresults SET prText='" & SQLEncrypt(tAnswers(X)) & "'"
			Else
				rSQL = "DELETE FROM pollsresults WHERE rpID=" & oRs("rpID")
			End If
			DBExecute oCn, rSQL
			X = X + 1
			oRs.MoveNext
		WEnd
		
		ModifyPollResults = True
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function
	
	' Delete poll (delete query)
	' IN  : iID (int) : poll's id (table poll, field pID)
	' OUT : (boolean) : True if deleted
	Function DeletePoll(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "DELETE FROM pollsresults WHERE prPoll=" & iID
		DBExecute oCn, rSQL
		rSQL = "DELETE FROM polls WHERE pID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		DeletePoll = True
	End Function
	
	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminPolls()
		Dim pDateBegin, pDateEnd, pValid, X
		Dim tAnswers()
		ReDim tAnswers(GLOBAL_POLLS_MAX_RESULTS)

		Select Case Request("do") 
			Case "add"  : 
				pDateBegin = StringToDate(Request.Form("sAnneeDebut") & Request.Form("sMoisDebut") & Request.Form("sJourDebut") & " " & Request.Form("sHeureDebut") & ":" & Request.Form("sMinuteDebut") & ":00")
				pDateEnd = StringToDate(Request.Form("sAnneeFin") & Request.Form("sMoisFin") & Request.Form("sJourFin") & " " & Request.Form("sHeureFin") & ":" & Request.Form("sMinuteFin") & ":00")
				If Request.Form("pValid") = "on" Then
					pValid = "1"
				Else
					pValid = "0"
				End If
				For X = 0 To GLOBAL_POLLS_MAX_RESULTS-1
					tAnswers(X) = Request.Form("prText_" & X)
				Next
				If AddPoll(Request.Form("pTitle"), pDateBegin, pDateEnd, tAnswers, Request.Form("pColor"), Request.Form("pVersion"), pValid) Then 
					sInfoPage = GetTranslation("LANG_POLL") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_POLL") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			Case "updt" : 
				pDateBegin = StringToDate(Request.Form("sAnneeDebut") & Request.Form("sMoisDebut") & Request.Form("sJourDebut") & " " & Request.Form("sHeureDebut") & ":" & Request.Form("sMinuteDebut") & ":00")
				pDateEnd = StringToDate(Request.Form("sAnneeFin") & Request.Form("sMoisFin") & Request.Form("sJourFin") & " " & Request.Form("sHeureFin") & ":" & Request.Form("sMinuteFin") & ":00")
				If Request.Form("pValid") = "on" Then
					pValid = "1"
				Else
					pValid = "0"
				End If
				If ModifyPoll(Request("pID"), Request.Form("pTitle"), pDateBegin, pDateEnd, Request.Form("pColor"), Request.Form("pVersion"), pValid) Then 
					sInfoPage = GetTranslation("LANG_POLL") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_POLL") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del"  : 
				If DeletePoll(Request.Form("pID")) Then 
					sInfoPage = GetTranslation("LANG_POLL") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_POLL") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub

	' Display page
	' IN  : -
	' OUT : -
	Sub DisplayAdminPollsPage()
		Select Case Request("do")
			Case "view" : 
				DisplayAdminPoll Request("id")
			Case "new"  : 
				EditPoll 0
			Case "edit" : 
				EditPoll Request("id")
			Case "cdel" :
				ConfirmDeletePoll Request("id")
		End Select
		DisplayAdminAllPolls()
	End Sub
%>