<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display user profile
	' IN  : sUserLogin (string) : login's profile (table users, field uLogin)
	' OUT : -
	Sub DisplayProfile(sUserLogin)
		Dim oCn, oCn2, oRs, rSQL, iLine

		Set oCn  = DBConnexion(DB_MAIN)

		CreateTopTable "Profile", GetTranslation("LANG_PROFILE") & " - " & Server.HTMLEncode(sUserLogin)

		rSQL = "SELECT uProfile, uEMail, uMSN, uYahoo, uICQ, uAIM, uURL FROM users WHERE uLogin='" & SQLEncrypt(sUserLogin) & "'"
		Set oRs = DBRecordSet(oCn, rSQL)

		iLine = 1
		If Not oRs.EOF Then
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
			Response.Write "    <td width=""120"">" & GetTranslation("LANG_LOGIN") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(sUserLogin)
			If sPseudo <> "" Then
				Response.Write "&nbsp;&nbsp;&nbsp;<span class=""small"">(<a href=""" & GLOBAL_SITE_PRIVATE_MESSAGES_PAGE & "?do=new&to=" & Server.HTMLEncode(sUserLogin) & """>" & GetTranslation("LANG_SEND_PRIVATE_MESSAGE") & "</a>)</span>" & vbCRLF
			End If

			Response.Write "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = ((iLine - 1) Xor 1) + 1

			' Personal information
			If oRs("uProfile").Value Or IsAuthorized(ROLE_ADMIN) Then
				If Not oRs.EOF Then
					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td width=""100"">" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
					If oRs("uEmail") <> "" Then
						Response.Write "    <td><a href=""mailto:" & Server.HTMLEncode(oRs("uEMail")) & """>" & Server.HTMLEncode(oRs("uEmail")) & "</a></td>" & vbCRLF
					Else
						Response.Write "    <td>-</td>" & vbCRLF
					End If
					Response.Write "  </tr>" & vbCRLF
					iLine = ((iLine - 1) Xor 1) + 1

					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td width=""100"">MSN</td>" & vbCRLF
					If oRs("uMSN") <> "" Then
						Response.Write "    <td>" & Server.HTMLEncode(oRs("uMSN")) & "</td>" & vbCRLF
					Else
						Response.Write "    <td>-</td>" & vbCRLF
					End If
					Response.Write "  </tr>" & vbCRLF
					iLine = ((iLine - 1) Xor 1) + 1

					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td width=""100"">Yahoo Messenger</td>" & vbCRLF
					If oRs("uYahoo") <> "" Then
						Response.Write "    <td>" & Server.HTMLEncode(oRs("uYahoo")) & "</td>" & vbCRLF
					Else
						Response.Write "    <td>-</td>" & vbCRLF
					End If
					Response.Write "  </tr>" & vbCRLF
					iLine = ((iLine - 1) Xor 1) + 1

					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td width=""100"">ICQ</td>" & vbCRLF
					If oRs("uICQ") <> "" Then
						Response.Write "    <td>" & Server.HTMLEncode(oRs("uICQ")) & "</td>" & vbCRLF
					Else
						Response.Write "    <td>-</td>" & vbCRLF
					End If
					Response.Write "  </tr>" & vbCRLF
					iLine = ((iLine - 1) Xor 1) + 1

					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td width=""100"">AIM</td>" & vbCRLF
					If oRs("uAIM") <> "" Then
						Response.Write "    <td>" & Server.HTMLEncode(oRs("uAIM")) & "</td>" & vbCRLF
					Else
						Response.Write "    <td>-</td>" & vbCRLF
					End If
					Response.Write "  </tr>" & vbCRLF
					iLine = ((iLine - 1) Xor 1) + 1

					Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
					Response.Write "    <td width=""100"">" & GetTranslation("LANG_SITE") & "</td>" & vbCRLF
					If oRs("uURL") <> "" Then
						Response.Write "    <td><a href=""" & Server.HTMLEncode(oRs("uURL")) & """ target=""_blank"">" & Server.HTMLEncode(oRs("uURL")) & "</a></td>" & vbCRLF
					Else
						Response.Write "    <td>-</td>" & vbCRLF
					End If
					Response.Write "  </tr>" & vbCRLF
					iLine = ((iLine - 1) Xor 1) + 1
				End If
			End If
				
			Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_POSTS") & "</td>" & vbCRLF
			Response.Write "    <td>"

			Set oCn2 = DBConnexion(DB_FORUM)
			rSQL = "SELECT UserPosts FROM Users WHERE UserLogin='" & SQLEncrypt(sUserLogin) & "'"
			Set oRs = DBRecordSet(oCn2, rSQL)
			
			If Not oRs.EOF Then
				Response.write oRs("UserPosts") 
			Else
				Response.Write "0"
			End If

			oCn2.Close
			Set oCn2 = Nothing

			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			iLine = 1

			' Last 10 news
			rSQL = "SELECT TOP 10 nID, nTitle, nDate FROM News WHERE nAuthor='" & SQLEncrypt(sUserLogin) & "' AND nValid=True ORDER BY nDate DESC"
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td width=""100"" valign=""top"">" & GetTranslation("LANG_NEWS") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF

				While Not oRs.EOF
					 Response.Write "<a href=""" & GLOBAL_SITE_NEWS_PAGE & "?id=" & oRs("nID") & """>" & CodeMessage(oRs("nTitle"), False) & "</a> (" & GetDateDDMMYYYY(StringtoDate(oRs("nDate"))) & ")<br>" & vbCRLF
					 oRs.MoveNext
				WEnd

				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = ((iLine - 1) XOr 1) + 1
			End If

			' Last 10 comments
			rSQL = "SELECT TOP 10 cID, cItem, cText, cType, cDate FROM comments WHERE cAuthor='" & SQLEncrypt(sUserLogin) & "' AND cValid=True ORDER BY cDate DESC"
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td width=""100"" valign=""top"">" & GetTranslation("LANG_COMMENTS") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF

				While Not oRs.EOF
					Select Case oRs("cType")
						Case CATEGORY_TYPE_NEWS			: Response.Write "<a href=""" & GLOBAL_SITE_NEWS_PAGE & "?id=" & oRs("cItem") & "#comment_" & oRs("cID") & """>" 
						Case CATEGORY_TYPE_DIRECTORY	: Response.Write "<a href=""" & GLOBAL_SITE_DIRECTORY_PAGE & "?id=" & oRs("cItem") & "#comment_" & oRs("cID") & """>" 
						Case CATEGORY_TYPE_DOWNLOADS	: Response.Write "<a href=""" & GLOBAL_SITE_DOWNLOADS_PAGE & "?id=" & oRs("cItem") & "#comment_" & oRs("cID") & """>" 
						Case CATEGORY_TYPE_IMAGES		: Response.Write "<a href=""" & GLOBAL_SITE_IMAGES_PAGE & "?id=" & oRs("cItem") & "#comment_" & oRs("cID") & """>" 
						Case CATEGORY_TYPE_ARTICLES		: Response.Write "<a href=""" & GLOBAL_SITE_ARTICLES_PAGE & "?id=" & oRs("cItem") & "#comment_" & oRs("cID") & """>" 
					End Select
					Response.Write CodeMessageEx(oRs("cText"), 40, False, True) & "</a> (" & GetDateDDMMYYYY(StringtoDate(oRs("cDate"))) & ")<br>" & vbCRLF
					oRs.MoveNext
				WEnd
			
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				iLine = ((iLine - 1) XOr 1) + 1
			End If

			' Last 10 articles
			rSQL = "SELECT TOP 10 arID, arTitle, arDate FROM articles WHERE arAuthor='" & SQLEncrypt(sUserLogin) & "' AND arValid=1 ORDER BY arDate DESC"
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td width=""100"" valign=""top"">" & GetTranslation("LANG_ARTICLES") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF

				While Not oRs.EOF
					Response.Write "<a href=""" & GLOBAL_SITE_ARTICLES_PAGE & "?id=" & oRs("arID") & """>" & CodeMessageEx(oRs("arTitle"), 0, False, True) & "</a> (" & GetDateDDMMYYYY(StringtoDate(oRs("arDate"))) & ")<br>" & vbCRLF
					oRs.MoveNext
				WEnd
			
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				iLine = ((iLine - 1) XOr 1) + 1
			End If

			' Last 10 websites
			rSQL = "SELECT TOP 10 dID, dCategory, dTitle, dDate FROM directory WHERE dAuthor='" & SQLEncrypt(sUserLogin) & "' AND dValid=True ORDER BY dDate DESC, dTitle"
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td width=""100"" valign=""top"">" & GetTranslation("LANG_DIRECTORY") & "</td>" & vbCRLF
				Response.Write "    <td>" & vbCRLF

				While Not oRs.EOF
					 Response.Write "<a href=""" & GLOBAL_SITE_DIRECTORY_PAGE & "?id=" & oRs("dID") & "&cat=" & oRs("dCategory") & """>" & Server.HTMLEncode(oRs("dTitle")) & "</a> (" & GetDateDDMMYYYY(StringtoDate(oRs("dDate"))) & ")<br>" & vbCRLF
					 oRs.MoveNext
				WEnd
			
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
			End If

			Response.Write "</table>" & vbCRLF
		Else
			Response.Write GetTranslation("LANG_LOGIN_UNKNOWN") & "<br><br>" & vbCRLF
			Response.Write "<a href=""" & GLOBAL_SITE_PATH & "Default.asp"">" & GetTranslation("LANG_BACK") & "</a>" & vbCRLF
		End If

		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
	End Sub
%>