<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display search's results
	' IN  : sSection (string) : type of data (news, downloads)
	'     : sQuery (string) : query data
	' OUT : -
	Sub DisplaySearchResults(sSection, sQuery)
		Dim oCn, oRs, rSQL, rSQL2, rSQLr, rSQLs, X
		DIm tQuery, iResults, sSectionName
		
		Select Case LCase(sSection)
			Case "news" : 
				sSectionName = GetTranslation("LANG_NEWS")
				rSQL  = "SELECT TOP " & GLOBAL_SEARCH_TOP & " nID, nTitle, nAuthor, nDate FROM News, Versions WHERE nValid=1 AND nVersion=vID AND vCode='" & SQLEncrypt(sXMLVersion) & "' AND ("
				rSQL2 = "SELECT Count(*) FROM News, Versions WHERE nValid=1 AND nVersion=vID AND vCode='" & sXMLVersion & "' AND ("
				rSQLs = " OR nTitle LIKE '%$$WORD$$%'"
			Case "downloads" :
				sSectionName = GetTranslation("LANG_DOWNLOADS")
				rSQL  = "SELECT TOP " & GLOBAL_SEARCH_TOP & " dID, dTitle, dDate FROM downloads WHERE dValid=1 AND ("
				rSQL2 = "SELECT Count(*) FROM Downloads WHERE dValid=1 AND ("
				rSQLs = " OR dTitle LIKE '%$$WORD$$%'"
			Case "articles" :
				sSectionName = GetTranslation("LANG_ARTICLES")
				rSQL  = "SELECT TOP " & GLOBAL_SEARCH_TOP & " arID, arTitle, arAuthor, arDate FROM articles, articlespages, versions WHERE arValid=1 AND arID=apArticle AND apValid=1 AND arVersion=vID AND vCode='" & SQLEncrypt(sXMLVersion) & "' AND ("
				rSQL2 = "SELECT Count(*) FROM articles, articlespages, versions WHERE arValid=1 AND arID=apArticle AND apValid=1 AND arVersion=vID AND vCode='" & SQLEncrypt(sXMLVersion) & "' AND ("
				rSQLs = " OR arTitle LIKE '%$$WORD$$%'"
			Case "directory" :
				sSectionName = GetTranslation("LANG_DIRECTORY")
				rSQL  = "SELECT TOP " & GLOBAL_SEARCH_TOP & " dID, dTitle, dDescription, dURL, dCategory, dDate FROM directory WHERE dValid=True AND ("
				rSQL2 = "SELECT Count(*) FROM directory WHERE dValid=1 AND ("
				rSQLs = " OR dTitle LIKE '%$$WORD$$%'"
			Case "images" :
				sSectionName = GetTranslation("LANG_IMAGES")
				rSQL  = "SELECT TOP " & GLOBAL_SEARCH_TOP & " iID, iTitle, iDate, iSourceSmall FROM images WHERE iValid=1 AND ("
				rSQL2 = "SELECT Count(*) FROM images WHERE iValid=1 AND ("
				rSQLs = " OR iTitle LIKE '%$$WORD$$%'"
			Case Else :
				sSection = "news"
				sSectionName = GetTranslation("LANG_NEWS")
				rSQL  = "SELECT TOP " & GLOBAL_SEARCH_TOP & " nID, nTitle, nAuthor, nDate FROM News, Versions WHERE nValid=1 AND nVersion=vID AND vCode='" & sXMLVersion & "' AND ("
				rSQL2 = "SELECT Count(*) FROM News, Versions WHERE nValid=1 AND nVersion=vID AND vCode='" & sXMLVersion & "' AND ("
				rSQLs = " OR nTitle LIKE '%$$WORD$$%'"
		End Select

		sQuery = Trim(sQuery)

		CreateTopTable "SearchResults", GetTranslation("LANG_SEARCH_RESULTS") & " - " & sSectionName

		If sQuery = "" Then
			Response.Write GetTranslation("LANG_SEARCH_EMPTY") & vbCRLF
		Else
			Set oCn = DBConnexion(DB_MAIN)

			tQuery = Split(sQuery, " ")
			Response.Write GetTranslation("LANG_SEARCH_CRITERIA") & " : """ & Server.HTMLEncode(sQuery) & """<br><br>" & vbCRLF
			For X = 0 To UBound(tQuery)
					rSQLr = rSQLr & Replace(rSQLs, "$$WORD$$", SQLEncrypt(tQuery(X)))
			Next
			rSQLr = Mid(rSQLr, 5)
			rSQL = rSQL & rSQLr & ")"
			rSQL2 = rSQL2 & rSQLr & ")"

			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Select Case LCase(sSection)
					Case "news" :
						While Not oRs.EOF
							Response.Write "<a href=""" & GLOBAL_SITE_NEWS_PAGE & "?id=" & oRs("nID") & """>" & CodeMessage(oRs("nTitle"), False) & "</a> - <span class=""small""><a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_PROFILE_PAGE & "?id=" & Server.URLEncode(oRs("nAuthor")) & """>" & Server.HTMLEncode(oRs("nAuthor")) & "</a> - " & GetDateLitteralDDMMYYYY(StringToDate(oRs("nDate"))) & "</span><br>" & vbCRLF
							oRs.MoveNext
						WEnd
					Case "downloads" :
						While Not oRs.EOF
							Response.Write "<a href=""" & GLOBAL_SITE_DOWNLOADS_PAGE & "?id=" & oRs("dID") & """>" & CodeMessage(oRs("dTitle"), False) & "</a> <span class=""small"">" & GetDateLitteralDDMMYYYY(StringToDate(oRs("dDate"))) & "</span><br>" & vbCRLF
							oRs.MoveNext
						WEnd
					Case "articles" :
						While Not oRs.EOF
							Response.Write "<a href=""" & GLOBAL_SITE_ARTICLES_PAGE & "?id=" & oRs("arID") & """>" & CodeMessage(oRs("arTitle"), False) & "</a> - <span class=""small""><a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_PROFILE_PAGE & "?id=" & Server.URLEncode(oRs("arAuthor")) & """>" & Server.HTMLEncode(oRs("arAuthor")) & "</a></span> - " & GetDateLitteralDDMMYYYY(StringToDate(oRs("arDate"))) & "</span><br>" & vbCRLF
							oRs.MoveNext
						WEnd
					Case "directory" :
						While Not oRs.EOF
							Response.Write "<a href=""" & GLOBAL_SITE_DIRECTORY_PAGE & "?cat=" & oRs("dCategory") & "#site_" & oRs("dID") & """>" & CodeMessage(oRs("dTitle"), False) & "</a><br><span class=""small"">" & CodeMessage(oRS("dDescription") & "", True) & "</span><br>" & vbCRLF
							oRs.MoveNext
						WEnd
					Case "images" :
						While Not oRs.EOF
							Response.Write "<a href=""" & GLOBAL_SITE_IMAGES_PAGE & "?id=" & oRs("iID") & """><img src=""" & Server.HTMLEncode(oRs("iSourceSmall")) & """ border=""0"" vspace=""2""> " & CodeMessage(oRs("iTitle"), False) & "</a> - " & GetDateLitteralDDMMYYYY(StringToDate(oRs("iDate"))) & "</span><br>" & vbCRLF
							oRs.MoveNext
						WEnd
				End Select

				Set oRs = DBRecordSet(oCn, rSQL2)
				iResults = oRs(0)

				If iResults > GLOBAL_SEARCH_TOP Then
					Response.Write "<br>" & Replace(Replace(GetTranslation("LANG_SEARCH_TOTAL"), "%1%", GLOBAL_SEARCH_TOP), "%2%", iResults) & vbCRLF
				Else
					Response.Write "<br>" & Replace(Replace(GetTranslation("LANG_SEARCH_TOTAL"), "%1%", iResults), "%2%", iResults) & vbCRLF
				End If
			Else
				Response.Write GetTranslation("LANG_SEARCH_EMPTY") & vbCRLF
			End If
			
			oCn.Close
			Set oCn = Nothing
			Set oRs = Nothing
		End If

		CreateBottomTable ""		
	End Sub
	
	' Display extended search engine's form
	' IN  : -
	' OUT : -
	Sub DisplayExtendedSearch(sQuerySection, sQueryStr)
		If bDisplaySearchEngine Then
			If sQueryStr <> "" Then sQueryStr = Trim(sQueryStr)

			CreateTopTable "Search", GetTranslation("LANG_SEARCH")
			Response.Write "<table id=""SearchTable"" border=""0"" cellpadding=""0"" cellspacing=""0"">" & vbCRLF
			Response.Write "<form name=""rechercherEx"" method=""post"" action=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_SEARCH_PAGE & """>" & vbCRLF
			Response.Write " <tr>" & vbCRLF
			Response.Write "   <td>" & vbCRLF
			Response.Write "     <input type=""text"" name=""r"" maxlength=""50"" size=""40"" class=""cell"" value=""" & Server.HTMLEncode(sQueryStr) & """>&nbsp;" & vbCRLF
			Response.Write "     <select name=""section"" class=""cell"">" & vbCRLF
			If GLOBAL_NEWS_TOP > 0 Then
				Response.Write "		  <option value=""news"""
				If sQuerySection = "news" Then Response.Write " selected"
				Response.Write ">" & GetTranslation("LANG_NEWS") & "</option>" & vbCRLF
			End If
			If GLOBAL_DOWNLOADS_TOP > 0 Then
				Response.Write "		  <option value=""downloads"""
				If sQuerySection = "downloads" Then Response.Write " selected"
				Response.Write ">" & GetTranslation("LANG_DOWNLOADS") & "</option>" & vbCRLF
			End If
			If GLOBAL_ARTICLES_TOP > 0 Then
				Response.Write "		  <option value=""articles"""
				If sQuerySection = "articles" Then Response.Write " selected"
				Response.Write ">" & GetTranslation("LANG_ARTICLES") & "</option>" & vbCRLF
			End If
			If GLOBAL_DIRECTORY_TOP > 0 Then
				Response.Write "		  <option value=""directory"""
				If sQuerySection = "directory" Then Response.Write " selected"
				Response.Write ">" & GetTranslation("LANG_DIRECTORY") & "</option>" & vbCRLF
			End If
			If GLOBAL_IMAGES_TOP > 0 Then
				Response.Write "		  <option value=""images"""
				If sQuerySection = "images" Then Response.Write " selected"
				Response.Write ">" & GetTranslation("LANG_IMAGES") & "</option>" & vbCRLF
			End If
			Response.Write "	 </select>&nbsp;" & vbCRLF
			Response.Write "     <input type=""submit"" value=""" & GetTranslation("LANG_OK") & """ class=""button"">" & vbCRLF
			Response.Write "   </td>" & vbCRLF
			Response.Write " </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
	End Sub
%>