<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Log off from members section
	' IN  : -
	' OUT : -
	Sub Logoff()
		Dim oCn, rSQL

		Response.Cookies("pseudo") = ""
		Response.Cookies("pseudoid") = ""
		Response.Cookies("email") = ""
		Response.Cookies("pseudo").Expires = Date - 7
		Response.Cookies("pseudoid").Expires = Date - 7
		Response.Cookies("email").Expires = Date - 7

		If iSessionID <> "" Then
			rSQL = "UPDATE sessions SET sLogin='' WHERE sID=" & iSessionID
			Set oCn = DBConnexion(DB_MAIN)
			DBExecute oCn, rSQL

			oCn.Close
			Set oCn = Nothing
		End If
		
		Set oLangXML = Nothing
		Response.Redirect GLOBAL_SITE_PATH & "Default.asp?do=out"
		Response.End
	End Sub
	
	Function UpdateSession(iUserSessionID, sUserLogin, sUserIP)
		Const SESSION_DURATION = 10 ' in minutes
		Dim oCn, oRs, rSQL, sDateNow, sDateOld

		sDateNow = DateTimeToString(Now())
		sDateOld = DateTimeToString(DateAdd("n", - SESSION_DURATION, Now()))

		Set oCn = DBConnexion(DB_MAIN)

		UpdateSession = iUserSessionID

		If Not IsNumeric(iUserSessionID) Then
			If sUserLogin <> "" Then
				rSQL = "DELETE FROM sessions WHERE sLogin='" & SQLEncrypt(sUserLogin) & "'"
			Else
				rSQL = "DELETE FROM sessions WHERE sIP='" & sUserIP & "' AND sLogin=''"
			End If
			DBExecute oCn, rSQL
			rSQL = "INSERT INTO sessions (sLogin, sIP, sDateFirst, sDateLast, sReferer) VALUES ('" & SQLEncrypt(sUserLogin) & "', '" & SQLEncrypt(sUserIP) & "', '" & sDateNow & "','" & sDateNow & "', '" & Request.ServerVariables("HTTP_REFERER") & "')" 
			DBExecute oCn, rSQL
			rSQL = "SELECT sID FROM sessions WHERE sLogin = '" & SQLEncrypt(sUserLogin) & "' AND sIP = '" & SQLEncrypt(sIP) & "' AND sDateFirst = '" & sDateNow & "' AND sDateLast=sDateFirst"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then UpdateSession = oRs("sID")
		Else
			rSQL = "SELECT * FROM sessions WHERE sID=" & iUserSessionID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				rSQL = "UPDATE sessions SET sLogin='" & SQLEncrypt(sUserLogin) & "', sDateLast='" & sDateNow & "' WHERE sID = " & iUserSessionID
				DBExecute oCn, rSQL
			Else
				rSQL = "DELETE FROM sessions WHERE sID=" & iUserSessionID
				If sUserLogin <> "" Then rSQL = rSQL & " OR sLogin='" & SQLEncrypt(sUserLogin) & "'"
				DBExecute oCn, rSQL
				rSQL = "INSERT INTO sessions (sLogin, sIP, sDateFirst, sDateLast, sReferer) VALUES ('" & SQLEncrypt(sUserLogin) & "', '" & SQLEncrypt(sUserIP) & "', '" & sDateNow & "','" & sDateNow & "', '" & Request.ServerVariables("HTTP_REFERER") & "')" 
				DBExecute oCn, rSQL
				rSQL = "SELECT sID FROM sessions WHERE sLogin = '" & SQLEncrypt(sUserLogin) & "' AND sIP = '" & SQLEncrypt(sIP) & "' AND sDateFirst = '" & sDateNow & "' AND sDateLast=sDateFirst"
				Set oRs = DBRecordSet(oCn, rSQL)
				If Not oRs.EOF Then UpdateSession = oRs("sID")
			End If
		End If

		' Delete old sessions		
		rSQL = "DELETE FROM sessions WHERE sDateLast<='" & sDateOld & "'"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function

	' Verify that user's id and login are ok, and get role
	' IN  : sUserLogin (string) user's login (table users, field uLogin)
	'     : iUserID (int) user's id (table users, field uID)
	' OUT : (int) user's role (redirection to /Default.asp if user not found)
	Function VerifyUserIntegrityAndGetRole(sUserLogin, iUserID)
		Dim oCn, oRs, rSQL, bOk, iRole
		
		VerifyUserIntegrityAndGetRole = ROLE_USER
		bOk = False

		If sUserLogin <> "" and iUserID <> "" Then
			If IsNumeric(iUserID) Then
				rSQL = "SELECT uRole FROM Users WHERE uLogin='" & SQLEncrypt(sUserLogin) & "' AND uID=" & iUserID
				Set oCn = DBConnexion(DB_MAIN)
				Set oRs = DBRecordSet(oCn, rSQL)
				If Not oRs.EOF Then
					bOk = True
					iRole = oRs("uRole").Value
				End If

				oCn.Close
				Set oCn = Nothing
				Set oRs = Nothing
			End If
		End If
		
		If bOk Then
			VerifyUserIntegrityAndGetRole = iRole
		Else
			Response.Cookies("pseudo") = ""
			Response.Cookies("pseudoid") = ""
			Response.Cookies("email") = ""
			sPseudo = ""
			iPseudoId = ""
			Set oLangXML = Nothing
			Response.Redirect GLOBAL_SITE_PATH & "Default.asp"
		End If	
	End Function
%>