<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	Option Explicit

	Response.AddHeader "pragma","no-cache"
	Response.AddHeader "expires", "0"
	Response.AddHeader "P3P", "CP=""NOI CUR OUR IND UNI COM NAV INT"""

	Response.Expires = -1500
	Response.Buffer = True

	' Global variables
	Dim sXMLVersion ' Current XML version
	Dim oLangXML	' Current language xml file
	Dim sCharset	' Current charset
	Dim sTitlePage	' Current page's title
	Dim sInfoPage	' Information (display at right)
	Dim sTheme		' Current theme (default if empty)
	Dim sUrlPage	' Current page's url
	Dim sPseudo		' User's login (if authenticated, else empty)
	Dim iPseudoID	' User's unique id (if authenticated, else empty)
	Dim sEmail		' User's email (if authenticated, else empty)
	Dim iRole		' User's role (if authenticated, else empty)
	Dim dDatePage	' Date rcupre
	Dim sLastVisit	' Date (string) de la dernire visite
	Dim sIP			' User's ip address
	Dim iSessionID	' user's session id
	Dim tLeftColumn ' Left Column
	Dim tRightColumn' Right Column

	' Initializing some global variables
	sTitlePage 	= GLOBAL_SITE_NAME
	sInfoPage 	= ""
	sUrlPage   	= Request.ServerVariables("URL")
	sPseudo	    = Request.Cookies("pseudo")
	iPseudoID   = Request.Cookies("pseudoid")
	sEmail	    = Request.Cookies("email")
	iSessionID  = Request.Cookies("sessionid")
	sIP			= Request.ServerVariables("REMOTE_ADDR")

	sLastVisit = GetAndSetLastVisit()
	sTheme = GetAndSetTheme()
	sXMLVersion = GetAndSetXMLVersion()
	Set oLangXML = GetXMLDocument(sXMLVersion)
	SetLCID()
	sCharset = GetCharset()
	ManageLeftAndRightColumn()

	' Get current role and verify user
	If sPseudo <> "" or iPseudoID <> "" Then 
		iRole = VerifyUserIntegrityAndGetRole(sPseudo, iPseudoID)
	Else
		iRole = 0
	End If

	' Check and update session
	iSessionID = UpdateSession(iSessionID, sPseudo, sIP)
	Response.Cookies("sessionid") = iSessionID

	' User login/logoff
	Select Case Request.QueryString("do") 
		Case "in" :	sInfoPage = GetTranslation("LANG_CONNECT")
		Case "out" : sInfoPage = GetTranslation("LANG_DISCONNECT")
	End Select
%>