<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	Option Explicit
	Response.Expires = 0

	Const sVersion = "v1.2"
	Const sLangCode = "EN"
	Const sCharset = "iso-8859-1"

	Const LANG_VERSION_NAME = "English version"
	Const LANG_ERROR_DB_PATH = "Error: you have given a bad database path.<br><a href=""javascript:history.back(1)"">Back to setup.</a>"
	Const LANG_TITLE_PAGE = "Website's configuration"
	Const LANG_SITE_ALREADY_CONFIGURED = "The website is already configured"
	Const LANG_CONFIGURATION_CREATED1 = "The configuration file (configuration-inc.asp) has been successfully generated in the ""/includes/"" directory of your website."
	Const LANG_CONFIGURATION_CREATED2 = "<br>Your website is now correctly configured.<br>"
	Const LANG_FILESYSTEM_FORBIDDEN1 = "Your webhost forbids the use of the FileSystemObject. You must copy-past the content of the text area in a file called ""configuration-inc.asp"". Put it then in the ""/includes/"" directory of your website.<br>"
	Const LANG_FILESYSTEM_FORBIDDEN2 = "<br>Your website will be correctly configured when this file will be created and put on your website (in the /includes/ directory).<br>"
	Const LANG_CONFIGURATION_END1 = "Please remove this file (setup.asp) from your webserver.<br>"
	Const LANG_CONFIGURATION_END1_2 = "Please remove this file (upgrade.asp) from your webserver.<br>"
	Const LANG_CONFIGURATION_END2 = "To reconfigure your website, just delete the configuration file (/includes/configuration-inc.asp).<br><br>"
	Const LANG_CONFIGURATION_END3 = "<a href=""Default.asp"">Go to your website !</a>"
	Const LANG_BAD_LOGIN_PASSWORD = "Your login and/or password are incorrect, or it's not an admin account."
	Const LANG_INTRODUCTION1 = "<br>Here is the setup of your website. Answer the following questions (let the default value if you don't know what to fill)."
	Const LANG_INTRODUCTION1_2 = "<br>To upgrade your ASP-Nuke's website, please answer the following questions.<br>"
	Const LANG_INTRODUCTION2 = "<br>After submitting this form, you'll get confirmation that your website has been successfully configured.  If so, then remove the ""setup.asp"" file from your webserver for preventing people to try to access it.<br>"
	Const LANG_INTRODUCTION3 = "Normalement, celui-ci ne pourra ne faire tant que vous avez un fichier ""/includes/configuration-inc.asp"", mais par principe de scurit, je vous engage fortement  retirer ce fichier de votre serveur (setup.asp).<br><br>"
	Const LANG_MISSING_FIELDS = "Following fields are needed"
	Const LANG_WEBSITE_NAME = "Website's name"
	Const LANG_WEBSITE_URL = "URL"
	Const LANG_ADMIN_LOGIN = "Admin login"
	Const LANG_ADMIN_PASSWORD = "Admin password"
	Const LANG_WEBSITE_EMAIL = "Webmaster's Email"
	Const LANG_WEBSITE_EMAIL2 = "Accounts' email"
	Const LANG_ADMIN_LOGIN_NOTE = "this login will be created and use for the administration"
	Const LANG_ADMIN_PASSWORD_NOTE = "keep it somewhere"
	Const LANG_WEBSITE_KEYWORDS = "Keywords"
	Const LANG_WEBSITE_KEYWORDS_NOTE = "delimited by a comma"
	Const LANG_WEBSITE_DESCRIPTION = "Short description of your website"
	Const LANG_WEBSITE_DESCRIPTION_NOTE = "2 or 3 sentences"
	Const LANG_WEBSITE_AUTHOR = "Author"
	Const LANG_WEBSITE_AUTHOR_NOTE = "your nick, email, lastname/firstname..."
	Const LANG_DATABASE_DIRECTORY = "Databases directory"
	Const LANG_DISPLAY_VISITORS_COUNTER = "Display current visitors"
	Const LANG_DISPLAY_ADVERTISING = "Display advertising"
	Const LANG_DISPLAY_SEARCH = "Display the search engine"
	Const LANG_DISPLAY_NEWSLETTER_CHECKBOX = """Newsletter"" available"
	Const LANG_DISPLAY_FAVORITES = "Display my favorites websites"
	Const LANG_DISPLAY_ACCOUNTS = "Display accounts information"
	Const LANG_DISPLAY_TOP_DIRECTORY = "Display last added websites in your directory"
	Const LANG_DISPLAY_BULLETS = "ADisplay bullets"
	Const LANG_DISPLAY_BULLETS_NOTE = "in menu section"
	Const LANG_DISPLAY_BACKEND = "Generate Backend"
	Const LANG_DISPLAY_BACKEND_NOTE = "you must have write rights in the ""/scripts"" directory"
	Const LANG_ENABLE_PRIVATE_AVATAR = "Users could have a private avatar"
	Const LANG_AUTO_ACCEPT_PRIVATE_AVATAR = "Private avatars are automatically validated"
	Const LANG_DISPLAY_VERSIONS = "Display version's selection"
	Const LANG_AUTO_SIGNUP = "Auto-signup"
	Const LANG_AUTO_SIGNUP_NOTE = "if you uncheck, users must confirm by clicking a link in an email sent to them"
	Const LANG_TOP_IMPORTANT_NOTE = "<b>Warning : </b> If you choose <b>0</b> in the following comboboxes, these sections will be disabled."
	Const LANG_TOP_NEWS = "Top last news"
	Const LANG_TOP_NEWS_LINKS = "Top last news (links)"
	Const LANG_TOP_COMMENTS = "Top last comments"
	Const LANG_TOP_ARTICLES = "Top last articles"
	Const LANG_TOP_DOWNLOADS = "Top last downloads"
	Const LANG_TOP_POSTS = "Top last posts (forum)"
	Const LANG_TOP_SEARCH_RESULTS = "Top search results"
	Const LANG_TOP_POLLS = "Top last polls"
	Const LANG_TOP_IMAGES = "Top last pictures"
	Const LANG_TOP_DIRECTORY = "Top last websites"
	Const LANG_COMMENTS_BY_PAGE = "Comments by page"
	Const LANG_IMAGES_BY_PAGE = "Pictures by page"
	Const LANG_SUBMIT = "Submit"
	Const LANG_PROPERTY = "Property"
	Const LANG_VALUE = "Value"
%>
<!-- #include file="includes/display-inc.asp" -->
<%
	Function AutoDetectDBPath(sPath)
		Dim oFs, oFolder, oSubFolder, oFile, bMain, bForum, sTempPath, sDBPath
		
		bMain = False
		bForum = False
		sDBPath = ""
		If sPath = "" then sPath = "."
		
		On Error Resume Next
		Set oFs = Server.CreateObject("Scripting.FileSystemObject")

		If oFs.FolderExists(Server.MapPath(sPath)) Then
			Set oFolder = oFs.GetFolder(Server.MapPath(sPath))
		
			For Each oFile In oFolder.Files
				If LCase(oFile.Name) = "forum.mdb" Then bForum = True
				If LCase(oFile.Name) = "main.mdb" Then bMain = True
			Next

			If bMain and bForum Then
				sDBPath = sPath
			Else
				For Each oSubFolder In oFolder.SubFolders
					sTempPath = AutoDetectDBPath(sPath & "/" & oSubFolder.Name)
					If sTempPath <> "" Then
						sDBPath = sTempPath
						Exit For
					End If
				Next
			End If
		End If

		If sDBPath <> "" Then
			If Left(sDBPath, 2) = "./" Then 
				sDBPath = Mid(sDBPath, 3)
			ElseIf Left(sDBPath, 1) = "." Then
				sDBPath = Mid(sDBPath, 2)
			ElseIf Left(sDBPath, 1) = "/" Then
				sDBPath = Mid(sDBPath, 2)
			End If		
		End If

		Set oFs = Nothing

		On Error Goto 0

		AutoDetectDBPath = sDBPath
	End Function

	Function GetDBPath(sPath)
		Dim sMyDBPath
		
		sMyDBPath = AutoDetectDBPath(sPath)
		
		If sMyDBPath = "" Then 
			sMyDBPath = "db"
		End If
		
		If Left(sMyDBPath, 1) <> "/" Then sMyDBPath = "/" & sMyDBPath

		GetDBPath = sMyDBPath
	End Function

	Function DBConnexion(sPath, sDBName)
		Dim oCn, sConnString, oFs, sDBPath
		sDBPath = Server.MapPath(sPath)

		Set oCn = Server.CreateObject("ADODB.Connection")
		sConnString = "DRIVER={Microsoft Access Driver (*.mdb)}; " & "DBQ=" & sDBPath & "/" & sDBName & ".mdb" 
		On Error Resume Next
		oCn.Open sConnString
		If Err.number <> 0 Then
			Response.Write LANG_ERROR_DB_PATH
			Response.End
			Err.Clear
		End If
		On Error Goto 0
		Set DBConnexion = oCn
	End Function

	Function DateTimeToString(dDateTime)
		DateTimeToString = Year(dDateTime) & Right("0" & Month(dDateTime), 2) & Right("0" & Day(dDateTime), 2) & " " & Right("0" & Hour(dDateTime), 2) & ":" & Right("0" & Minute(dDateTime), 2) & ":" & Right("0" & Second(dDateTime), 2)
	End Function

	Dim oFs, oFile, sDirectory, X, bFileSO, bAlreadyConf, sMsg, oCn, oRs, rSQL
	Dim bDynCount, bAdvertsing, bSearchEngine, bNewsletter, bFavorites, bAccounts, bLastSites, bBullet, bBackEnd, sAdminPseudo, sAdminPwd, sDBDir
	Dim bAllowPrivateAvatars, bAutoAcceptPrivateAvatar, bDisplayVersions, bAutoSignup
	
	sDirectory = Replace(LCase(Request.ServerVariables("PATH_INFO")), "/setup.asp", "")
	bAlreadyConf = False
	bFileSO = True

	Response.Write "<html>" & vbCRLF
	Response.Write "<head>" & vbCRLF
	Response.Write "<title>" & LANG_TITLE_PAGE & "</title>" & vbCRLF
	Response.Write "<meta http-equiv=""Content-Type"" content=""text/html; charset=" & sCharset & """>" & vbCRLF
	Response.Write "<link rel=""stylesheet"" href=""themes/default/default.css"" type=""text/css"">" & vbCRLF
	Response.Write "</head>" & vbCRLF
	Response.Write "<body>" & vbCRLF

	On Error Resume Next
	Set oFs = Server.CreateObject("Scripting.FileSystemObject")
	If Err.number <> 0 Then
		Err.Clear
		bFileSO = False
	End If
	On Error Goto 0

	If bFileSO Then
		If oFs.FileExists(Server.MapPath("./includes/configuration-inc.asp")) Then bAlreadyConf = True
	End If

	If bAlreadyConf Then
		Response.Write LANG_SITE_ALREADY_CONFIGURED
	Else
		If Request.Form("SiteName") <> "" Then
			If Request.Form("DynamicCount") <> "" Then
				bDynCount = "True"
			Else
				bDynCount = "False"
			End If
			If Request.Form("Advertising") <> "" Then
				bAdvertsing = "True"
			Else
				bAdvertsing = "False"
			End If
			If Request.Form("SearchEngine") <> "" Then
				bSearchEngine = "True"
			Else
				bSearchEngine = "False"
			End If
			If Request.Form("Newsletter") <> "" Then
				bNewsletter = "True"
			Else
				bNewsletter = "False"
			End If
			If Request.Form("Favorites") <> "" Then
				bFavorites = "True"
			Else
				bFavorites = "False"
			End If
			If Request.Form("Accounts") <> "" Then
				bAccounts = "True"
			Else
				bAccounts = "False"
			End If
			If Request.Form("LastSites") <> "" Then
				bLastSites = "True"
			Else
				bLastSites = "False"
			End If
			If Request.Form("Bullet") <> "" Then
				bBullet = "True"
			Else
				bBullet = "False"
			End If
			If Request.Form("AllowPrivateAvatars") <> "" Then
				bAllowPrivateAvatars = "True"
			Else
				bAllowPrivateAvatars = "False"
			End If
			If Request.Form("AutoAcceptPrivateAvatar") <> "" Then
				bAutoAcceptPrivateAvatar = "True"
			Else
				bAutoAcceptPrivateAvatar = "False"
			End If
			If Request.Form("DisplayVersions") <> "" Then
				bDisplayVersions = "True"
			Else
				bDisplayVersions = "False"
			End If
			If Request.Form("AutoSignup") <> "" Then
				bAutoSignup = "True"
			Else
				bAutoSignup = "False"
			End If

			If Request.Form("AutoBackEnd") <> "" Then
				bBackEnd = "True"
			Else
				bBackEnd = "False"
			End If

			sAdminPseudo = Request.Form("uLogin")
			sAdminPwd = Request.Form("uPassword")
			sDBDir = Request.Form("sDBPath")

			Set oCn = DBConnexion(sDBDir, "main")
			rSQL = "SELECT * FROM Users WHERE uLogin='" & Replace(sAdminPseudo, "'", "''") & "'"
			Set oRs = oCn.Execute(rSQL)
			If oRs.EOF Then
				rSQL = "INSERT INTO users (uLogin, uPassword, uEmail, uMSN, uYahoo, uICQ, uAIM, uURL, uSignature, uRole, uDate, uNewsletter, uProfile, uValid) VALUES ('" & Replace(sAdminPseudo, "'", "''") & "', '" & Replace(sAdminPwd, "'", "''") & "', '" & Replace(Request.Form("SiteEmail"), "'", "''") & "', '', '', '', '', '" & Replace(Request.Form("SiteURL"), "'", "''") & "', '', 3, '" & DateTimeToString(Now()) & "', 0, 0, 1)"
				oCn.Execute rSQL
				rSQL = "SELECT * FROM Versions WHERE vCode='" & Replace(sLangCode, "'", "''") & "'"
				Set oRs = oCn.Execute(rSQL)
				If oRs.EOF Then
					rSQL = "INSERT INTO versions (vCode, vTitle, vPicture) VALUES ('" & Replace(sLangCode, "'", "''") & "', '" & Replace(LANG_VERSION_NAME, "'", "''") & "', '')"
					oCn.Execute rSQL
				End If
				Set oCn = DBConnexion(sDBDir, "forum")
				rSQL = "INSERT INTO users (UserLogin, UserPosts, UserValid) VALUES ('" & Replace(sAdminPseudo, "'", "''") & "', 0, 1)"
				oCn.Execute rSQL
				rSQL = "INSERT INTO Owners (OwnerID) VALUES ('" & Replace(sAdminPseudo, "'", "''") & "')"
				oCn.Execute rSQL
			End If
			oCn.Close
			Set oCn = Nothing

			sMsg = "<" & "%" & vbCRLF
			sMsg = sMsg & "	' General website's information" & vbCRLF
			sMsg = sMsg & "	' Website's name" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_NAME 		= """ & Server.HTMLEncode(Request.Form("SiteName")) & """" & vbCRLF
			sMsg = sMsg & "	' Website's url" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_URL		= """ & Server.HTMLEncode(Request.Form("SiteURL")) & """" & vbCRLF
			sMsg = sMsg & "	' Webmaster's email" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_EMAIL		= """ & Server.HTMLEncode(Request.Form("SiteEmail")) & """" & vbCRLF
			sMsg = sMsg & "	' Accounts email" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_ACCOUNTS_EMAIL = """ & Server.HTMLEncode(Request.Form("AccountsEmail")) & """" & vbCRLF
			sMsg = sMsg & "	' Copyright display at bottom" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_COPYRIGHT	= """ & Server.HTMLEncode(Request.Form("SiteCopyright")) & """" & vbCRLF
			sMsg = sMsg & "	' Default language file" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_DEFAULT_VERSION = """ & sLangCode & """" & vbCRLF
			sMsg = sMsg & "" & vbCRLF
			sMsg = sMsg & "	' META info" & vbCRLF
			sMsg = sMsg & "	' Keywords" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_META_KEYWORDS    = """ & Server.HTMLEncode(Request.Form("MetaKeywords")) & """" & vbCRLF
			sMsg = sMsg & "	' Description" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_META_DESCRIPTION = """ & Server.HTMLEncode(Request.Form("MetaDescription")) & """" & vbCRLF
			sMsg = sMsg & "	' Author" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_META_AUTHOR      = """ & Server.HTMLEncode(Request.Form("MetaAuthor")) & """" & vbCRLF
			sMsg = sMsg & "	' Head structure of subtable" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_SUBTABLE    = ""<table width=""""100%"""" class=""""myTable"""" cellspacing=""""1"""" cellpadding=""""2"""" align=""""center"""">""" & vbCRLF
			sMsg = sMsg & "" & vbCRLF
			sMsg = sMsg & "	' Paths. Edit ALL paths IF YOU ARE IN A VIRTUAL DIRECTORY !" & vbCRLF
			sMsg = sMsg & "	' put a ""/myAspNukeDir"" before paths if you're in a virtual directory, " & vbCRLF
			sMsg = sMsg & "	' where /myAspNukeDir is your virtual directory. " & vbCRLF
			sMsg = sMsg & "	' For example : Const GLOBAL_SITE_PATH = ""/mywebsite/""" & vbCRLF
			sMsg = sMsg & "" & vbCRLF
			sMsg = sMsg & "	' Website path" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_PATH			   = """ & sDirectory & "/""" & vbCRLF
			sMsg = sMsg & "	' admin path" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_ADMIN_PATH	   = """ & sDirectory & "/admin/""" & vbCRLF
			sMsg = sMsg & "	' Themes Path" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_THEMES_PATH      = """ & sDirectory & "/themes/""" & vbCRLF
			sMsg = sMsg & "	' Pictures directory" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_IMAGES_PATH      = """ & sDirectory & "/imgs/""" & vbCRLF
			sMsg = sMsg & "	' News pictures directory" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_IMAGES_NEWS_PATH = """ & sDirectory & "/imgs/news/""" & vbCRLF
			sMsg = sMsg & "	' Smileys pictures directory" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_IMAGES_SMILEYS_PATH = """ & sDirectory & "/forum/smileys/""" & vbCRLF
			sMsg = sMsg & "	' Backend path and file" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_BACKEND = """ & sDirectory & "/scripts/display_news.js""" & vbCRLF
			sMsg = sMsg & "	' Database path" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_DATABASE_PATH		= """ & sDBDir & """" & vbCRLF
			sMsg = sMsg & "	' Language files path" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SITE_VERSIONS_PATH      = """ & sDirectory & "/lang/""" & vbCRLF
			sMsg = sMsg & "" & vbCRLF
			sMsg = sMsg & "	' Database constants" & vbCRLF
			sMsg = sMsg & "	Const DB_MAIN  = ""main""" & vbCRLF
			sMsg = sMsg & "	Const DB_FORUM = ""forum""" & vbCRLF
			sMsg = sMsg & "" & vbCRLF
			sMsg = sMsg & "	' Display configuration (left column)" & vbCRLF
			sMsg = sMsg & "	' Dynamic count display" & vbCRLF
			sMsg = sMsg & "	Const bDisplayDynamicCount = " & bDynCount & vbCRLF
			sMsg = sMsg & "	' Advertising display" & vbCRLF
			sMsg = sMsg & "	Const bDisplayAdvertising = " & bAdvertsing & vbCRLF
			sMsg = sMsg & "	' Search engine display" & vbCRLF
			sMsg = sMsg & "	Const bDisplaySearchEngine = " & bSearchEngine & vbCRLF
			sMsg = sMsg & "	' Newsletter" & vbCRLF
			sMsg = sMsg & "	Const bNewsletter = " & bNewsletter & vbCRLF
			sMsg = sMsg & "	' Favorites display" & vbCRLF
			sMsg = sMsg & "	Const bDisplayFavorites = " & bFavorites & vbCRLF
			sMsg = sMsg & "	' Accounts display" & vbCRLF
			sMsg = sMsg & "	Const bDisplayAccounts = " & bAccounts & vbCRLF
			sMsg = sMsg & "	' Last websites display" & vbCRLF
			sMsg = sMsg & "	Const bDisplayLastSites = " & bLastSites & vbCRLF
			sMsg = sMsg & "	' Display a bullet before menu choices" & vbCRLF
			sMsg = sMsg & "	Const bDisplayBullet = " & bBullet & vbCRLF
			sMsg = sMsg & "	' Allow or not private avatar" & vbCRLF
			sMsg = sMsg & "	Const bAllowPrivateAvatars = " & bAllowPrivateAvatars & vbCRLF
			sMsg = sMsg & "	' Auto accept private avatar or not by default" & vbCRLF
			sMsg = sMsg & "	Const bAutoAcceptPrivateAvatar = " & bAutoAcceptPrivateAvatar & vbCRLF
			sMsg = sMsg & "	' Display language choice" & vbCRLF
			sMsg = sMsg & "	Const bDisplayVersions = " & bDisplayVersions & vbCRLF
			sMsg = sMsg & "	' Automatic signup" & vbCRLF
			sMsg = sMsg & "	Const bAutoSignup = " & bAutoSignup & vbCRLF
			sMsg = sMsg & "" & vbCRLF	
			sMsg = sMsg & "	' Back End" & vbCRLF
			sMsg = sMsg & "	' Automatic backend generated" & vbCRLF
			sMsg = sMsg & "	Const bAutoBackEnd = " & bBackEnd & "" & vbCRLF
			sMsg = sMsg & "" & vbCRLF
			sMsg = sMsg & "	' TOP results for each section" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_NEWS_TOP = " & Request.Form("TopNews") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_NEWS_LINKS_TOP = " & Request.Form("TopNewsLinks") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_COMMENTS_TOP = " & Request.Form("TopComments") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_ARTICLES_TOP = " & Request.Form("TopArticles") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_DOWNLOADS_TOP = " & Request.Form("TopDownloads") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_FORUM_TOP = " & Request.Form("TopForum") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_SEARCH_TOP = " & Request.Form("TopSearch") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_POLLS_TOP = " & Request.Form("TopPolls") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_IMAGES_TOP = " & Request.Form("TopImages") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_DIRECTORY_TOP = " & Request.Form("TopDirectory") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_COMMENTS_PAGE = " & Request.Form("PageComments") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_IMAGES_PAGE = " & Request.Form("PageImages") & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_POLLS_MAX_RESULTS = 5" & vbCRLF
			sMsg = sMsg & "	Const GLOBAL_CUSTOM_BLOCKS = 0" & vbCRLF
			sMsg = sMsg & "%" & ">" & vbCRLF
			
			If bFileSO Then
				On Error Resume Next
				Set oFile = oFs.OpenTextFile(Server.MapPath("./includes/configuration-inc.asp"), 2, True)
				oFile.WriteLine sMsg
				oFile.Close
				If oFs.FileExists(Server.MapPath("./includes/configuration-inc.asp")) Then
					Response.Write LANG_CONFIGURATION_CREATED1 & vbCRLF
					Response.Write LANG_CONFIGURATION_CREATED2 & vbCRLF
				Else
					bFileSO = False
				End If

				Set oFs = Nothing
				On Error GoTo 0
			End If

			If Not bFileSO Then
				Response.Write LANG_FILESYSTEM_FORBIDDEN1 & vbCRLF
				Response.Write "<div align=""center""><textarea name=""configuration"" class=""cell"" rows=""80"" cols=""100"">" & Server.HTMLEncode(sMsg) & "</textarea></div>" & vbCRLF
				Response.Write LANG_FILESYSTEM_FORBIDDEN2 & vbCRLF
			End If

			Response.Write LANG_CONFIGURATION_END1 & vbCRLF
			Response.Write LANG_CONFIGURATION_END2 & vbCRLF
			Response.Write LANG_CONFIGURATION_END3 & vbCRLF
		Else
			sDBDir = GetDBPath(sDirectory)

			CreateTopTable "setup", "ASP-Nuke Setup (" & sVersion & ") - " & LANG_VERSION_NAME

			Response.Write LANG_INTRODUCTION1 & vbCRLF
			Response.Write LANG_INTRODUCTION2 & vbCRLF
			Response.Write LANG_INTRODUCTION3 & vbCRLF
			Response.Write "<script language=""Javascript"" type=""text/javascript"">" & vbCRLF
			Response.Write "	function testAndSubmit()" & vbCRLF
			Response.Write "	{" & vbCRLF
			Response.Write "			var ok = true;" & vbCRLF
			Response.Write "			var texte = '" & Replace(LANG_MISSING_FIELDS, "'", "\'") & " :';" & vbCRLF
			Response.Write "			if (document.ConfigASPNuke.SiteName.value == '')" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				ok = false;" & vbCRLF
			Response.Write "				texte = texte + '\n - " & Replace(LANG_WEBSITE_NAME, "'", "\'") & "';" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			if (document.ConfigASPNuke.SiteURL.value == '')" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				ok = false;" & vbCRLF
			Response.Write "				texte = texte + '\n - " & Replace(LANG_WEBSITE_URL, "'", "\'") & "';" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			if (document.ConfigASPNuke.uLogin.value == '')" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				ok = false;" & vbCRLF
			Response.Write "				texte = texte + '\n - " & Replace(LANG_ADMIN_LOGIN, "'", "\'") & "';" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			if (document.ConfigASPNuke.uPassword.value == '')" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				ok = false;" & vbCRLF
			Response.Write "				texte = texte + '\n - " & Replace(LANG_ADMIN_PASSWORD, "'", "\'") & "';" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			if (document.ConfigASPNuke.SiteEmail.value == '')" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				ok = false;" & vbCRLF
			Response.Write "				texte = texte + '\n - " & Replace(LANG_WEBSITE_EMAIL, "'", "\'") & "';" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			if (document.ConfigASPNuke.AccountsEmail.value == '')" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				ok = false;" & vbCRLF
			Response.Write "				texte = texte + '\n - " & Replace(LANG_WEBSITE_EMAIL2, "'", "\'") & "';" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			if (ok)" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				document.ConfigASPNuke.submit();" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "			else" & vbCRLF
			Response.Write "			{" & vbCRLF
			Response.Write "				alert(texte);" & vbCRLF
			Response.Write "			}" & vbCRLF
			Response.Write "	}" & vbCRLF
			Response.Write "</script>" & vbCRLF
			Response.Write "<table width=""100%"" class=""myTable"" cellpadding=""2"" cellspacing=""1"" border=""0"" align=""center"">" & vbCRLF
			Response.Write "<form name=""ConfigASPNuke"" method=""post"" action=""setup.asp"">" & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_PROPERTY & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_VALUE & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_WEBSITE_NAME & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""SiteName"" size=""20"" maxlength=""50"" class=""cell"" value=""""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_WEBSITE_URL & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""SiteURL"" size=""50"" maxlength=""100"" class=""cell"" value=""http://" & Request.ServerVariables("SERVER_NAME") & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_ADMIN_LOGIN & " <span class=""small"">(" & LANG_ADMIN_LOGIN_NOTE & ")</span></td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""uLogin"" maxlength=""20"" size=""20"" class=""cell""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_ADMIN_PASSWORD & " <span class=""small"">(" & LANG_ADMIN_PASSWORD_NOTE & ")</span></td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""uPassword"" maxlength=""20"" size=""20"" class=""cell""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_WEBSITE_EMAIL & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""SiteEmail"" size=""30"" maxlength=""50"" class=""cell"" value=""webmaster@" & Replace(Request.ServerVariables("SERVER_NAME"), "www.", "") & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_WEBSITE_EMAIL2 & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""AccountsEmail"" size=""30"" maxlength=""100"" class=""cell"" value=""info@" & Replace(Request.ServerVariables("SERVER_NAME"), "www.", "") & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">Copyright</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""SiteCopyright"" size=""20"" maxlength=""50"" class=""cell"" value=""&copy;""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_WEBSITE_KEYWORDS & " <span class=""small"">(" & LANG_WEBSITE_KEYWORDS_NOTE & ")</span></td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""MetaKeywords"" size=""50"" maxlength=""100"" class=""cell"" value=""""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_WEBSITE_DESCRIPTION & " <span class=""small"">(" & LANG_WEBSITE_DESCRIPTION_NOTE & ")</span></td>" & vbCRLF
			Response.Write "    <td width=""50%""><textarea name=""MetaDescription"" cols=""40"" rows=""3"" class=""cell""></textarea></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_WEBSITE_AUTHOR & " <span class=""small"">(" & LANG_WEBSITE_AUTHOR_NOTE & ")</span></td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""MetaAuthor"" size=""30"" maxlength=""100"" class=""cell"" value=""""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DATABASE_DIRECTORY & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""sDBPath"" maxlength=""50"" size=""20"" class=""cell"" value=""" & sDBDir & """></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DISPLAY_VISITORS_COUNTER & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""DynamicCount"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DISPLAY_ADVERTISING & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""Advertising"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DISPLAY_SEARCH & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""SearchEngine"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DISPLAY_NEWSLETTER_CHECKBOX & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""Newsletter"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DISPLAY_FAVORITES & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""Favorites"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DISPLAY_ACCOUNTS & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""Accounts"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DISPLAY_TOP_DIRECTORY & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""LastSites"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DISPLAY_BULLETS & " <span class=""small"">(" & LANG_DISPLAY_BULLETS_NOTE & ")</span></td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""Bullet"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DISPLAY_BACKEND & " <span class=""small"">(" & LANG_DISPLAY_BACKEND_NOTE & ")</span></td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""AutoBackEnd"" type=""checkbox""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_ENABLE_PRIVATE_AVATAR & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""AllowPrivateAvatars"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_AUTO_ACCEPT_PRIVATE_AVATAR & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""AutoAcceptPrivateAvatar"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_DISPLAY_VERSIONS & "</td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""DisplayVersions"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_AUTO_SIGNUP & " <span class=""small"">(" & LANG_AUTO_SIGNUP_NOTE & ")</span></td>" & vbCRLF
			Response.Write "    <td width=""50%""><input name=""AutoSignup"" type=""checkbox"" checked></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF		
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2"">" & LANG_TOP_IMPORTANT_NOTE & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_TOP_NEWS & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""TopNews"">" & vbCRLF
			For X = 0 To 20 
				Response.Write "<option value=""" & X & """"
				If X = 5 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_TOP_NEWS_LINKS & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""TopNewsLinks"">" & vbCRLF
			For X = 0 To 20
				Response.Write "<option value=""" & X & """"
				If X = 10 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_TOP_COMMENTS & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""TopComments"">" & vbCRLF
			For X = 0 To 20 
				Response.Write "<option value=""" & X & """"
				If X = 10 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_TOP_ARTICLES & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""TopArticles"">" & vbCRLF
			For X = 0 To 20 
				Response.Write "<option value=""" & X & """"
				If X = 5 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_TOP_DOWNLOADS & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""TopDownloads"">" & vbCRLF
			For X = 0 To 20 
				Response.Write "<option value=""" & X & """"
				If X = 10 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_TOP_POSTS & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""TopForum"">" & vbCRLF
			For X = 0 To 20 
				Response.Write "<option value=""" & X & """"
				If X = 5 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_TOP_SEARCH_RESULTS & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""TopSearch"">" & vbCRLF
			For X = 0 To 20 
				Response.Write "<option value=""" & X & """"
				If X = 10 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_TOP_POLLS & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""TopPolls"">" & vbCRLF
			For X = 0 To 5
				Response.Write "<option value=""" & X & """"
				If X = 1 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_TOP_IMAGES & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""TopImages"">" & vbCRLF
			For X = 0 To 20 
				Response.Write "<option value=""" & X & """"
				If X = 10 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_TOP_DIRECTORY & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""TopDirectory"">" & vbCRLF
			For X = 0 To 20 
				Response.Write "<option value=""" & X & """"
				If X = 10 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_COMMENTS_BY_PAGE & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""PageComments"">" & vbCRLF
			For X = 1 To 30 
				Response.Write "<option value=""" & X & """"
				If X = 10 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""50%"">" & LANG_IMAGES_BY_PAGE & "</td>" & vbCRLF
			Response.Write "    <td width=""50%"">" & vbCRLF
			Response.Write "      <select name=""PageImages"">" & vbCRLF
			For X = 1 To 30 
				Response.Write "<option value=""" & X & """"
				If X = 12 Then Response.Write " selected"
				Response.Write ">" & X & "</option>" & vbCRLF
			Next
			Response.Write "      </select>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2""><input type=""button"" class=""button"" onClick=""testAndSubmit()"" value=""" & LANG_SUBMIT & """>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			
			CreateBottomTable ""
		End If
	End If

	Response.Write "</body>" & vbCRLF
	Response.Write "</html>" & vbCRLF
%>